// GDI_Sample.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "GDI_Sample.h"
#include <commctrl.h>
#include <aygshell.h>
#include <sipapi.h>
#include "cDisplay.h"
#include "cPicture.h"
#include "cPictureBook.h"
#include "cGameObject.h"
#include "cList.h"


#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE			hInst;					// The current instance
HWND				hwndCB;					// The command bar handle

static SHACTIVATEINFO s_sai;

cDisplay g_Display;
cPictureBook g_PBNumber;
cPictureBook g_PBClock;
cPicture g_BackPic;
cGameObject g_ClockObj;
cList<cGameObject *> g_ClockNumList;
int g_h10, g_h1, g_m10, g_m1, g_s10, g_s1;


// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass	(HINSTANCE, LPTSTR);
BOOL				InitInstance	(HINSTANCE, int);
LRESULT CALLBACK	WndProc			(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About			(HWND, UINT, WPARAM, LPARAM);
HWND				CreateRpCommandBar(HWND);


void Minute10();
void Minute1();
void Second10();
void Hour1();
void Hour10();




int WINAPI WinMain(	HINSTANCE hInstance,
					HINSTANCE hPrevInstance,
					LPTSTR    lpCmdLine,
					int       nCmdShow)
{
	MSG msg;
	HACCEL hAccelTable;

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_GDI_SAMPLE);

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return msg.wParam;
}

//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    It is important to call this function so that the application 
//    will get 'well formed' small icons associated with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance, LPTSTR szWindowClass)
{
	WNDCLASS	wc;

    wc.style			= CS_HREDRAW | CS_VREDRAW;
    wc.lpfnWndProc		= (WNDPROC) WndProc;
    wc.cbClsExtra		= 0;
    wc.cbWndExtra		= 0;
    wc.hInstance		= hInstance;
    wc.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_GDI_SAMPLE));
    wc.hCursor			= 0;
    wc.hbrBackground	= (HBRUSH) GetStockObject(WHITE_BRUSH);
    wc.lpszMenuName		= 0;
    wc.lpszClassName	= szWindowClass;

	return RegisterClass(&wc);
}

//
//  FUNCTION: InitInstance(HANDLE, int)
//
//  PURPOSE: Saves instance handle and creates main window
//
//  COMMENTS:
//
//    In this function, we save the instance handle in a global variable and
//    create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
	HWND	hWnd = NULL;
	TCHAR	szTitle[MAX_LOADSTRING];			// The title bar text
	TCHAR	szWindowClass[MAX_LOADSTRING];		// The window class name

	hInst = hInstance;		// Store instance handle in our global variable
	// Initialize global strings
	LoadString(hInstance, IDC_GDI_SAMPLE, szWindowClass, MAX_LOADSTRING);
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);

	//If it is already running, then focus on the window
	hWnd = FindWindow(szWindowClass, szTitle);	
	if (hWnd) 
	{
		SetForegroundWindow ((HWND) (((DWORD)hWnd) | 0x01));    
		return 0;
	} 

	MyRegisterClass(hInstance, szWindowClass);
	
	RECT	rect;
	GetClientRect(hWnd, &rect);
	
	hWnd = CreateWindow(szWindowClass, szTitle, WS_VISIBLE,
		CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, hInstance, NULL);
	if (!hWnd)
	{	
		return FALSE;
	}
	//When the main window is created using CW_USEDEFAULT the height of the menubar (if one
	// is created is not taken into account). So we resize the window after creating it
	// if a menubar is present
	{
		RECT rc;
		GetWindowRect(hWnd, &rc);
		rc.bottom -= MENU_HEIGHT;
//		if (hwndCB)
//			MoveWindow(hWnd, rc.left, rc.top, rc.right, rc.bottom, FALSE);
	}


	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);

	return TRUE;
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//



void DrawScreen(HWND hWnd) {

	g_Display.GetBackPic()->Blt(0, 0, &g_BackPic);
	g_ClockObj.Draw(g_Display.GetBackPic());

	cList<cGameObject *> :: cCursor csr;

	cGameObject *pNumber;
	csr = g_ClockNumList.Head();
	(*csr)->SetCurFrame(g_h10);
	csr++;
	(*csr)->SetCurFrame(g_h1);
	csr++;
	(*csr)->SetCurFrame(g_m10);
	csr++;
	(*csr)->SetCurFrame(g_m1);
	csr++;
	(*csr)->SetCurFrame(g_s10);
	csr++;
	(*csr)->SetCurFrame(g_s1);

	for (csr = g_ClockNumList.Head(); csr != 0; csr ++) {
		pNumber = *csr;
		pNumber->Draw (g_Display.GetBackPic() );
	}
	
	
	
	HDC hdc = GetDC (hWnd);
	g_Display.Flip (hdc);
	ReleaseDC (hWnd, hdc);
}

void Inintialize(HWND _hWnd) {
	cPicture PicNum;
	cPicture PicClock;	
	int i;
//	RECT rc;

	g_Display.Create(_hWnd);

//	char *numsct;
//	strcpy(numsct, "\\program files\\renodigm\\rogbaduk\\number_sct.txt");
//	PicNum.Create (&g_Display, _T("\\program files\\renodigm\\rogbaduk\\number.bmp") );
	g_PBNumber.AcceptScript(&g_Display, "\\temp\\number_sct.txt");
//	g_PBNumber.Create(10);
//	for (i=0; i<10; i++) {
//		SetRect (&rc, i*25, 0, i*25+25, 0+28);
//		g_PBNumber.InsertPic (&g_Display, &PicNum, &rc);
//	}
//	PicNum.Destroy();

//	PicClock.Create (&g_Display, _T("\\program files\\renodigm\\rogbaduk\\clock.bmp") );
	g_PBClock.AcceptScript(&g_Display, "\\temp\\clock_sct.txt");
//	for (i=0; i<16; i++) {
//		SetRect (&rc, i*77+1, 1, i*77+75, 101);
//		g_PBClock.InsertPic (&g_Display, &PicClock, &rc);
//	}
//	PicClock.Destroy();

	cGameObject *pGameObj;

	for ( i=0; i<6; i++) {
		pGameObj = new cGameObject;
		pGameObj->Create (&g_PBNumber);
		pGameObj->SetPosition (i*25+20, 100);
		g_ClockNumList.AddTail (pGameObj);
	}
	
	g_ClockObj.Create(&g_PBClock);
	g_ClockObj.SetPosition (0, 0);

	g_BackPic.Create(&g_Display, _T("\\program files\\renodigm\\rogbaduk\\backpic.bmp") );

	SYSTEMTIME	st;
	GetLocalTime(&st);

	g_s1 = st.wSecond%10;
	g_s10=st.wSecond/10;
	g_m1=st.wMinute%10;
	g_m10=st.wMinute/10;
	g_h1=st.wHour%10;
	g_h10=st.wHour/10;
	
	
	SetTimer(_hWnd, 1, 1000, NULL);
	SetTimer (_hWnd, 5, 70, NULL);



}



LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	HDC hdc;
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	static bool Dir = false;
	static bool shoot = false;

	switch (message) 
	{
		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			// Parse the menu selections:
			switch (wmId)
			{	
				case IDM_HELP_ABOUT:
					DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
				    break;
				case IDOK:
					SendMessage(hWnd, WM_ACTIVATE, MAKEWPARAM(WA_INACTIVE, 0), (LPARAM)hWnd);
					SendMessage (hWnd, WM_CLOSE, 0, 0);
					break;
				default:
				   return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;
		case WM_CREATE:
			{

//				hwndCB = CreateRpCommandBar(hWnd);
				Inintialize(hWnd);
			}
			break;
		case WM_TIMER:
			switch (wParam) {
			case 5:
				g_ClockObj.AddCurFrame();
				break;

			case 1:
				g_s1++;
				if(g_s1==10)
				{ 
					g_s1=0;
					Second10();
				}
				break;					
			}

			DrawScreen(hWnd);			
			break;
//		case WM_LBUTTONDOWN:
//			PostQuitMessage(0);
//			break;

		case WM_PAINT:
//			RECT rt;
			hdc = BeginPaint(hWnd, &ps);
//			SetRect (&rc, 0, 0, 45, 16);
//			_Pic = PicBook.GetPicture(1);
//			if (_Pic != NULL ) {			
//				g_Display.GetBackPic()->Blt(10, 10, _Pic, &rc ); 
//				g_Display.Flip(hdc);
//			}
//			DrawScreen(hWnd);			

			EndPaint(hWnd, &ps);
			break; 
		case WM_DESTROY:
			{
//				CommandBar_Destroy(hwndCB);
				g_ClockObj.Destroy();
				
//				cList<cGameObject *> :: cCursor csr;
//				for (int i=0; i<6; i++) {
//					(*csr)->Destroy();
//					csr ++;
//				}
				g_PBNumber.RemoveAll();
				g_PBNumber.Destroy();
				g_PBClock.RemoveAll();
				g_PBNumber.Destroy();

				g_Display.Destroy();

				PostQuitMessage(0);
			}
			break;
		case WM_SETTINGCHANGE:
//			SHHandleWMSettingChange(hWnd, wParam, lParam, &s_sai);
     		break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}

HWND CreateRpCommandBar(HWND hwnd)
{
	SHMENUBARINFO mbi;

	memset(&mbi, 0, sizeof(SHMENUBARINFO));
	mbi.cbSize     = sizeof(SHMENUBARINFO);
	mbi.hwndParent = hwnd;
	mbi.nToolBarId = IDM_MENU;
	mbi.hInstRes   = hInst;
	mbi.nBmpId     = 0;
	mbi.cBmpImages = 0;

//	if (!SHCreateMenuBar(&mbi)) 
//		return NULL;

	return mbi.hwndMB;
}

// Mesage handler for the About box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	SHINITDLGINFO shidi;

	switch (message)
	{
		case WM_INITDIALOG:
			// Create a Done button and size it.  
			shidi.dwMask = SHIDIM_FLAGS;
			shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN;
			shidi.hDlg = hDlg;
//			SHInitDialog(&shidi);
			return TRUE; 

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK) {
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}




//////////////////// 10 Լ/////////////////////////////////////////
void Hour10()
{
	g_h10++;
}
//////////////////// 1 Լ////////////////////////////////////////
void Hour1()
{
	g_h1++;
	if(g_h10<=1)
	{
		if(g_h1==10) 
		{
			g_h1=0;
			Hour10();
		}
	}
	else
	{
		if(g_h1==4)
		{
			g_h1=0;
			g_h10=0;
		}

	}
}
///////////////// 10 Լ/////////////////////////////////////////////
void Minute10()
{
	g_m10++;
	if(g_m10==6)
	{
		g_m10=0;
		Hour1();
	}
}
//////////////// 1 Լ///////////////////////////////////////////////
void Minute1()
{
	g_m1++;
	if(g_m1==10) 
	{
		g_m1=0;
		Minute10();
	}
}
////////////// 10 Լ////////////////////////////////////////////////
void Second10()
{
	g_s10++;
	if(g_s10==6) 
	{
		g_s10=0;
		Minute1();
	}
}


