#ifndef cShape_H
#define cShape_H

class cPoint : public tagPOINT{
public:
	cPoint();
	cPoint(DWORD val);
	cPoint(int _x, int _y);

	cPoint operator-=(cPoint& a);
	cPoint operator+=(cPoint& a);

	bool operator==(cPoint& a);
	bool operator!=(cPoint& a);

	friend cPoint operator-(cPoint& a, cPoint& b);
	friend cPoint operator+(cPoint& a, cPoint& b);

	operator LPPOINT(){ return LPPOINT(this); }
};


class cRect : public tagRECT{
public:
	void Set(int _Left, int _Top, int _Right, int _Bottom);

	int Width();
	int Height();

	cPoint LeftTop();
	cPoint RightBottom();

	bool IsNormal();
	void Normalize();

	bool IsIn(int x, int y);
	bool IsIn(cPoint pt);

	void ClipRect(int _left, int _top, int _right, int _bottom);
	bool ClipRect(cRect *pRect);

	cRect& operator=(RECT& a);
	cRect& operator+=(cRect& a);
	cRect& operator-=(cRect& a);
	friend cRect operator+(cRect &a, cRect &b);
	friend cRect operator-(cRect &a, cRect &b);

	cRect& operator+=(cPoint& a);
	cRect& operator-=(cPoint& a);
	cRect operator+(cPoint& a);
	cRect operator-(cPoint& a);

	operator LPRECT();
};


#endif 
