#include "stdafx.h"
#include "Helper.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

void EncodeURL(char *pData){
	char Src[300];
	int ch;
	int nLen;

	nLen = strlen(pData);

	strcpy((char*)Src, pData);

	for(int i = 0; i < nLen; i ++){
		ch = (BYTE)Src[i];
		if(isalnum(ch)){
			*pData = ch;
			pData ++;
		}else if(ch == ' '){
			*pData = '+';
			pData ++;
		}else{
			sprintf(pData, "%%%02X ", ch);
			pData += 3;
		}
	}
	*pData = 0;
}

bool IsSameFileExtent(LPCTSTR lpszPathName, LPCTSTR lpszExt){
	int PathNameLen;
	int ExtLen;

	PathNameLen		= lstrlen(lpszPathName);
	ExtLen			= lstrlen(lpszExt);

	if(PathNameLen < ExtLen + 1)
		return false;

	// .  ִ ˻
	if(lpszPathName[PathNameLen - ExtLen - 1] != '.')
		return false;

	int i;
	for(i = 0; i <= ExtLen; i ++){
		if(toupper(lpszPathName[PathNameLen - ExtLen + i]) != 
			toupper(lpszExt[i]))
			return false;
	}

	return true;

}

bool GetPathName(LPCTSTR strFileName, TCHAR *Buff, DWORD BuffSize){
	DWORD nLen;
	int i;

	nLen = lstrlen(strFileName);
	// н .
	for(i = nLen - 1; i >= 0; i --){
		if(strFileName[i] == '\\' || strFileName[i] == '/'){
			if(BuffSize <= (DWORD)i)
				return false;
			_tcsncpy(Buff, strFileName, i);
			Buff[i] = 0;
			return true;
		}
	}
	return false;
}

bool GetFileName(LPCTSTR strFileName, TCHAR *Buff, DWORD BuffSize){
	DWORD nLen;
	DWORD FileNameLen;
	int i;

	nLen = lstrlen(strFileName);
	// ϸ .
	for(i = nLen - 1; i >= 0; i --){
		if(strFileName[i] == '\\' || strFileName[i] == '/'){
			i ++;
			break;
		}
	}
	FileNameLen = nLen - i;
	if(BuffSize <= FileNameLen)
		return false;
	_tcsncpy(Buff, strFileName + i, FileNameLen);
	Buff[FileNameLen] = 0;
	return true;

};

bool GetFileTitle2(LPCTSTR strFileName, TCHAR *Buff, DWORD BuffSize){
	DWORD nLen;
	DWORD FileNameLen;
	int i;
	int DotPos = 0;

	nLen = lstrlen(strFileName);
	// ϸ .
	for(i = nLen - 1; i >= 0; i --){
		if(strFileName[i] == '\\' || strFileName[i] == '/'){
			i ++;
			break;
		}
		if(strFileName[i] == '.')
			DotPos = i;
	}
	FileNameLen = nLen - i;
	if(BuffSize <= FileNameLen + 1)
		return false;
	_tcsncpy(Buff, strFileName + i, FileNameLen);
	if(DotPos)
		Buff[FileNameLen - (nLen - DotPos)] = 0;
	else
		Buff[FileNameLen] = 0;
	return true;
}

bool GetFileExt(LPCTSTR strFileName, TCHAR *Buff, DWORD BuffSize){
	DWORD nLen;
	DWORD ExtLen;
	int i;
	int ExtPos = 0;

	nLen = lstrlen(strFileName);
	// ϸ .
	for(i = nLen - 1; i >= 0; i --){
		if(strFileName[i] == '\\' || strFileName[i] == '/'){
			i ++;
			break;
		}
		if(strFileName[i] == '.')
			ExtPos = i + 1;
	}
	if(ExtPos){
		ExtLen = nLen - ExtPos;
		if(BuffSize <= ExtLen + 1)
			return false;
		_tcscpy(Buff, strFileName + ExtPos);
	}else{
		if(i == 0){
			_tcscpy(Buff, strFileName + 1);
		}else{
			Buff[0] = 0; // Ȯ 
		}
	}
	return true;
}


bool IsFileExist(LPCTSTR strFilePath){
	HANDLE hFile;

	hFile = CreateFile(strFilePath, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if(hFile == INVALID_HANDLE_VALUE){
		CloseHandle(hFile);
		return false;
	}
	CloseHandle(hFile);
	return true;
}

