#include "stdafx.h"

#ifndef _USE_GAPI

#include "cPicture.h"
#include "cDisplay.h"

cPicture::cPicture(){
	m_PictureType = PT_NONE;
	m_dwTransparentColor = 0;
	m_iOffsetX = 0;
	m_iOffsetY = 0;
}

cPicture::~cPicture(){
	Destroy();
}

bool cPicture::Create(cDisplay *pDisplay, cPicture *pSrcPicture, LPRECT lpSrcRect){
	//SrcPicture  簢 ڸ ׸ Ѵ.
	m_PictureType = PT_CROPPED;
	m_Rect = *lpSrcRect;
	m_pImage = pSrcPicture->m_pImage;
	m_hImage = pSrcPicture->m_hImage;

	m_dwTransparentColor = pSrcPicture->m_dwTransparentColor;
	
	return true;
}


bool cPicture::Create(cDisplay *pDisplay, DWORD dwWidth, DWORD dwHeight){
	HDC hdcScreen = GetDC(0);

	m_hImage = CreateCompatibleBitmap(hdcScreen, dwWidth, dwHeight);
	ReleaseDC(0, hdcScreen);

	m_PictureType = PT_ORIGINAL;
	::SetRect(&m_Rect, 0, 0, dwWidth, dwHeight);

	m_dwTransparentColor = 0;
	m_iOffsetX = 0;
	m_iOffsetY = 0;
	

	return true;
}


bool cPicture::Create(cDisplay *pDisplay, LPCTSTR _FileName){
	//  ο ε ׸ Ѵ.
	HANDLE hFile;
	DWORD dwReadBytes, dwFileSize;
	DWORD dwWidth, dwHeight;
	BITMAPFILEHEADER BitmapFileHeader;
	BITMAPINFO		 *pBitmapInfo;
	HBITMAP			hImageTmp;
	HBITMAP hOldDIBit, hOldDDBit;
	HDC hMemDC_DDB, hMemDC_DIB;

	// ڵ Ѵ.
	hFile = CreateFile(_FileName, GENERIC_READ, FILE_SHARE_READ, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);

	DWORD dwErr = GetLastError();

	// ڵ ߸Ǿ  ϰ false Ѵ.
	if(hFile == INVALID_HANDLE_VALUE){
		TCHAR szError[200];

		_stprintf(szError, _T("'%s' is not found."), _FileName);
		MessageBox(0, szError, _T("Error"), MB_OK);

		return false;
	}

	// Ͽ BITMAPFILEHEADER оδ.
	if(!ReadFile(hFile, &BitmapFileHeader, sizeof(BITMAPFILEHEADER), &dwReadBytes, 0)){
		ASSERT(false);
		return false;
	}

	dwFileSize = BitmapFileHeader.bfOffBits - sizeof(BITMAPFILEHEADER);
	pBitmapInfo = new BITMAPINFO[dwFileSize];
	// Ͽ BITMPAINFO оδ.
	if(!ReadFile(hFile, pBitmapInfo, dwFileSize, &dwReadBytes, 0)){
		ASSERT(false);
		return false;
	}
	dwWidth  = pBitmapInfo->bmiHeader.biWidth;
	dwHeight = pBitmapInfo->bmiHeader.biHeight;

	// о ͷ DIBSection Ѵ.
	hImageTmp = CreateDIBSection(NULL, pBitmapInfo, DIB_RGB_COLORS, &m_pImage, NULL, 0);
	
	delete[] pBitmapInfo;

	// ̹ ͸ оδ.
	if(!ReadFile(hFile, m_pImage, BitmapFileHeader.bfSize-BitmapFileHeader.bfOffBits, &dwReadBytes, NULL)){
		ASSERT(false);
		return false;
	}

	// DIBSection DDB ϰ ڵ .
	HDC hdc = GetDC(NULL);
	m_hImage = CreateCompatibleBitmap(hdc, dwWidth, dwHeight);
	hMemDC_DDB = CreateCompatibleDC(hdc);
	hMemDC_DIB = CreateCompatibleDC(hdc);
	hOldDDBit =(HBITMAP)SelectObject(hMemDC_DDB, m_hImage);
	hOldDIBit =(HBITMAP)SelectObject(hMemDC_DIB, hImageTmp);

	BitBlt(hMemDC_DDB, 0, 0, dwWidth, dwHeight, hMemDC_DIB, 0, 0, SRCCOPY);
	SelectObject(hMemDC_DDB, hOldDDBit);
	SelectObject(hMemDC_DIB, hOldDIBit);
	
	DeleteDC(hMemDC_DDB);
	DeleteDC(hMemDC_DIB);

	DeleteObject(hImageTmp);

	ReleaseDC(NULL, hdc);

	CloseHandle(hFile);

	m_PictureType = PT_ORIGINAL;
	SetRect(&m_Rect, 0, 0, dwWidth, dwHeight);

	m_dwTransparentColor = 0;
	m_iOffsetX = 0;
	m_iOffsetY = 0;

	return true;


}

bool cPicture::Create(cDisplay *pDisplay, HINSTANCE hInstance, UINT ResourceID){
	// Create Picture from Resource ID
	HBITMAP hBitmapResource;
	BITMAP Bitmap;
	HGDIOBJ hOldDIBit, hOldDDBit;
	HDC hMemDC_DDB, hMemDC_DIB;

	// Ʈ ҽ εϰ ̿  ڵ .
	hBitmapResource = ::LoadBitmap(hInstance, MAKEINTRESOURCE(ResourceID));
	if(!hBitmapResource)
		return false;

	// Ʈ ҽ Ʈʿ    ´.
	memset(&Bitmap, 0, sizeof(Bitmap));
	if(!GetObject(hBitmapResource, sizeof(BITMAP), &Bitmap))
		return false;

	// Ʈ ġ  Ʈ ȯѴ.
	if(!Create(pDisplay, Bitmap.bmWidth, Bitmap.bmHeight))
		return false;

	hMemDC_DIB = CreateCompatibleDC(NULL);
	hMemDC_DDB = CreateCompatibleDC(NULL);

	hOldDIBit = SelectObject(hMemDC_DIB, hBitmapResource);
	hOldDDBit = SelectObject(hMemDC_DDB, m_hImage);

	BitBlt(hMemDC_DDB, 0, 0, Bitmap.bmWidth, Bitmap.bmHeight, hMemDC_DIB, 0, 0, SRCCOPY);

	SelectObject(hMemDC_DIB, hOldDIBit);
	SelectObject(hMemDC_DDB, hOldDDBit);

	DeleteDC(hMemDC_DDB);
	DeleteDC(hMemDC_DIB);

	// ޸𸮿 ε Ʈ Ѵ.
	DeleteObject(hBitmapResource);

	m_PictureType = PT_ORIGINAL;
	SetRect(&m_Rect, 0, 0, Bitmap.bmWidth, Bitmap.bmHeight);

	m_dwTransparentColor = 0;
	m_iOffsetX = 0;
	m_iOffsetY = 0;

	return true;


}


void cPicture::Destroy(){
	if(m_PictureType == PT_ORIGINAL){
		if(m_pImage){
			DeleteObject(m_hImage);
			m_pImage = 0;
		}
	}
	m_PictureType = PT_NONE;
	
}


void cPicture::Blt(int x, int y, cPicture *pSrc, LPRECT lpSrcRect, bool bSrcColorKey, bool bOffset){
	HDC hMemDC_Dst, hMemDC_Src;
	HBITMAP hOldBit_Dst, hOldBit_Src;

	cRect rcSrc;
	cRect rcDest;
	cRect OldDestRect;
	int OldX, OldY;

	if(lpSrcRect){
		rcSrc = *lpSrcRect;
		rcSrc += pSrc->m_Rect.LeftTop();
		// ҽ Ŭ
		OldX = rcSrc.left;
		OldY = rcSrc.top;
		if(!pSrc->m_Rect.ClipRect(&rcSrc))
			return;

		x += rcSrc.left - OldX;
		y += rcSrc.top - OldY;

	}else{
		rcSrc = pSrc->m_Rect;
	}
	
	// Dest  Ŭ
	int iOffsetX, iOffsetY;
	pSrc->GetOffsetPos( &iOffsetX, &iOffsetY);
	rcDest.Set(x, y, x + rcSrc.Width(), y + rcSrc.Height());
	if(bOffset || iOffsetX != 0 || iOffsetY != 0){
		rcDest.left -= iOffsetX;
		rcDest.top -= iOffsetY;
		rcDest.right -= iOffsetX;
		rcDest.bottom -= iOffsetY;
	}

	OldDestRect = rcDest;
	if(!m_Rect.ClipRect(&rcDest))
		return;
	rcSrc += rcDest - OldDestRect;
	if(!rcSrc.IsNormal())
		return;

//	::SetRect(&rcDest, x, y, x + rcSrc.right - rcSrc.left, y + rcSrc.bottom - rcSrc.top);

	HDC hdc = GetDC(NULL);
	hMemDC_Dst = ::CreateCompatibleDC(hdc);
	hMemDC_Src = ::CreateCompatibleDC(hdc);

	hOldBit_Dst =(HBITMAP)::SelectObject(hMemDC_Dst, m_hImage);
	hOldBit_Src =(HBITMAP)::SelectObject(hMemDC_Src, pSrc->m_hImage);

	if(bSrcColorKey || pSrc->GetTransparnetColor() != 0)
		TransparentImage(hMemDC_Dst, rcDest.left, rcDest.top, rcDest.right-rcDest.left, rcDest.bottom-rcDest.top, hMemDC_Src, rcSrc.left, rcSrc.top, rcSrc.right, rcSrc.bottom, pSrc->GetTransparnetColor() );	
	else
		BitBlt(hMemDC_Dst, rcDest.left, rcDest.top, rcDest.right - rcDest.left, rcDest.bottom - rcDest.top, hMemDC_Src, rcSrc.left, rcSrc.top, SRCCOPY);

	::SelectObject(hMemDC_Dst, hOldBit_Dst);
	::SelectObject(hMemDC_Src, hOldBit_Src);
	DeleteDC(hMemDC_Dst);
	DeleteDC(hMemDC_Src);

	ReleaseDC(NULL, hdc);

}


void cPicture::BltText(cPicture *FontPic, LPCTSTR strText, int x, int y, bool bUseSrcColorKey){
	int nTextLen;
	int i;
	TCHAR Char;
	RECT SrcRect;
	int idx;

	nTextLen = lstrlen(strText);

	for(i = 0; i < nTextLen; i ++){
		Char = towupper(strText[i]);
		if(Char >= 32 && Char <= 127){
			idx = Char - 32;
			SetRect(&SrcRect, idx * 8, 0, idx * 8 + 8, 16);
			Blt(x + i * 10, y, FontPic, &SrcRect, bUseSrcColorKey);
		}
	}

}

void cPicture::BltText(LPCTSTR strText, int x, int y, HFONT font, COLORREF FontColor, COLORREF BGColor){
	HDC hScrDC;
	HDC hMemDC;
	HGDIOBJ hOldBitmap;
	HGDIOBJ hOldFont;
	RECT rt;
	
	hScrDC = GetDC(0);
	hMemDC = CreateCompatibleDC(hScrDC);
	ReleaseDC(0, hScrDC);

	hOldBitmap =(HBITMAP)SelectObject(hMemDC, m_hImage);

	if(font)
		hOldFont = SelectObject(hMemDC, font);

	if(FontColor != 0xFFFFFFFF)
		SetTextColor(hMemDC, FontColor);

	if(BGColor == 0xFFFFFFFF)
		SetBkMode(hMemDC, TRANSPARENT);
	else
		SetBkColor(hMemDC, BGColor);


	::SetRect(&rt,x, y, x+240, y+50);
	DrawText(hMemDC, strText, -1, &rt, DT_LEFT | DT_TOP);

	if(font)
		SelectObject(hMemDC, hOldFont);

	SelectObject(hMemDC, hOldBitmap);

	DeleteDC(hMemDC);

}

int cPicture::GetWidth(){
	return m_Rect.right - m_Rect.left; 
}

int cPicture::GetHeight(){ 
	return m_Rect.bottom - m_Rect.top; 
}

cRect cPicture::GetRect(){
	return m_Rect;
}

DWORD cPicture::GetTransparnetColor(){
	return m_dwTransparentColor; 
}

void cPicture::SetTransparentColor(DWORD Color) { 
	m_dwTransparentColor = Color; 
}


void cPicture::SetOffsetPos(int x, int y){
	m_iOffsetX = x;
	m_iOffsetY = y;
}

void cPicture::GetOffsetPos(int *x, int *y){
	*x = m_iOffsetX;
	*y = m_iOffsetY;
}

#endif