#include "stdafx.h"
#include "cPictureBook.h"
#include "cDisplay.h"

cPictureBook::cPictureBook() {
	m_pIndices = NULL;
	m_TotalPicNum = 0;
	m_pOriginPic = NULL;
}

cPictureBook::~cPictureBook() {
	if (!m_TotalPicNum) {
		RemoveAll();
	}
}

void cPictureBook::Create(int Size) {
	if (Size) {
		m_pIndices = new cPicture*[Size];
	}
	m_TotalPicNum = 0;
	m_pOriginPic = NULL;
}

void cPictureBook::Destroy() {
	if (!m_TotalPicNum) {
		RemoveAll();
	}
}

void cPictureBook::CreateOriginPic(cDisplay *pDisplay, LPCTSTR FileName){
	cPicture * Pic = new cPicture;
	Pic->Create (pDisplay, FileName);
	m_pOriginPic = Pic;
}




void cPictureBook::CropPic (cDisplay *pDisplay, LPRECT lpSrcRect) {
	if (m_pOriginPic == NULL)
		return;

	cPicture * Pic = new cPicture;
	Pic->Create (pDisplay, m_pOriginPic, lpSrcRect);
	m_pIndices[m_TotalPicNum] = Pic;
	m_TotalPicNum++;
}

void cPictureBook::InsertPic (cDisplay *pDisplay, LPCTSTR FileName) {

	cPicture *Pic = new cPicture;
	Pic->Create (pDisplay, FileName);
	m_pIndices[m_TotalPicNum] = Pic;
	m_TotalPicNum++;

}


cPicture* cPictureBook::GetPicture (int no) {
	if (m_TotalPicNum > no)
		return m_pIndices[no];
	else
		return m_pIndices[0];
}

/*
void cPictureBook::RemovePic(int no) {
	cList<cPicture *>::cCursor	csr;
	int index = 0;
	for(csr = PictureList.Head(); csr != 0; index++){
		if (index == no) { 
			(*csr)->Destroy();
			delete (*csr);
			PictureList.Remove(*csr);
			return;
		}
		csr++;
	}
	UpdatePicBook();
}
*/


void cPictureBook::RemoveAll() {

	for (int i=0; i<m_TotalPicNum; i++) {
		m_pIndices[i]->Destroy();
		delete m_pIndices[i];
	}
	delete[] m_pIndices; 
	m_pIndices = NULL;

	if (m_pOriginPic) {
		m_pOriginPic->Destroy();
		delete m_pOriginPic;
	}

	m_TotalPicNum = 0;
}
/*
void cPictureBook::UpdatePicBook() {
	// ٽ ε ּҿ ׸ Ѱ Ѵ.
//	cList<cPicture *>::cCursor	csr;
//	int count = 0;
//	for(csr = PictureList.Head(); csr != 0; count++){
//		m_pIndices[count] = *csr;
//		csr++;
//	}
//	m_TotalPicNum = count;
}
*/
int cPictureBook::GetTotalPicNum() {
	return m_TotalPicNum;
}

bool cPictureBook::AcceptScript(cDisplay *pDisplay, const char* FileName){
	char Buff[256], Lexeme[256];
	wchar_t WLexeme[256]={0,};
	int a, b, c, d;
	FILE *pFile;

	pFile = fopen(FileName, "rt");
	if(!pFile) return false;

	RECT		Rect;

	while(true){
		if(!fgets(Buff, 256, pFile)) break;

		if(strncmp(Buff, "Create", 6) == 0){
			if(sscanf(Buff + 6, "%*[(] %d %*[)] %*[;]", &a) == 1){
				Create(a);
			}
		}else if(strncmp(Buff, "LoadPicture", 11) == 0){
			if(sscanf(Buff + 11, "( %s );", Lexeme) == 1){ 
				mbstowcs(WLexeme, Lexeme, strlen(Lexeme));
				CreateOriginPic(pDisplay, WLexeme);
			}
		}else if(strncmp(Buff, "CropPicture", 11) == 0){
			if(sscanf(Buff + 11, "%*[(] %d %*[,] %d %*[,] %d %*[,] %d %*[)] %*[;]", &a, &b, &c, &d) == 4){
				SetRect(&Rect, a, b, c, d);
				CropPic(pDisplay, &Rect);
			}
		}
	}

	fclose(pFile);
	return true;

}
