#include "stdafx.h"
#include "cPicture.h"
#include "cDisplay.h"

#ifdef _USE_GAPI

cPicture::cPicture(){
	m_PictureType = PT_NONE;
	m_dwTransparentColor = 0;
	m_iOffsetX = 0;
	m_iOffsetY = 0;
}

cPicture::~cPicture(){
	Destroy();
}

bool cPicture::Create(cDisplay *pDisplay, cPicture *pSrcPicture, LPRECT lpSrcRect){
	//SrcPicture  簢 ڸ ׸ Ѵ.
	m_PictureType = PT_CROPPED;
	m_Rect = *lpSrcRect;
	m_pImage = pSrcPicture->m_pImage;
	m_hImage = pSrcPicture->m_hImage;

	this->m_xPitch = pSrcPicture->m_xPitch;
	this->m_yPitch = pSrcPicture->m_yPitch;

	m_dwTransparentColor = pSrcPicture->m_dwTransparentColor;

	return true;
}

bool cPicture::Create(cDisplay *pDisplay, DWORD dwWidth, DWORD dwHeight){
	//	־ ũ ġ  ׸ ޸𸮿 Ѵ.

	m_xPitch = 2;
	m_yPitch = dwWidth * m_xPitch;

	// Ʈ   GDI 踦  DIB Section Ʈ .
	BITMAPINFO *pBitmapInfo;
	RGBQUAD *pPal;

	pBitmapInfo = (BITMAPINFO*)new char[sizeof(BITMAPINFOHEADER) + sizeof(RGBQUAD) * 256];
	pPal = (RGBQUAD*)&pBitmapInfo->bmiColors;
	memset(pBitmapInfo, 0, sizeof(BITMAPINFO));

	pBitmapInfo->bmiHeader.biSize			= sizeof(BITMAPINFOHEADER);
	pBitmapInfo->bmiHeader.biWidth			= dwWidth;
	pBitmapInfo->bmiHeader.biHeight			= -(int)dwHeight; // Ʈ ⺻ ǥ y  ϹǷ ȭ ǥ ϰ ϱ  -̸ Ѵ.
	pBitmapInfo->bmiHeader.biPlanes			= 1; 
	pBitmapInfo->bmiHeader.biBitCount		= 16; 
	pBitmapInfo->bmiHeader.biCompression	= BI_BITFIELDS; //     (,,) Ʈ迭 ̷ .
	*((DWORD*)&pPal[0]) = 0xF800;
	*((DWORD*)&pPal[1]) = 0x07E0;
	*((DWORD*)&pPal[2]) = 0x001F;

	m_pImage = 0;
	//  DIBSection  .
	m_hImage = CreateDIBSection(0, pBitmapInfo, DIB_RGB_COLORS, &m_pImage, NULL, 0);

	delete [] pBitmapInfo;

	if(m_hImage == 0)
		return false;

	m_PictureType = PT_ORIGINAL;
	::SetRect(&m_Rect, 0, 0, dwWidth, dwHeight);

	return true;
}


bool cPicture::Create(cDisplay *pDisplay, LPCTSTR _FileName){
	HANDLE hFile;
	DWORD dwReadBytes;
	BITMAPFILEHEADER BitmapFileHeader;
	BITMAPINFOHEADER BitmapInfoHeader;
	BYTE *pRGBBuff;
	DWORD dwPixelSize, dwLineSize;
	int x, y;
	DWORD r, g, b;
	BYTE * pPixel;
	BYTE *pMemory;

	hFile = CreateFile(_FileName, GENERIC_READ, FILE_SHARE_READ, 0, 
		OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);

	DWORD dwErr = GetLastError();

	if(hFile == INVALID_HANDLE_VALUE){
		TCHAR szError[200];

		_stprintf(szError, _T("'%s' is not found."), _FileName);
		MessageBox(0, szError, _T("Error"), MB_OK);

		return false;
	}

	if(!ReadFile(hFile, &BitmapFileHeader, sizeof(BitmapFileHeader), &dwReadBytes, 0)){
		ASSERT(false);
		return false;
	}

	if(!ReadFile(hFile, &BitmapInfoHeader, sizeof(BitmapInfoHeader), &dwReadBytes, 0)){
		ASSERT(false);
		return false;
	}

	if(!Create(pDisplay, BitmapInfoHeader.biWidth, BitmapInfoHeader.biHeight)){
		CloseHandle(hFile);

		return false;
	}

	dwPixelSize = BitmapInfoHeader.biBitCount / 8;

	dwLineSize = ((dwPixelSize * BitmapInfoHeader.biWidth) + 3) / 4 * 4;
	pRGBBuff = new BYTE [dwLineSize];

	pMemory = (unsigned char*)m_pImage;

	//  ȼ ȯ ۾ Ѵ.
	for(y = 0; y < BitmapInfoHeader.biHeight; y ++){
		if(!ReadFile(hFile, pRGBBuff, dwLineSize, &dwReadBytes, 0)){
			delete [] pRGBBuff;
			Destroy();
			CloseHandle(hFile);
			return false;
		}

		if(dwReadBytes <= 0){
			delete [] pRGBBuff;
			Destroy();
			CloseHandle(hFile);
			return false;
		}

		// RGB  16 Ʈ ÷ ȯѴ.
		pPixel = (BYTE*)pMemory + (BitmapInfoHeader.biHeight - y - 1) * BitmapInfoHeader.biWidth * 2;
		for(x = 0; x < BitmapInfoHeader.biWidth; x ++){
			b = pRGBBuff[dwPixelSize * x] * 32 / 256;
			g = pRGBBuff[dwPixelSize * x + 1] * 64 / 256;
			r = pRGBBuff[dwPixelSize * x + 2] * 32 / 256;

			*(WORD*)pPixel = (WORD)((r << 11) | (g << 5) | (b));

			pPixel += 2;
		}

	}

	delete [] pRGBBuff;
	

	CloseHandle(hFile);

	m_PictureType = PT_ORIGINAL;
	SetRect(&m_Rect, 0, 0, BitmapInfoHeader.biWidth, BitmapInfoHeader.biHeight);

	return true;


}


bool cPicture::Create(cDisplay *pDisplay, HINSTANCE hInstance, UINT ResourceID){
	// Create Picture from Resource ID
	HBITMAP hBitmapResource;
	BITMAP Bitmap;
	HGDIOBJ hOldDIBit, hOldDDBit;
	HDC hMemDC_DDB, hMemDC_DIB;

	// Ʈ ҽ εϰ ̿  ڵ .
	hBitmapResource = ::LoadBitmap(hInstance, MAKEINTRESOURCE(ResourceID));
	if(!hBitmapResource)
		return false;

	// Ʈ ҽ Ʈʿ    ´.
	memset(&Bitmap, 0, sizeof(Bitmap));
	if(!GetObject(hBitmapResource, sizeof(BITMAP), &Bitmap))
		return false;

	// Ʈ ġ  Ʈ ȯѴ.
	HDC hdcScreen;
	
	if(!Create(pDisplay, Bitmap.bmWidth, Bitmap.bmHeight))
		return false;

	hdcScreen = GetDC(NULL);
	hMemDC_DIB = CreateCompatibleDC(hdcScreen);
	hMemDC_DDB = CreateCompatibleDC(hdcScreen);
	ReleaseDC(NULL, hdcScreen);

	hOldDIBit = SelectObject(hMemDC_DIB, hBitmapResource);
	hOldDDBit = SelectObject(hMemDC_DDB, m_hImage);

	BitBlt(hMemDC_DDB, 0, 0, Bitmap.bmWidth, Bitmap.bmHeight,
		hMemDC_DIB, 0, 0, SRCCOPY);

	SelectObject(hMemDC_DIB, hOldDIBit);
	SelectObject(hMemDC_DDB, hOldDDBit);

	DeleteDC(hMemDC_DDB);
	DeleteDC(hMemDC_DIB);

	// ޸𸮿 ε Ʈ Ѵ.
	DeleteObject(hBitmapResource);

	m_PictureType = PT_ORIGINAL;
	SetRect(&m_Rect, 0, 0, Bitmap.bmWidth, Bitmap.bmHeight);

	m_dwTransparentColor = 0;
	m_iOffsetX = 0;
	m_iOffsetY = 0;

	return true;


}

void cPicture::Blt(int x, int y, cPicture *pSrc, LPRECT lpSrcRect, bool bUseSrcColorKey, bool bOffset){
	cRect rcSrc;
	cRect rcDest;
	cRect OldDestRect;
	int OldX, OldY;

	if(lpSrcRect){
		rcSrc = *lpSrcRect;
		rcSrc += pSrc->m_Rect.LeftTop();
		// ҽ Ŭ
		OldX = rcSrc.left;
		OldY = rcSrc.top;
		if(!pSrc->m_Rect.ClipRect(&rcSrc))
			return;

		x += rcSrc.left - OldX;
		y += rcSrc.top - OldY;

	}else{
		rcSrc = pSrc->m_Rect;
	}
	
	// Dest  Ŭ
	rcDest.Set(x, y, x + rcSrc.Width(), y + rcSrc.Height());

	if(bOffset || pSrc->m_iOffsetX || pSrc->m_iOffsetY){
		rcDest.left -= pSrc->m_iOffsetX;
		rcDest.top -= pSrc->m_iOffsetY;
		rcDest.right -= pSrc->m_iOffsetX;
		rcDest.bottom -= pSrc->m_iOffsetY;
	}


	OldDestRect = rcDest;
	if(!m_Rect.ClipRect(&rcDest))
		return;
	rcSrc += rcDest - OldDestRect;
	if(!rcSrc.IsNormal())
		return;

	WORD* pDestMem, * pSrcMem;

	if(!m_pImage)
		return;

	pDestMem = (WORD*)m_pImage + rcDest.top * m_yPitch / 2 + rcDest.left;
	pSrcMem = (WORD*)pSrc->m_pImage;
	if(!pSrcMem)
		return;

	pSrcMem += rcSrc.top * pSrc->m_yPitch / 2 + rcSrc.left;
	if(bUseSrcColorKey || pSrc->GetTransparnetColor() != 0)
		Blt(pDestMem, m_yPitch / 2, pSrcMem, pSrc->m_yPitch / 2, rcDest.right - rcDest.left, rcDest.bottom - rcDest.top, pSrc->GetTransparnetColor());
	else
		Blt(pDestMem, m_yPitch / 2, pSrcMem, pSrc->m_yPitch / 2, rcDest.right - rcDest.left, rcDest.bottom - rcDest.top);
	

}

void cPicture::Blt(WORD* pDestMem, int DestPitch, WORD* pSrcMem, int SrcPitch, int Width, int Height){
	register y, x;

	for(y = Height; y; y --){
		for(x = Width; x; x --){
			*pDestMem = *pSrcMem;
			pDestMem ++;
			pSrcMem ++;
		}
		pDestMem += DestPitch - Width;
		pSrcMem += SrcPitch - Width;
	}

}

void cPicture::Blt(WORD* pDestMem, int DestPitch, WORD* pSrcMem, int SrcPitch, int Width, int Height, DWORD dwSrcColorKey){
	
	register y, x;
	register unsigned s;

	DWORD dwColorKey;

	//24bit bitmap ؼ colorkey  
	{

	#ifdef _X86_
		DWORD dwPixelFormat = 555; //kfDirect555;//  ̰  ȵǰ DDB   ϴµ..
	
	#else
		DWORD dwPixelFormat = 565; //kfDirect565;//  ̰  ȵǰ DDB   ϴµ..
	
	#endif


		
		BYTE* pSrcColorKey = (BYTE*)&dwSrcColorKey;
		BYTE r, g, b;
		r = g = b = 0;

		r = *pSrcColorKey;
		g = *(pSrcColorKey + 1);
		b = *(pSrcColorKey + 2);


		if(dwPixelFormat == 555){
			r = r * 32/256;
			g = g * 32/256;
			b = b * 32/256;
			dwColorKey =  (DWORD)((r << 10) | (g << 5) | (b));
			
		}else if(dwPixelFormat == 565){
			r = r * 32/256;
			g = g * 64/256;
			b = b * 32/256;
			dwColorKey = (DWORD)((r << 11) | (g << 5) | (b));
			
		}
	}




	for(y = Height; y; y --){
		for(x = Width; x; x --){
			s = *pSrcMem;
			if(s != dwColorKey)
				*pDestMem = s;
			pDestMem ++;
			pSrcMem ++;
		}
		pDestMem += DestPitch - Width;
		pSrcMem += SrcPitch - Width;
	}




}



void cPicture::Destroy(){
	if(m_PictureType == PT_ORIGINAL){
		if(m_pImage){
			DeleteObject(m_hImage);
			m_pImage = 0;
		}
	}
	m_PictureType = PT_NONE;
	
}

void cPicture::BltText(cPicture *FontPic, LPCTSTR strText, int x, int y, bool bUseSrcColorKey){
	int nTextLen;
	int i;
	TCHAR Char;
	RECT SrcRect;
	int idx;

	nTextLen = lstrlen(strText);

	for(i = 0; i < nTextLen; i ++){
		Char = towupper(strText[i]);
		if(Char >= 32 && Char <= 127){
			idx = Char - 32;
			SetRect(&SrcRect, idx * 8, 0, idx * 8 + 8, 16);
			Blt(x + i * 10, y, FontPic, &SrcRect, bUseSrcColorKey);
		}
	}

}


void cPicture::BltText(LPCTSTR strText, int x, int y, HFONT font, COLORREF FontColor, COLORREF BGColor){
	HDC hScrDC;
	HDC hMemDC;
	HGDIOBJ hOldBitmap;
	HGDIOBJ hOldFont;
	RECT rt;
	
	hScrDC = GetDC(0);
	hMemDC = CreateCompatibleDC (hScrDC);
	ReleaseDC (0, hScrDC);

	hOldBitmap = (HBITMAP)SelectObject (hMemDC, m_hImage);

	if(font)
		hOldFont = SelectObject(hMemDC, font);

	if(FontColor != 0xFFFFFFFF)
		SetTextColor(hMemDC, FontColor);

	if(BGColor == 0xFFFFFFFF)
		SetBkMode(hMemDC, TRANSPARENT);
	else
		SetBkColor(hMemDC, BGColor);


	::SetRect(&rt,x, y, x+240, y+50);
	DrawText(hMemDC, strText, -1, &rt, DT_LEFT | DT_TOP);

	if(font)
		SelectObject (hMemDC, hOldFont);

	SelectObject (hMemDC, hOldBitmap);

	DeleteDC(hMemDC);

}

int cPicture::GetWidth(){
	return m_Rect.right - m_Rect.left; 
}

int cPicture::GetHeight(){ 
	return m_Rect.bottom - m_Rect.top; 
}

cRect cPicture::GetRect(){
	return m_Rect;
}

DWORD cPicture::GetTransparnetColor(){
	return m_dwTransparentColor; 
}

void cPicture::SetTransparentColor(DWORD Color) { 
#ifdef _X86_
	DWORD dwPixelFormat = 555;

#else
	DWORD dwPixelFormat = 565;

#endif
	DWORD r, g, b;

	r = (Color & 0x0f00) >> 16;
	g = (Color & 0x00f0) >> 8;
	b = (Color & 0x000f);
	
	if(dwPixelFormat == 555){
		m_dwTransparentColor = (r >> 3) << 10 | (g >> 3) << 5 | b >> 3;
	}else{
		m_dwTransparentColor = (r >> 3) << 11 | (g >> 2) << 5 | b >> 3;
	}
}


void cPicture::SetOffsetPos(int x, int y){
	m_iOffsetX = x;
	m_iOffsetY = y;
}

void cPicture::GetOffsetPos(int *x, int *y){
	*x = m_iOffsetX;
	*y = m_iOffsetY;
}


#endif