#include "StdAfx.h"
#include "cRPC.h"
//#include <errno.h>

//extern int errno;
#define SOCKET_ERROR (-1)
// cRPCPacket //////////////////////////////////////////////////////////////////////////////////////////////////////////////
cRPCPacket::cRPCPacket(int PacketSize){
	pData		= new char [PacketSize];
	DataSize	= PacketSize;
	ReadMode	= true;
	Cursor		= 4;
}

cRPCPacket::~cRPCPacket(){
	delete pData;
}

BYTE cRPCPacket::GetObjectID(){
	return (BYTE)pData[2];
}

BYTE cRPCPacket::GetMethodID(){
	return (BYTE)pData[3];
}

WORD cRPCPacket::GetSize(){
	return ((WORD*)pData)[0];

}

void cRPCPacket::SetHeader(BYTE ObjectID, BYTE MethodID){
	pData[2]	= (char)ObjectID;
	pData[3]	= (char)MethodID;
	Cursor		= 4;	//  ũⰡ 4̹Ƿ
	((WORD*)pData)[0] = (WORD)Cursor;
	ReadMode	= false;
}

void cRPCPacket::SetReadMode(){
	ReadMode	= true;
	Cursor		= 4;
}

void cRPCPacket::SetWriteMode(){
	ReadMode	= false;
	Cursor		= 4;
}

bool cRPCPacket::ExSizeParam(void *pParamData){
	// ũⰡ  ִ Param ȯ
	WORD Size;

	if(!ExParam(&Size, sizeof(WORD)))
		return false;
	return ExParam(pParamData, Size);
}

bool cRPCPacket::ExString(char *pParam){
	WORD Size;

	if(!ReadMode)
		Size = strlen(pParam);
	if(!ExParam(&Size, sizeof(WORD)))
		return false;
	if(!ExParam(pParam, Size))
		return false;

	if(ReadMode)
		pParam[Size] = 0;

	return true;
}


#ifdef _UNICODE

bool cRPCPacket::ExString(unsigned short *pParam){
	char Buff[256];
	if(ReadMode){
		ExString(Buff);
		mbstowcs(pParam, Buff, strlen(Buff) + 1);
	}else{
		wcstombs(Buff, pParam, wcslen(pParam) + 1);
		ExString(Buff);
		
	}

	return true;
}

bool cRPCPacket::ExString(const unsigned short *pParam){
	return ExString((unsigned short*)pParam);
}
#endif

bool cRPCPacket::ExString(const char *pParam){
	WORD Size;

	ASSERT(!ReadMode);

	Size = strlen(pParam);
	if(!ExParam(&Size, sizeof(WORD)))
		return false;
	if(!ExParam((char *)pParam, Size))
		return false;

	return true;
}


/*
bool cRPCPacket::ExAuto(const char *pParam){
	return ExAuto((char *)pParam);
}
*/
bool cRPCPacket::ExParam(void *pParamData, WORD ParamSize){
	if(Cursor + ParamSize > DataSize){
		ASSERT(!"cRPCPacket::ExParam() buffer overflow.");
		return false;
	}

	if(ReadMode)
		memcpy(pParamData, pData + Cursor, (size_t)ParamSize);
	else
		memcpy(pData + Cursor, pParamData, (size_t)ParamSize);

	Cursor += (int)ParamSize;

	if(!ReadMode)
		((WORD*)pData)[0] = (WORD)Cursor;


	return true;

}

// cRPC //////////////////////////////////////////////////////////////////////////////////////////////////////////////

cRPC::cRPC(){
	Socket = INVALID_SOCKET;
}

cRPC::~cRPC(){
	if(Socket != INVALID_SOCKET){
		shutdown(Socket, 0);
		closesocket(Socket);
	}
	
}

bool cRPC::CreateFromSocket(SOCKET _Socket){
	Socket		= _Socket;
	ServerMode	= false;	
	RecvCount	= 0;
	return true;
}

bool cRPC::CreateServer(const char *IPAddr, int IPPort, int BackLogCount){
	sockaddr_in serv_addr;
	int reuse = 1;

	ZeroMemory(&serv_addr, sizeof(serv_addr));

	serv_addr.sin_family      = AF_INET;
	if(IPAddr)
		serv_addr.sin_addr.s_addr = inet_addr(IPAddr);
	else
		serv_addr.sin_addr.s_addr = INADDR_ANY;

	serv_addr.sin_port        = htons(IPPort);

	Socket = socket(AF_INET, SOCK_STREAM, 0);
	if(Socket == INVALID_SOCKET)
		return false;

	// set socket option to non-blocking mode
	u_long argp = 1;
#ifdef _LINUX
	ioctl(Socket, FIONBIO, &argp);
#else
	ioctlsocket (Socket, FIONBIO, &argp);
#endif

	setsockopt(Socket, SOL_SOCKET, SO_REUSEADDR, (char *)&reuse, sizeof(reuse));
	if (bind(Socket,(struct sockaddr *)&serv_addr,sizeof(serv_addr)) == SOCKET_ERROR){
		printf("bind error\n");


#ifdef _LINUX		

		closesocket(Socket);
		Socket = INVALID_SOCKET;
		return false;
#endif

	}
	if(listen(Socket, BackLogCount) == SOCKET_ERROR){
		closesocket(Socket);
		Socket = INVALID_SOCKET;                  
		return false;
	}

	ServerMode = true;
	RecvCount	= 0;
	return true;

}

bool cRPC::CreateClient(const char *DestIPAddr, int DestIPPort){
	// ش  ϴ Ŭ̾Ʈ   
	//   
	sockaddr_in serv_addr;

	memset(&serv_addr, 0, sizeof(serv_addr));

	// ip ּҰ url  Ip ּ  ˾Ƴ.
	int DestIPAddrLen;
	int i;
	bool IsUrl = false;

	DestIPAddrLen = strlen(DestIPAddr);

	for(i = 0; i < DestIPAddrLen; i ++){
		if(isalpha(DestIPAddr[i])){
			IsUrl = true;
			break;
		}
	}

	if(IsUrl){
		hostent *pHostent;
		pHostent = gethostbyname(DestIPAddr);
		
		serv_addr.sin_family      = AF_INET;
		serv_addr.sin_addr.s_addr = *((int*)pHostent->h_addr_list[0]);
		serv_addr.sin_port        = htons(DestIPPort);
	}else{
		serv_addr.sin_family      = AF_INET;
		serv_addr.sin_addr.s_addr = inet_addr(DestIPAddr);
		serv_addr.sin_port        = htons(DestIPPort);
	}


	Socket = socket(AF_INET,SOCK_STREAM,0);
	if (Socket == INVALID_SOCKET){
		return false;
	}

#ifndef _LINUX
	BOOL Nodelay = TRUE;
	setsockopt(Socket, IPPROTO_TCP, TCP_NODELAY, (char*)&Nodelay, sizeof(BOOL));
#endif

	int rv;
	if ((rv = connect(Socket,(struct sockaddr *)&serv_addr,sizeof(serv_addr))) != 0){
 		
		closesocket(Socket);
		Socket = INVALID_SOCKET;
		return false;
	}

	//ϴ ŷ  connect    ͺŷ ȯ ؼ 
	//send,recv ÿ ŷ Ǵ  Ѵ.

	// set socket option to non-blocking mode
	u_long argp = 1;
#ifdef _LINUX
	ioctl(Socket, FIONBIO, &argp);
#else
	ioctlsocket (Socket, FIONBIO, &argp);
#endif	
	ServerMode = false;

	RecvCount = 0; 
	return true;
}

void cRPC::Destroy(){
	if(Socket != INVALID_SOCKET){
		shutdown(Socket, 0);
		closesocket(Socket);
		Socket = INVALID_SOCKET;
	}

	//  ť  .
	cList<void *>::cCursor csr;

	for(csr = ReceiveQueue.Head(); csr != 0; csr ++)
		delete (cRPCPacket*)*csr;
	ReceiveQueue.RemoveAll();

}

bool cRPC::ReceiveAsync(){
	fd_set fds;

	FD_ZERO(&fds);
	FD_SET(Socket, &fds);

	timeval tv;
	if(ServerMode){
		tv.tv_sec = 0;
		tv.tv_usec = 100;
	}else{
		tv.tv_sec = 0;
		tv.tv_usec = 0;
	}

	if(select( Socket+1/*FD_SETSIZE*/, &fds, NULL, NULL, &tv) == SOCKET_ERROR)
		return false;

	if(FD_ISSET(Socket, &fds)){
		if(ServerMode){
			return Accept();
		}else{
			return Receive();
		}
	}
	return true;
}


bool cRPC::Receive(){
	cRPCPacket *pPacket;
	int Count;

	Count = recv(Socket, PacketBuff.pData, MAX_PACKET_SIZE - RecvCount, 0);
	if(Count == SOCKET_ERROR){
		Close();
		return false;
	}
	if(Count == 0){
		Close();
	}else{
		RecvCount += Count;
		while(RecvCount >= 2){
			if(RecvCount < PacketBuff.GetSize())
				break;
			pPacket = new cRPCPacket(PacketBuff.GetSize());
			memcpy(pPacket->pData, PacketBuff.pData, PacketBuff.GetSize());
			ReceiveQueue.AddTail(pPacket);
			RecvCount -= PacketBuff.GetSize();
			memcpy(PacketBuff.pData, PacketBuff.pData + PacketBuff.GetSize(), RecvCount);
		}
	}
	return true;
}



cRPCPacket* cRPC::GetPacket(){
	//  ť Ŷ , DestroyPacket ȣ ־ 
	cRPCPacket* pPacket;

	if(ReceiveQueue.GetCount() == 0){
		if(ServerMode){
			if(!Accept())
				return 0;
		}else{
			if(!Receive())
				return 0;
		}
	}
	if(ReceiveQueue.GetCount() == 0)
		return 0;

	pPacket = (cRPCPacket*)ReceiveQueue.GetHead();
	ReceiveQueue.RemoveHead();
	return pPacket;
}

cRPCPacket* cRPC::PeekPacket(){
	// ť Ŷ  , DestroyPacket ȣ ʿ 
	ReceiveAsync();
//		return 0;

	if(ReceiveQueue.GetCount() == 0)
		return 0;

	return (cRPCPacket*)ReceiveQueue.GetHead();
}

void cRPC::DestroyPacket(cRPCPacket *pPacket){
	// ť  Ŷ 
	if(pPacket->pData)
		delete pPacket;
}

bool cRPC::SendPacket(cRPCPacket *pPacket){
	// Ŷ ۽(۽ť  )
	int SendSize;

	SendSize = send(Socket, pPacket->pData, pPacket->GetSize(), 0);

	if(SendSize < pPacket->GetSize()){
		/*int i = GetLastError();
		ASSERT(false);*/
		return false;
	}
	return true;

}

bool cRPC::SendSimplePacket(BYTE ObjectID, BYTE MethodID){
	cRPCPacket Packet(4);

	Packet.SetHeader(ObjectID, MethodID);

	return SendPacket(&Packet);
}

bool cRPC::Accept(){
	SOCKET NewSocket;

	NewSocket = accept(Socket, 0, 0);
	if(NewSocket == INVALID_SOCKET){
		return false;
	}

	cRPCPacket *pPacket;
	pPacket = new cRPCPacket(4 + sizeof(SOCKET));
	pPacket->SetHeader(RPCO_RPC, RPCM_Accept);
	AcceptStub(*pPacket, NewSocket);
	pPacket->SetReadMode();
	ReceiveQueue.AddTail(pPacket);

	return true;
}

bool cRPC::Close(){
	cRPCPacket *pPacket;
	pPacket = new cRPCPacket(4);
	pPacket->SetHeader(RPCO_RPC, RPCM_Close);
	CloseStub(*pPacket);
	pPacket->SetReadMode();
	ReceiveQueue.AddTail(pPacket);

	return true;
}



// RPC Stub /////////////////////////////////////////////////////////////////
bool cRPC::AcceptStub(cRPCPacket &Packet, SOCKET &s){
	if(!Packet.ExAuto(s))
		return false;

	return true;

}

bool cRPC::CloseStub(cRPCPacket &Packet){

	return true;

}


