#include "stdafx.h"
#include "cShape.h"

// cPoint ///////////////////////////////////////////////////
cPoint::cPoint(){

}

cPoint::cPoint(DWORD val){
	x = LOWORD(val);
	y = HIWORD(val);
}

cPoint::cPoint(int _x, int _y){
	x = _x;
	y = _y;
}

bool cPoint::operator==(cPoint& a){
	return x == a.x && y == a.y;
}

bool cPoint::operator!=(cPoint& a){
	return x != a.x || y != a.y;
}

cPoint cPoint::operator+=(cPoint& a){
	x += a.x;
	y += a.y;
	return *this;
}

cPoint cPoint::operator-=(cPoint& a){
	x -= a.x;
	y -= a.y;
	return *this;
}

cPoint operator+(cPoint& a, cPoint& b){
	cPoint c;
	c.x = a.x + b.x;
	c.y = a.y + b.y;
	return c;
}

cPoint operator-(cPoint& a, cPoint& b){
	cPoint c;
	c.x = a.x - b.x;
	c.y = a.y - b.y;
	return c;
}

// cRect //////////////////////////////////////////////////////////
void cRect::Set(int _Left, int _Top, int _Right, int _Bottom){
	left = _Left;
	top = _Top;
	right = _Right;
	bottom = _Bottom;
}

void cRect::ClipRect(int _left, int _top, int _right, int _bottom){
	if(left < _left) left = _left;
	if(top < _top) top = _top;
	if(right > _right) right = _right;
	if(bottom > _bottom) bottom = _bottom;
}

bool cRect::IsIn(int x, int y){
	return (x >= left && y >= top && x < right && y < bottom);
}

bool cRect::IsIn(cPoint pt){
	return (pt.x >= left && pt.y >= top && pt.x < right && pt.y < bottom);
}

int cRect::Width(){
	return right - left; 
}

int cRect::Height(){
	return bottom - top; 
}

cRect::operator LPRECT(){
	return LPRECT(this); 
}

cRect& cRect::operator=(RECT& a){ 
	*((LPRECT)this) = a; 
	return *this; 
}

cPoint cRect::LeftTop(){
	cPoint pt;
	pt.x = left;
	pt.y = top;
	return pt;
}

cPoint cRect::RightBottom(){
	cPoint pt;
	pt.x = right;
	pt.y = bottom;
	return pt;
}


cRect& cRect::operator+=(cPoint& a){
	left += a.x;
	top += a.y;
	right += a.x;
	bottom += a.y;
	return *this;
}

cRect& cRect::operator-=(cPoint& a){
	left -= a.x;
	top -= a.y;
	right -= a.x;
	bottom -= a.y;
	return *this;
}

cRect cRect::operator+(cPoint& a){
	cRect rc;

	rc.left = left + a.x;
	rc.top = top + a.y;
	rc.right = right + a.x;
	rc.bottom = bottom + a.y;
	return rc;
}

cRect cRect::operator-(cPoint& a){
	cRect rc;

	rc.left = left - a.x;
	rc.top = top - a.y;
	rc.right = right - a.x;
	rc.bottom = bottom - a.y;
	return rc;
}

bool cRect::ClipRect(cRect *pRect){
	// Ŭ ؼ ܿ 簢 ִٸ true
	// ƴϸ false
	if(left >= pRect->right ||
		top >= pRect->bottom ||
		right <= pRect->left ||
		bottom <= pRect->top)
		return false;

	if(left > pRect->left)
		pRect->left = left;

	if(top > pRect->top)
		pRect->top = top;

	if(right < pRect->right)
		pRect->right = right;

	if(bottom < pRect->bottom)
		pRect->bottom = bottom;

	return true;
}

bool cRect::IsNormal(){
	return left < right && top < bottom;
}

void cRect::Normalize(){
	int temp;

	if(left > right){
		temp = left;
		left = right;
		right = temp;
	}
	
	if(top > bottom){
		temp = top;
		top = bottom;
		bottom = temp;
	}

}

cRect& cRect::operator+=(cRect& a){
	left += a.left;
	top += a.top;
	right += a.right;
	bottom += a.bottom;
	return *this;
}

cRect& cRect::operator-=(cRect& a){
	left -= a.left;
	top -= a.top;
	right -= a.right;
	bottom -= a.bottom;
	return *this;
}

cRect operator+(cRect &a, cRect &b){
	cRect c;
	c = a;
	c += b;
	return c;
}

cRect operator-(cRect &a, cRect &b){
	cRect c;
	c = a;
	c -= b;
	return c;
}


