// cChatClientMainWnd.cpp : implementation file
//
#include "stdafx.h"
#include "cChatClientMainWnd.h"
#include "cLoginWnd.h"
#include "cChatWnd.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// cChatClientMainWnd

cChatClientMainWnd::cChatClientMainWnd()
{
	m_pChildWnd = NULL;
}

cChatClientMainWnd::~cChatClientMainWnd()
{
	m_pChildWnd = NULL;
}


BEGIN_MESSAGE_MAP(cChatClientMainWnd, CWnd)
	//{{AFX_MSG_MAP(cChatClientMainWnd)
	ON_WM_CREATE()
	ON_MESSAGE(CCM_ChangeChild, OnChangeChild)
	ON_WM_DESTROY()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// cChatClientMainWnd message handlers






bool cChatClientMainWnd::Create(CWnd *pParentWnd, UINT nID, sClientInfo ClientInfo) {
	CRect rcClient;
 	::GetClientRect (pParentWnd->GetSafeHwnd(), rcClient);
//	rcClient.SetRect(0, 0, 240, 320);

	m_ClientInfo = ClientInfo;

	if(!CWnd::Create(NULL, NULL, WS_CHILD | WS_VISIBLE, rcClient, pParentWnd, nID, NULL))
		return false;
	
	m_pChildWnd = NULL;

	SetFocus();

	return true;	

}

int cChatClientMainWnd::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here

//	m_pChildWnd = CreateChildWnd(CCMP_Default);

//	if(!m_pChildWnd){
//		TRACE0("Failed to create view window\n");
//		return -1;
//	}

	//   ʱȭ
	WSADATA wsaData;
	if(WSAStartup(MAKEWORD( 2, 2 ), &wsaData ) != 0){
		ASSERT(!"CROGClientMainWnd::OpenRPC()::WSAStartup() fail.");
		return false;
	}
	

	PostMessage(CCM_ChangeChild, CCMP_Login, 0);



	return 0;
}

void cChatClientMainWnd::Destory() {
	DestroyChildWnd();
	m_RPC.Destroy();  
	PostQuitMessage(0);
}

void cChatClientMainWnd::OnDestroy() 
{
	CWnd::OnDestroy();
	
	// TODO: Add your message handler code here
	DestroyChildWnd();
	m_RPC.Destroy();  
}



LRESULT cChatClientMainWnd::OnChangeChild(WPARAM wParam, LPARAM lParam){
	DestroyChildWnd();
	m_pChildWnd = CreateChildWnd(wParam);
	if (!m_pChildWnd) {
		AfxMessageBox (_T("Error : CreateChildWnd()"));
		return 0;
	}

	m_pChildWnd->ShowWindow(SW_SHOW);
	return 0;
}



CWnd *cChatClientMainWnd::CreateChildWnd(int ChildViewID){
	CWnd *pNewChild = NULL;

	switch(ChildViewID){
	case CCMP_Login:
		{
			pNewChild = new cLoginWnd;
		}
		break;
	case CCMP_ChatView:
		{
			pNewChild = new cChatWnd;
		}
		break;

	}

	if(pNewChild){
		CRect rcClient;
		GetClientRect(rcClient);
		if (pNewChild->Create(NULL, NULL, 
			WS_CHILD | WS_VISIBLE | WS_CLIPCHILDREN ,
			rcClient, this, 0, NULL)){
		}else{
			TRACE0("Failed to create view window\n");
			return 0;//pNewChild = &m_wndView;
		}
	}else{
		return 0;
	}

	return pNewChild;
}

void cChatClientMainWnd::DestroyChildWnd(){
	if (m_pChildWnd) {
		m_pChildWnd->DestroyWindow();
		delete m_pChildWnd;
	}
	m_pChildWnd = NULL;
}


bool cChatClientMainWnd::OpenRPC(const char *ServerIP, int ServerPort){
	if(ServerIP == 0){
		if(!m_RPC.CreateClient(m_ClientInfo.ServerAddr, m_ClientInfo.ServerPort))
			return false;
	}else if(ServerPort == 0){
		if(!m_RPC.CreateClient(ServerIP, m_ClientInfo.ServerPort))
			return false;
	}else{
		if(!m_RPC.CreateClient(ServerIP, ServerPort))
			return false;
	}
	SetTimer(100, 100, 0);
	return true;
}

void cChatClientMainWnd::CloseRPC(){
	m_RPC.Destroy();
	KillTimer(100);
}


void cChatClientMainWnd::OnTimer(UINT nIDEvent) 
{
   // TODO: Add your message handler code here and/or call default
   if(nIDEvent == 100){
   // Ʈ ޽ ó
      cRPCPacket *pPacket;
	  bool Continue = true;

	  while(Continue){
         pPacket = m_RPC.PeekPacket();
         if(pPacket){
         pPacket = m_RPC.GetPacket();
            if(pPacket->GetObjectID() == RPCO_RPC){
               switch(pPacket->GetMethodID()){
               case RPCM_Close:
                  // Ʈ  ݴ´.
                  CloseRPC();
                  MessageBox(_T("Connection closed"));
                  PostMessage(CCM_ChangeChild, CCMP_Login, 0);
                  Continue = false;
                  break;
               default:
                  ASSERT(FALSE);
                  break;
			   }
               m_RPC.DestroyPacket(pPacket);
			}else{
               m_pChildWnd->SendMessage(CCM_RPCCall, pPacket->GetMethodID(), (LPARAM)pPacket);
               m_RPC.DestroyPacket(pPacket);
			}
		 }else{
            Continue = false;
		 }
	  }
   }
	
   CWnd::OnTimer(nIDEvent);
}



BOOL cChatClientMainWnd::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs


//	cs.lpszClass = AfxRegisterWndClass(0);
//
//	cs.style = cs.style & ~WS_CLIPCHILDREN;
	return TRUE;
}



