#include "StdAfx.h"
#include "cChatSvrApp.h"
#include "cPlayer.h"
#include "ChatProtocol.h"

int cChatSvrApp::Main (int argc, char **argv) {


	if (!OpenRPC() )
		return -1;

	// Main Loop
	cRPCPacket *pPacket=NULL;
	bool Continue = true;

	while(Continue){
		pPacket = m_RPC.PeekPacket();
		if (pPacket) {
			pPacket = m_RPC.GetPacket();
			ASSERT(pPacket->GetObjectID() == RPCO_RPC);

			switch(pPacket->GetMethodID()){
			case RPCM_Accept:
				{	// ο ڰ 
					SOCKET Socket;
					cRPC::AcceptStub(*pPacket, Socket);
					AcceptNewPlayer(Socket);
				}
				break;
			case RPCM_Close:
				Continue = false;
				break;
			}
			m_RPC.DestroyPacket(pPacket);
		} else {
			UpdatePlayers();
		}
		

	}

	printf("cChatServerApp::Main() Closing...\n");

	CloseRPC();

	printf("cChatServerApp::Main() OK\n");

#ifdef _DEBUG
	printf("Press enter key to exit.\n");
	char c;
	scanf("%c", &c);
#endif	
	
	return 0;
}



bool cChatSvrApp::OpenRPC() {
	
	printf("cROGServerApp::OpenRPC()\n");


	WSADATA wsaData;
	if(WSAStartup(MAKEWORD( 2, 2 ), &wsaData ) != 0){
		printf("\tWSAStartup() fail.\n");
		return false;
	}

	if(!m_RPC.CreateServer(NULL, GetServerPort(), 10)){
		printf("\tRPC.CreateServer() Fail.\n");
		return false;
	}
	printf("\tOK.\n");
	return true;

}


void cChatSvrApp::CloseRPC() {
	printf("cChatServerApp::CloseRPC()\n");

	m_RPC.Destroy();

	printf("\tOK.\n");	

}


bool cChatSvrApp::AcceptNewPlayer(SOCKET Socket) {

	cPlayer *pNewPlayer;

	printf("cChatServerApp::AcceptNewPlayer(%d)\n", Socket);

	pNewPlayer = new cPlayer;
	if (!pNewPlayer->Create(Socket, this)) {
		shutdown(Socket, 0);
		closesocket(Socket);
		printf("\tpNewPlayer->Create() Failed.\n");
	}

	printf("\tOK.\n");

	m_PlayerList.AddTail(pNewPlayer);

	return true;

}



void cChatSvrApp::UpdatePlayers(){
	cList<cPlayer *>::cCursor	csr;
	cPlayer						*pPlayer;

	for(csr = m_PlayerList.Head(); csr != 0;){
		pPlayer = *csr;
		if(pPlayer->Update()){
			csr ++;

		}else{
			// ÷̾ ۾
			csr = m_PlayerList.Delete(csr);

			printf("cChatSvrApp::UpdatePlayers() Destroying Player\n");

			// ٸ ڵ鿡 ڰ  ˸.
			printf("CSM_PlayerOut\n");
			cRPCPacket NewPacket;
			NewPacket.SetHeader (RPCO_Owner, CCM_LogOut);
			CCM_LogOut_Stub( NewPacket, pPlayer->GetName());
			BroadcastPacket(&NewPacket, pPlayer);

			pPlayer->Dump();
			pPlayer->Destroy();
			delete pPlayer;
		}

	}
}



bool cChatSvrApp::BroadcastPacket(cRPCPacket *pPacket, cPlayer *pPlayerExcept){
	cList<cPlayer *>::cCursor	csr;
	cPlayer						*pPlayer;

	for(csr = m_PlayerList.Head(); csr != 0; csr ++){
		pPlayer = *csr;

		if(pPlayer != pPlayerExcept)
			pPlayer->GetRPC()->SendPacket(pPacket);

	}

	return true;
}
