// cChatWnd.cpp : implementation file
//

#include "stdafx.h"
#include "cChatWnd.h"
#include "Client.h"
#include "cChatClientMainWnd.h"
#include "ChatProtocol.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// cChatWnd

static RECT rcExitBtn = { 180, 0, 180 + 50, 0 + 24 };
static RECT rcChatListEdit = { 0, 28, 0 + 240, 28 + 88 };
static RECT rcChatEdit = { 0, 116, 0 + 200, 116 + 24 };
static RECT rcChatEditFocus = { 0, 260, 0 + 200, 260 + 24 };
static RECT rcSendBtn = { 200, 116, 200 + 40, 116 + 24 };

cChatWnd::cChatWnd()
{
}

cChatWnd::~cChatWnd()
{
}


BEGIN_MESSAGE_MAP(cChatWnd, CWnd)
	//{{AFX_MSG_MAP(cChatWnd)
	ON_COMMAND(cChatWnd::CWID_SendBtn, OnSendBtn)
	ON_COMMAND(cChatWnd::CWID_ExitBtn, OnExitBtn)
	ON_WM_CREATE()
	ON_MESSAGE(CCM_RPCCall, OnRPCCall)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// cChatWnd message handlers

int cChatWnd::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	GetRPC()->SendSimplePacket(RPCO_Owner, CSM_SetChatMode);

	m_ExitBtn.Create(_T("Exit"), WS_CHILD | WS_VISIBLE, rcExitBtn, this, CWID_ExitBtn);

	m_ChatListEdit.Create(WS_CHILD | WS_VISIBLE | ES_READONLY | WS_VSCROLL | ES_MULTILINE, rcChatListEdit, this, CWID_ChatListEdit);
	m_ChatEdit.Create(WS_CHILD | WS_VISIBLE | WS_BORDER |ES_MULTILINE | ES_AUTOHSCROLL , rcChatEdit, this, CWID_ChatEdit);
	m_SendBtn.Create(_T("Send"), WS_CHILD | WS_VISIBLE/* | BS_DEFPUSHBUTTON*/ |WS_TABSTOP, rcSendBtn, this, CWID_SendBtn);

	m_ChatEdit.SetLimitText (200);

	m_ChatEdit.SetFocus();
	// TODO: Add your specialized creation code here
	
	return 0;
}


cRPC *cChatWnd::GetRPC(){
	return ((cChatClientMainWnd *)GetParent())->GetRPC();
}


LRESULT cChatWnd::OnRPCCall(WPARAM wParam, LPARAM lParam){
	cRPCPacket *pPacket;
	pPacket = (cRPCPacket *)lParam;

	switch(wParam){
		case CCM_AddChat:
			{
				TCHAR PlayerName[20];
				TCHAR Chat[200];
				CCM_AddChat_Stub(*pPacket, PlayerName, Chat);
				AddChat(PlayerName, Chat);
			}
			break;

		case CCM_SetName:
			{
				TCHAR pName[20];
				CCM_SetName_Stub (*pPacket, pName);
				m_PlayerName = pName;
			}
			break;

		case CCM_NewPlayer:
			{
				TCHAR pName[20];
				CCM_NewPlayer_Stub(*pPacket, pName);
				Player_Login(pName);
			}
			break;
		case CCM_LogOut:
			{
				TCHAR pName[20];
				CCM_LogOut_Stub(*pPacket, pName);
				Player_LogOut (pName);
			}
			break;

	}

	return TRUE;
}



void cChatWnd::AddChat(LPTSTR pName, LPTSTR pChat) {


	TCHAR strLine[256];

	_stprintf(strLine, _T("[%s]: %s\r\n"), pName, pChat);

	int nLen;
	nLen = m_ChatListEdit.GetWindowTextLength();
	m_ChatListEdit.SetSel(nLen, nLen);
	m_ChatListEdit.ReplaceSel(strLine);
	m_ChatListEdit.PostMessage(WM_VSCROLL, (WPARAM)SB_BOTTOM, 0);
	
	if(m_ChatListEdit.GetLineCount() > 100){
		m_ChatListEdit.SetSel(0, m_ChatListEdit.GetLine(0, strLine, 256) + 2, TRUE);
		m_ChatListEdit.ReplaceSel(_T(""), FALSE);
	}


}




void cChatWnd::Player_Login(LPTSTR pName) {

	TCHAR strLine[256];

	_stprintf(strLine, _T("[%s] ϼ̽ϴ.\r\n"), pName);

	int nLen;
	nLen = m_ChatListEdit.GetWindowTextLength();
	m_ChatListEdit.SetSel(nLen, nLen);
	m_ChatListEdit.ReplaceSel(strLine);
	m_ChatListEdit.PostMessage(WM_VSCROLL, (WPARAM)SB_BOTTOM, 0);
	
	if(m_ChatListEdit.GetLineCount() > 100){
		m_ChatListEdit.SetSel(0, m_ChatListEdit.GetLine(0, strLine, 256) + 2, TRUE);
		m_ChatListEdit.ReplaceSel(_T(""), FALSE);
	}



}


void cChatWnd::Player_LogOut (LPTSTR pName) {

	TCHAR strLine[256];

	_stprintf(strLine, _T("[%s] ϼ̽ϴ.\r\n"), pName);

	int nLen;
	nLen = m_ChatListEdit.GetWindowTextLength();
	m_ChatListEdit.SetSel(nLen, nLen);
	m_ChatListEdit.ReplaceSel(strLine);
	m_ChatListEdit.PostMessage(WM_VSCROLL, (WPARAM)SB_BOTTOM, 0);
	
	if(m_ChatListEdit.GetLineCount() > 100){
		m_ChatListEdit.SetSel(0, m_ChatListEdit.GetLine(0, strLine, 256) + 2, TRUE);
		m_ChatListEdit.ReplaceSel(_T(""), FALSE);
	}



}


void cChatWnd::OnSendBtn(){
	SendChat();
}

void cChatWnd::SendChat() {
	TCHAR MyName[20];
	TCHAR buff[200];

	if(!m_ChatEdit.GetWindowText(buff, 200))
		return;

	if(_tcslen(buff) <= 0)
		return;

	_tcscpy(MyName, m_PlayerName);
	AddChat(MyName, buff);

	m_ChatEdit.SetWindowText(_T(""));

	m_ChatEdit.SetFocus();

	cRPCPacket Packet;

	Packet.SetHeader(RPCO_Owner, CSM_AddChat);
	CSM_AddChat_Stub(Packet, buff);
	GetRPC()->SendPacket(&Packet);


}


void cChatWnd::OnExitBtn () {

	GetRPC()->SendSimplePacket (RPCO_Owner, CSM_LogOut);

	GetParent()->PostMessage(CCM_ChangeChild, CCMP_Login, 0);

}


BOOL cChatWnd::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	cs.style &= ~WS_BORDER;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		NULL, HBRUSH(COLOR_WINDOW+1), NULL);

	return TRUE;
}


BOOL cChatWnd::OnCommand( WPARAM wParam, LPARAM lParam ){
	if(HIWORD (wParam) == EN_CHANGE && LOWORD(wParam) == CWID_ChatEdit){

//		int a = DM_SETDEFID;
//		int b = WM_USER;
//		SendMessage(DM_SETDEFID, CWID_SendBtn, 0);
//                    (WPARAM) IDOK, 
  //                  (LPARAM) 0); 
            
		return TRUE;
	}
	if(HIWORD(wParam) == IDOK && LOWORD(wParam) == CWID_ChatEdit){
		int a;
		a = 0;
	}

	return CWnd::OnCommand(wParam, lParam);
}
