// cLoginWnd.cpp : implementation file
//
#include "stdafx.h"
#include "cLoginWnd.h"
#include "Client.h"
#include "cChatClientMainWnd.h"
#include "ChatProtocol.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// cLoginWnd


static RECT rcNameStatic = { 0, 0, 0 + 60, 0 + 24 };
static RECT rcNameEdit = { 80, 0, 80 + 120, 0 + 24 };
static RECT rcLoginBtn = { 0, 80, 0 + 60, 80 + 24 };
static RECT rcExitBtn = { 160, 80, 160 + 60, 80 + 24 };



cLoginWnd::cLoginWnd()
{
}

cLoginWnd::~cLoginWnd()
{
}


BEGIN_MESSAGE_MAP(cLoginWnd, CWnd)
	//{{AFX_MSG_MAP(cLoginWnd)
	ON_COMMAND(cLoginWnd::CWID_LoginBtn, OnLoginBtn)
	ON_COMMAND(cLoginWnd::CWID_ExitBtn, OnExitBtn)
	ON_MESSAGE(CCM_RPCCall, OnRPCCall)
	ON_WM_PAINT()
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// cLoginWnd message handlers



LRESULT cLoginWnd::OnRPCCall(WPARAM wParam, LPARAM lParam){
	cRPCPacket *pPacket;
	pPacket = (cRPCPacket *)lParam;

	switch(pPacket->GetObjectID()){
	case RPCO_Owner:
		switch(wParam){
		case CCM_LoginResult:
			{
				char Success;
				CCM_LoginResult_Stub(*pPacket, Success);
				LoginResult(Success);

			}
			break;
		default:
			ASSERT(FALSE);
			break;
		}
		break;
	default:
		ASSERT(FALSE);

	}

	return TRUE;

}

int cLoginWnd::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	m_NameStatic.Create (_T("Name"), WS_CHILD | WS_VISIBLE, rcNameStatic, this, CWID_NameStatic);
	m_NameEdit.Create ( WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP, rcNameEdit, this, CWID_NameEdit);
	m_LoginBtn.Create (_T("Login"), WS_VISIBLE | WS_CHILD, rcLoginBtn, this, CWID_LoginBtn);
	m_ExitBtn.Create (_T("Exit"), WS_VISIBLE | WS_CHILD, rcExitBtn, this, CWID_ExitBtn);



	m_LoginBtn.Invalidate();
	m_ExitBtn.Invalidate();
	m_NameStatic.Invalidate();
	m_NameEdit.Invalidate();

	m_NameEdit.SetFocus();

	((cChatClientMainWnd*)GetParent())->CloseRPC();	

	// TODO: Add your specialized creation code here
	
	return 0;
}


void cLoginWnd::OnLoginBtn(){
	cRPCPacket Packet;



	if(!((cChatClientMainWnd*)GetParent())->OpenRPC()){

		MessageBox(_T("Network connect fail."), _T("error"), MB_OK);
		return;
	}


	Packet.SetHeader(RPCO_Owner, CSM_Login);

	TCHAR PlayerName[20];
	m_NameEdit.GetWindowText(PlayerName, 20);

	CSM_Login_Stub(Packet, PlayerName);
	GetRPC()->SendPacket(&Packet);
}


void cLoginWnd::OnExitBtn() {
	((cChatClientMainWnd *) GetParent() )->Destory();
}


cRPC *cLoginWnd::GetRPC() {
	return ((cChatClientMainWnd *) GetParent() )->GetRPC();
}



void cLoginWnd::OnPaint() 
{
	CPaintDC dc(this); // device context for painting


//	dc.Ellipse (10, 10, 100, 100);
	
	// TODO: Add your message handler code here
	
	// Do not call CWnd::OnPaint() for painting messages
//	cROGDisplay &Display = ((CROGClientMainWnd*)GetParent())->m_Display;
//	Display.GetBackPic()->Blt(0, 0, &m_TitlePic);
//	Display.Flip();
	m_LoginBtn.Invalidate();
	m_ExitBtn.Invalidate();
	m_NameStatic.Invalidate();
	m_NameEdit.Invalidate();

//	m_StartBtn.Invalidate();
//	m_ExitBtn.Invalidate();

}



void cLoginWnd::LoginResult(char Success) {


	if (Success) {

		((cChatClientMainWnd *) GetParent() )->PostMessage(CCM_ChangeChild, CCMP_ChatView);

	}


}



BOOL cLoginWnd::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	cs.style &= ~WS_BORDER;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		NULL, HBRUSH(COLOR_WINDOW+1), NULL);

	return TRUE;
}

BOOL cLoginWnd::OnCommand( WPARAM wParam, LPARAM lParam ){
	return CWnd::OnCommand(wParam, lParam);
}
