#include "stdafx.h"
#include "Downloader.h"
#include "Helper.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

void CreateFileFolder(LPCTSTR strFilePath){

	//        .
	TCHAR strFolderName[MAX_PATH];
	int nFilePathLen;
	int i, j;

	nFilePathLen = _tcslen(strFilePath);
	for(i = 1; i < nFilePathLen; i ++){
		if(strFilePath[i] == '\\' || strFilePath[i] == '/'){
			_tcsncpy(strFolderName, strFilePath, i);
			strFolderName[i] = 0;
			for(j = 0; j < i; j ++){
				if(strFolderName[j] == '/')
					strFolderName[j] = '\\';
			}

			CreateDirectory(strFolderName, 0);

		}
	}
}
bool IsSameFileTime(LPCTSTR strFilePath, FILETIME *pServerFileTime){
	HANDLE hFile;

	hFile = CreateFile(strFilePath, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if(hFile == INVALID_HANDLE_VALUE){
		CloseHandle(hFile);
		return false; 
	}
	FILETIME LastWriteTime;

	GetFileTime(hFile, NULL, NULL, &LastWriteTime);

	SYSTEMTIME tmServerFileTime;
	SYSTEMTIME tmWriteTime;

	FileTimeToSystemTime(pServerFileTime, &tmServerFileTime);
	FileTimeToSystemTime(&LastWriteTime, &tmWriteTime);

	tmWriteTime.wSecond = tmServerFileTime.wSecond;
	SystemTimeToFileTime(&tmWriteTime, &LastWriteTime);

	if(CompareFileTime(&LastWriteTime, pServerFileTime) != 0){
		CloseHandle(hFile);
		return false;
	}

	CloseHandle(hFile);

	return true;
}




bool InternetReadString(HINTERNET hHttpRequest, TCHAR *Buff, DWORD dwBuffSize){
	char ch;
	DWORD dwRead;
	DWORD dwWritePos;

	dwWritePos = 0;

	while(true){
		if(!InternetReadFile(hHttpRequest, &ch, 1, &dwRead))
			return false;

		if(dwRead == 0){
			if(dwWritePos == 0)
				return false;
			break;
		}

		if(ch == '\n')
			break;
		if(ch != '\r'){
			Buff[dwWritePos] = ch;
			dwWritePos ++;
		}
			
	}

	Buff[dwWritePos] = '\0';
	return true;
}

/*
FILETIME StrToFileTime(LPCTSTR str){
	SYSTEMTIME sysTime;
	FILETIME FileTime;
	char strDay[4];
	char strMon[4];
//			Mon, 04 Jun 2001 09:18:57 GMT
	sscanf(str, "%3s, %d %s %d %d:%d:%d",
		strDay,
		&sysTime.wDay,
		strMon,
		&sysTime.wYear,
		&sysTime.wHour,
		&sysTime.wMinute,
		&sysTime.wSecond);
	const char *strDays[7] = {
		"SUN", "MON", "TUE", "WED", "THU", "FRI", "SAT"
	};
	const char *strMons[12] = {
		"JAN", "FEB", "MAR", "APR", "MAY", "JUN", "JUL", "AUG", "SEP", "OCT", "NOV", "DEC"
	};
//	GetSystemTime(&sysTime);
	int i;
	for(i = 0; i < 7; i ++){
		if(strcmpi(strDays[i], strDay) == 0){
			sysTime.wDayOfWeek = i + 1;
			break;
		}
	}
	if(i == 7) ASSERT(FALSE);

	for(i = 0; i < 12; i ++){
		if(strcmpi(strMons[i], strMon) == 0){
			sysTime.wMonth = i + 1;
			break;
		}
	}
	if(i == 12) ASSERT(FALSE);


	sysTime.wMilliseconds = 1;

	SystemTimeToFileTime(&sysTime, &FileTime);

	return FileTime;

}*/



enum eDownloadThreadError{
	DT_OK,
	DT_TERMINATE,

};

/////////////////////////////////////////////////////////////////////////////////////////

DWORD WINAPI CDownloader::DownloadThreadProc(LPVOID pParam){
	int nErrorCode = DT_OK;
    CDownloader* pObject = (CDownloader*)pParam;
	const int DOWN_BUFFER_SIZE = 1024;
	char DownloadBuff[DOWN_BUFFER_SIZE];
	TCHAR strTempFileName[MAX_PATH];

    if (pObject == NULL)// || !pObject->IsKindOf(RUNTIME_CLASS(CDownloadDlg)))
	    return 1;   // if pObject is not valid

	HINTERNET		hHTTPSession;
	HINTERNET		hHTTPRequest;

	//  ϵ ũ⸦ Ѵ.
	DWORD dwFileCount;
	DWORD dwTotalFileSize = 0;
	DWORD dwTotalDownSize = 0;
	DWORD dwCurFileSize = 0;
	DWORD dwCurDownSize = 0;

	GetTempPath(MAX_PATH, strTempFileName);
	_tcscat(strTempFileName, _T("\\fch.tmp"));

	cList<CDownloadFile *>::cCursor csr;
	CDownloadFile *pDownloadFile;

	dwFileCount = 0;
	for(csr = pObject->m_DownloadList.Head(); csr != 0; csr ++){
		pDownloadFile = *csr;

		hHTTPSession = InternetConnect(pObject->m_hInternet, pDownloadFile->m_pszServerUrl, pDownloadFile->m_nServerPort, _T(""), _T(""), INTERNET_SERVICE_HTTP, 0, 0);

		hHTTPRequest = HttpOpenRequest(hHTTPSession, _T("HEAD"), pDownloadFile->m_pszServerFileName, HTTP_VERSION, NULL, 0, INTERNET_FLAG_NO_CACHE_WRITE, 0);

		if(HttpSendRequest(hHTTPRequest, NULL, 0, 0, 0)){
			DWORD dwBufferSize;
			dwBufferSize = 100;//sizeof(DWORD);
			pDownloadFile->m_dwFileSize = 0;
			HttpQueryInfo(hHTTPRequest, HTTP_QUERY_CONTENT_LENGTH | HTTP_QUERY_FLAG_NUMBER, &pDownloadFile->m_dwFileSize, &dwBufferSize, 0);
//			pDownloadFile->FileCreateTime = pDownloadFile->m_ftFileTime;
			dwTotalFileSize += pDownloadFile->m_dwFileSize;
		}else{
			TRACE(pDownloadFile->m_pszServerFileName);
		}

		dwFileCount ++;
		InternetCloseHandle(hHTTPRequest);
		InternetCloseHandle(hHTTPSession);
	}

	SetEvent(pObject->m_hDownloadInit);

	if(pObject->m_hWndOwner)
		PostMessage(pObject->m_hWndOwner, WM_DOWNLOAD_START, (WPARAM)dwFileCount, (LPARAM)dwTotalFileSize);

	dwTotalDownSize = 0;
	// do something with 'pObject'
	dwFileCount = 0;
	while(pDownloadFile = pObject->GetNextDownload()){
		//  ϳ ٿε غ
		// ش ϸ ٿ ʴ´.
		if(pDownloadFile->m_dwFileSize == 0){
			dwCurDownSize += pDownloadFile->m_dwFileSize;
			dwTotalDownSize += pDownloadFile->m_dwFileSize;
			//pObject->SetDownloadInfo(dwTotalFileSize, dwTotalDownSize, dwCurFileSize, dwCurDownSize);
			pObject->AddSkip(pDownloadFile);
			continue;
		}
		if(IsSameFileTime(pDownloadFile->m_pszLocalFileName, &pDownloadFile->m_ftFileTime)){
			dwCurDownSize += pDownloadFile->m_dwFileSize;
			dwTotalDownSize += pDownloadFile->m_dwFileSize;
			//pObject->SetDownloadInfo(dwTotalFileSize, dwTotalDownSize, dwCurFileSize, dwCurDownSize);
			pObject->AddSkip(pDownloadFile);
			continue;
		}

		hHTTPSession = InternetConnect(pObject->m_hInternet, pDownloadFile->m_pszServerUrl, 
			pDownloadFile->m_nServerPort, _T(""), _T(""), INTERNET_SERVICE_HTTP, 0, 0);
		hHTTPRequest = HttpOpenRequest(hHTTPSession, _T("GET"), pDownloadFile->m_pszServerFileName,
			HTTP_VERSION, NULL, 0, INTERNET_FLAG_NO_CACHE_WRITE, 0);

		if(HttpSendRequest(hHTTPRequest, NULL, 0, 0, 0)){
			// ٿε  
			HANDLE hFileOnDisk;
			DWORD dwRead;

			dwCurFileSize = pDownloadFile->m_dwFileSize;
			dwCurDownSize = 0;

			if(pObject->m_hWndOwner)
				PostMessage(pObject->m_hWndOwner, WM_DOWNLOAD_FILE_START, (WPARAM)dwFileCount, (LPARAM)dwCurFileSize);
			
			CreateFileFolder(pDownloadFile->m_pszLocalFileName);// ϴ شϴ  н  
			hFileOnDisk = CreateFile(strTempFileName, GENERIC_WRITE, 0, 0, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0);
			if(hFileOnDisk != INVALID_HANDLE_VALUE){
				while(InternetReadFile(hHTTPRequest, DownloadBuff, DOWN_BUFFER_SIZE, &dwRead)){
//					Sleep(100);
					if(dwRead == 0)
						break;
					DWORD dwWritten;
					WriteFile(hFileOnDisk, DownloadBuff, dwRead, &dwWritten,0);

					dwCurDownSize += dwRead;
					dwTotalDownSize += dwRead;
					
					if(dwRead < DOWN_BUFFER_SIZE)
						break;

					if(WaitForSingleObject(pObject->m_hDownloadExit, 0) == WAIT_OBJECT_0){
						nErrorCode = DT_TERMINATE;
						pObject->AddFail(pDownloadFile);
						break;
					}
					if(pObject->m_hWndOwner)
						PostMessage(pObject->m_hWndOwner,WM_DOWNLOAD_FILE, (WPARAM)dwCurDownSize, (LPARAM)dwTotalDownSize);
				}

				CloseHandle(hFileOnDisk);

				if(nErrorCode == DT_OK){
					DeleteFile(pDownloadFile->m_pszLocalFileName);
					MoveFile(strTempFileName, pDownloadFile->m_pszLocalFileName);

					HANDLE hFile;

					hFile = CreateFile(pDownloadFile->m_pszLocalFileName, GENERIC_WRITE, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
					if(hFile != INVALID_HANDLE_VALUE){
						if(!SetFileTime(hFile, &pDownloadFile->m_ftFileTime, &pDownloadFile->m_ftFileTime, &pDownloadFile->m_ftFileTime)){
							int i;
							i = GetLastError();

						}
						CloseHandle(hFile);
					}
				}
				if(pObject->m_hWndOwner)
					PostMessage(pObject->m_hWndOwner, WM_DOWNLOAD_FILE_END, (WPARAM)dwFileCount, (LPARAM)dwTotalFileSize);
			}

			InternetCloseHandle(hHTTPRequest);
			InternetCloseHandle(hHTTPSession);

			if(nErrorCode == DT_TERMINATE)
				break;

			pObject->AddSuccess(pDownloadFile);

		}else{
			InternetCloseHandle(hHTTPRequest);
			InternetCloseHandle(hHTTPSession);

			pObject->AddFail(pDownloadFile);
		}

		dwFileCount ++;
			
	}

	ResetEvent(pObject->m_hDownloading);

	if(pObject->m_hWndOwner)
		PostMessage(pObject->m_hWndOwner, WM_DOWNLOAD_END, (WPARAM)dwFileCount, (LPARAM)dwTotalFileSize);

    return nErrorCode; // thread completed successfully
}
/////////////////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDownloader::CDownloader()
{

}

CDownloader::~CDownloader()
{

}


bool CDownloader::Create(HWND hWndOwner, HINTERNET hInternet){
	m_hWndOwner = hWndOwner;
	m_hInternet = hInternet;

//	m_pOwnerWnd->SendMessage(0, 0, 0);
	// ȭ ü ʱȭ Ѵ.
	InitializeCriticalSection(&m_csDownloadInfo);
	InitializeCriticalSection(&m_csDownloadList);
	InitializeCriticalSection(&m_csSuccessList);
	InitializeCriticalSection(&m_csFailList);
	InitializeCriticalSection(&m_csSkipList);
	m_hDownloadExit = CreateEvent(NULL, TRUE, FALSE, NULL);
	m_hDownloading = CreateEvent(NULL, TRUE, FALSE, NULL);
	m_hDownloadInit = CreateEvent(NULL, TRUE, FALSE, NULL);
	return true;
}

void CDownloader::Destroy(){
	Stop();

	CloseHandle(m_hDownloadExit);
	CloseHandle(m_hDownloading);

	DeleteCriticalSection(&m_csDownloadList);
	DeleteCriticalSection(&m_csDownloadInfo);
}


void CDownloader::AddDownload(CDownloadFile *pDownloadFile){
	EnterCriticalSection(&m_csDownloadList);

	m_DownloadList.AddTail(pDownloadFile);

	LeaveCriticalSection(&m_csDownloadList);

}

CDownloadFile *CDownloader::GetNextDownload(){ 
	//  ٿε ϸ ´
	EnterCriticalSection(&m_csDownloadList);

	if(m_DownloadList.IsEmpty()){
		LeaveCriticalSection(&m_csDownloadList);
		return 0;
	}
	CDownloadFile *pDownloadFile;
	pDownloadFile = (CDownloadFile*)m_DownloadList.GetHead();
	m_DownloadList.RemoveHead();

	LeaveCriticalSection(&m_csDownloadList);

	return pDownloadFile;
}


/*void CDownloader::SetDownloadInfo(DWORD dwTotalFileSize, DWORD dwTotalDownSize, DWORD dwCurFileSize, DWORD dwCurDownSize){
	EnterCriticalSection(&m_csDownloadInfo);

	m_dwTotalFileSize = dwTotalFileSize;
	m_dwTotalDownSize = dwTotalDownSize;
	m_dwCurFileSize = dwCurFileSize;
	m_dwCurDownSize = dwCurDownSize;

	LeaveCriticalSection(&m_csDownloadInfo);
}
*/
/*void CDownloader::GetDownloadInfo(DWORD &dwTotalFileSize, DWORD &dwTotalDownSize, DWORD &dwCurFileSize, DWORD &dwCurDownSize){
	EnterCriticalSection(&m_csDownloadInfo);

	dwTotalFileSize = m_dwTotalFileSize;
	dwTotalDownSize = m_dwTotalDownSize;
	dwCurFileSize = m_dwCurFileSize;
	dwCurDownSize = m_dwCurDownSize;

	LeaveCriticalSection(&m_csDownloadInfo);
}

void CDownloader::SetCurDownFileName(CString &strFileName){
	EnterCriticalSection(&m_csDownloadInfo);

	m_strCurFileName = strFileName;

	LeaveCriticalSection(&m_csDownloadInfo);
}

void CDownloader::GetCurDownFileName(CString &strFileName){
	EnterCriticalSection(&m_csDownloadInfo);

	strFileName = m_strCurFileName;

	LeaveCriticalSection(&m_csDownloadInfo);
}
*/
bool CDownloader::IsDownloading(){
	if(WaitForSingleObject(m_hDownloading, 0) == WAIT_OBJECT_0)
		return true;

	return false;
}

void CDownloader::Start(){
	// ٿε ؾ   ִٸ ٿε 带 Ѵ.
	if(!IsDownloading()){
	//	Stop();
		ResetEvent(m_hDownloadInit);
		SetEvent(m_hDownloading);
		DWORD dwThreadID;
		m_DownloadThread = CreateThread(0, 0, DownloadThreadProc, this, 0, &dwThreadID);
	}
}


void CDownloader::Stop(bool bDelete){
	if(IsDownloading()){
		SetEvent(m_hDownloadExit);
		WaitForSingleObject(m_DownloadThread, INFINITE);
		m_DownloadThread = 0;
	}
	// ٿ     
	while(!m_DownloadList.IsEmpty()){
		if(bDelete)
			delete m_DownloadList.GetHead();
		m_DownloadList.RemoveHead();
	}
	while(!m_SuccessList.IsEmpty()){
		if(bDelete)
			delete m_SuccessList.GetHead();
		m_SuccessList.RemoveHead();
	}
	while(!m_FailList.IsEmpty()){
		if(bDelete)
			delete m_FailList.GetHead();
		m_FailList.RemoveHead();
	}
	while(!m_SkipList.IsEmpty()){
		if(bDelete)
			delete m_SkipList.GetHead();
		m_SkipList.RemoveHead();
	}

	
}

void CDownloader::AddSuccess(CDownloadFile *pDownload){
	EnterCriticalSection(&m_csSuccessList);

	m_SuccessList.AddTail(pDownload);

	LeaveCriticalSection(&m_csSuccessList);
}

void CDownloader::AddFail(CDownloadFile *pDownload){
	EnterCriticalSection(&m_csFailList);

	m_FailList.AddTail(pDownload);

	LeaveCriticalSection(&m_csFailList);
}

void CDownloader::AddSkip(CDownloadFile *pDownload){
	EnterCriticalSection(&m_csSkipList);

	m_SkipList.AddTail(pDownload);

	LeaveCriticalSection(&m_csSkipList);
}

bool CDownloader::IsInitialized(){
	if(WaitForSingleObject(m_hDownloadInit, 0) == WAIT_OBJECT_0)
		return true;

	return false;
}
