// ROGClientLobbyView.cpp : implementation of the CROGClientLobbyView class
//

#include "stdafx.h"
#include "ROGClientLobbyView.h"
#include "ROGClientMainWnd.h"
#include "ROGClient.h"
#include "ROGLobbyProtocol.h"
#include "ROGCreateRoomDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
LRESULT CLobbyEdit::WindowProc( UINT message, WPARAM wParam, LPARAM lParam ){
	switch(message){
	case WM_CHAR:
		if(wParam == '\r'){
			GetParent()->PostMessage (WM_COMMAND, 
				MAKEWPARAM ( GetParent()->GetNextDlgTabItem(this)->GetDlgCtrlID(),
								BN_CLICKED ),
								(LPARAM)m_hWnd );

//			GetParent()->GetNextDlgTabItem(this)->SetFocus();
//			GetParent()->PostMessage(WM_COMMAND, GetDlgCtrlID(), (WPARAM)m_hWnd);
			return 0;
		}
		break;
//	case WM_KEYDOWN:
//		if(wParam == VK_TAB){
//			GetParent()->GetNextDlgTabItem(this)->SetFocus();
//			GetParent()->PostMessage(WM_COMMAND, GetDlgCtrlID(), (WPARAM)m_hWnd);
//			return 0;
//		}
//		break;
/*
#ifdef UNDER_CE
	case WM_SETFOCUS:
		SHSipPreference(m_hWnd, SIP_UP);
		break;

	case WM_KILLFOCUS:
		SHSipPreference(m_hWnd, SIP_DOWN);
		break;
#endif
*/	
	}
	return CEdit::WindowProc(message, wParam, lParam);
}

/*
WNDPROC OldEditWndProc;

LRESULT CALLBACK EditWndProc ( HWND hWnd, UINT iMessage, WPARAM wParam, LPARAM lParam )
{
	switch (iMessage) 
	{
	case WM_KEYDOWN:
		if(wParam == VK_RETURN) 
		{
			::PostMessage (::GetParent(hWnd), WM_COMMAND, 
				MAKEWPARAM( ::GetDlgCtrlID(::GetNextDlgTabItem(hWnd, NULL, FALSE)), BN_CLICKED),
				(LPARAM)hWnd);
				
		//	CROGClientLobbyView::OnSendBtn();			
		}
		break;
	}
	return CallWindowProc (OldEditWndProc, hWnd, iMessage, wParam, lParam);
}
*/

static int xOrg = 0, yOrg = 0;

static RECT rcUserBtn = { 
	xOrg, 
	yOrg + 0, 
	xOrg + 50,
	yOrg + 0 + 24 
};

static RECT rcRoomBtn = { 
	xOrg + 60, 
	yOrg + 0, 
	xOrg + 60 + 50, 
	yOrg + 0 + 24
};

static RECT rcMacroBtn = { 
	xOrg + 120, 
	yOrg + 0, 
	xOrg + 120 + 50, 
	yOrg + 0 + 24 
};

static RECT rcExitBtn = { 
	xOrg + 180, 
	yOrg + 0, 
	xOrg + 180 + 50, 
	yOrg + 0 + 24 
};


static RECT rcChatListEdit = { 0, 160, 0 + 240, 160 + 88 };
static RECT rcChatEdit = { 0, 248, 0 + 200, 248 + 24 };
static RECT rcChatEditFocus = { 0, 260, 0 + 200, 260 + 24 };
static RECT rcSendBtn = { 200, 248, 200 + 40, 248 + 24 };
static RECT rcChildView = { 0, 24, 0 + 240, 24 + 136 };
/////////////////////////////////////////////////////////////////////////////
// CROGClientLobbyView

BEGIN_MESSAGE_MAP(CROGClientLobbyView,CWnd )
	//{{AFX_MSG_MAP(CROGClientLobbyView)
	ON_WM_CREATE()
	ON_WM_PAINT()
	ON_COMMAND(CROGClientLobbyView::CWID_SendBtn, OnSendBtn)
	ON_COMMAND(CROGClientLobbyView::CWID_UserBtn, OnUserBtn)
	ON_COMMAND(CROGClientLobbyView::CWID_RoomBtn, OnRoomBtn)
	ON_COMMAND(CROGClientLobbyView::CWID_MacroBtn, OnMacroBtn)
	ON_COMMAND(CROGClientLobbyView::CWID_ExitBtn, OnExitBtn)
	ON_MESSAGE(ROGCM_RPCCall, OnRPCCall)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

CROGClientLobbyView::CROGClientLobbyView()
{
}

CROGClientLobbyView::~CROGClientLobbyView()
{
}


/////////////////////////////////////////////////////////////////////////////
// CROGClientLobbyView message handlers

BOOL CROGClientLobbyView::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	cs.style &= ~WS_BORDER;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		NULL, HBRUSH(COLOR_WINDOW+1), NULL);

	return TRUE;
}

int CROGClientLobbyView::OnCreate( LPCREATESTRUCT lpCreateStruct ){

	cDisplay &Display = ((CROGClientMainWnd*)GetParent())->m_Display;

	GetRPC()->SendSimplePacket(RPCO_System, ROGLSM_SetLobbyMode);

	m_UserBtn.Create(_T("User"), WS_CHILD | WS_VISIBLE, rcUserBtn, this, CWID_UserBtn);
	m_RoomBtn.Create(_T("Room"), WS_CHILD | WS_VISIBLE, rcRoomBtn, this, CWID_RoomBtn);
	m_MacroBtn.Create(_T("Money"), WS_CHILD | WS_VISIBLE, rcMacroBtn, this, CWID_MacroBtn);
	m_ExitBtn.Create(_T("Exit"), WS_CHILD | WS_VISIBLE, rcExitBtn, this, CWID_ExitBtn);

	
	m_ChatListEdit.Create(WS_CHILD | WS_VISIBLE | ES_READONLY | WS_VSCROLL | ES_MULTILINE, rcChatListEdit, this, CWID_ChatListEdit);
	m_ChatEdit.Create(WS_CHILD | WS_VISIBLE | WS_BORDER , rcChatEdit, this, CWID_ChatEdit);
	m_SendBtn.Create(_T("Send"), WS_CHILD | WS_VISIBLE/* | BS_DEFPUSHBUTTON*/ |WS_TABSTOP, rcSendBtn, this, CWID_SendBtn);

	m_ChatEdit.SendMessage(DM_SETDEFID, CWID_SendBtn, 0); 


	m_PlayerView.Create(0, 0, WS_CHILD, rcChildView, this, CWID_UserView);
	m_RoomView.Create(0, 0, WS_CHILD, rcChildView, this, CWID_RoomView);
	m_MoneyView.Create(0, 0, WS_CHILD, rcChildView, this, CWID_MoneyView);

	m_pChildView = &m_PlayerView;
	m_pChildView->ShowWindow(SW_SHOW);

	m_ChatEdit.SetFocus();

	GetRPC()->SendSimplePacket(RPCO_Owner, ROGLSM_GetName);

	return 0;
}

void CROGClientLobbyView::OnDestroy( ){
//	SetWindowLong (m_ChatEdit.m_hWnd, GCL_WNDPROC, (LONG)OldEditWndProc);
}

void CROGClientLobbyView::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	


}

void CROGClientLobbyView::ChangeChildView(CWnd *pNewChildView){
	m_pChildView->ShowWindow(SW_HIDE);
	m_pChildView = pNewChildView;
	m_pChildView->ShowWindow(SW_SHOW);
}


BOOL CROGClientLobbyView::OnCommand( WPARAM wParam, LPARAM lParam ){
	if(HIWORD (wParam) == EN_CHANGE && LOWORD(wParam) == CWID_ChatEdit){

//		int a = DM_SETDEFID;
//		int b = WM_USER;
//		SendMessage(DM_SETDEFID, CWID_SendBtn, 0);
//                    (WPARAM) IDOK, 
  //                  (LPARAM) 0); 
            
		return TRUE;
	}
	if(HIWORD(wParam) == IDOK && LOWORD(wParam) == CWID_ChatEdit){
		int a;
		a = 0;
	}

	return CWnd::OnCommand(wParam, lParam);
}



cRPC *CROGClientLobbyView::GetRPC(){
	return &((CROGClientMainWnd *)GetParent())->m_RPC;
}

void CROGClientLobbyView::OnSendBtn(){
	TCHAR MyName[20];
	TCHAR buff[200];

	if(!m_ChatEdit.GetWindowText(buff, 200))
		return;

	if(_tcslen(buff) <= 0)
		return;

//	_tcscpy(MyName, _T("noname"));
	_tcscpy(MyName, m_PlayerName);
	AddChat(MyName, buff);

	m_ChatEdit.SetWindowText(_T(""));

	m_ChatEdit.SetFocus();

	cRPCPacket Packet;

	Packet.SetHeader(RPCO_Owner, ROGLSM_AddChat);
	ROGLSM_AddChat_Stub(Packet, buff);
	GetRPC()->SendPacket(&Packet);
//	GetParent()->PostMessage(ROGCM_ChangeChild, ROGCCVC_Lobby, 0);
}

void CROGClientLobbyView::OnUserBtn(){
	ChangeChildView(&m_PlayerView);
}

void CROGClientLobbyView::OnRoomBtn(){
	ChangeChildView(&m_RoomView);
}

void CROGClientLobbyView::OnMacroBtn(){
	// κ  Ӵϸ ˾ƿ´.
	GetRPC()->SendSimplePacket(RPCO_Owner, ROGLSM_GetMoney);

	ChangeChildView(&m_MoneyView);
//  CROGCreateRoomDlg dlg(this);
//	dlg.DoModal();
}

void CROGClientLobbyView::OnExitBtn(){
	// Ʈ  ݴ´.
	GetRPC()->Destroy();

	GetParent()->PostMessage(ROGCM_ChangeChild, ROGCCVC_Login, 0);
}

void CROGClientLobbyView::WisperChat(LPCTSTR to){
	cRPCPacket Packet;
	TCHAR MyName[20];
	TCHAR buff[200];

	if(!m_ChatEdit.GetWindowText(buff, 200))
		return;

	if(_tcslen(buff) <= 0)
		return;

//	_tcscpy(MyName, _T("[noname]"));
	_tcscpy(MyName, m_PlayerName);
	AddChat(MyName, buff);

	m_ChatEdit.SetWindowText(_T(""));

	m_ChatEdit.SetFocus();

	Packet.SetHeader(RPCO_Owner, ROGLSM_WisperChat);
	ROGLSM_WisperChat_Stub(Packet, (LPTSTR)to, buff);
	GetRPC()->SendPacket(&Packet);
}

void CROGClientLobbyView::AddChat(LPCTSTR Name, LPCTSTR Chat){
	TCHAR strLine[256];

	_stprintf(strLine, _T("%s: %s\r\n"), Name, Chat);

	int nLen;
	nLen = m_ChatListEdit.GetWindowTextLength();
	m_ChatListEdit.SetSel(nLen, nLen);
	m_ChatListEdit.ReplaceSel(strLine);
	m_ChatListEdit.PostMessage(WM_VSCROLL, (WPARAM)SB_BOTTOM, 0);
	
	if(m_ChatListEdit.GetLineCount() > 100){
		m_ChatListEdit.SetSel(0, m_ChatListEdit.GetLine(0, strLine, 256) + 2, TRUE);
		m_ChatListEdit.ReplaceSel(_T(""), FALSE);
	}
}


LRESULT CROGClientLobbyView::OnRPCCall(WPARAM wParam, LPARAM lParam){
	cRPCPacket *pPacket;
	pPacket = (cRPCPacket *)lParam;

	switch(pPacket->GetObjectID()){
	case ROGLCO_Lobby:
		switch(wParam){
		case ROGLCM_AddChat:
			TCHAR PlayerName[20];
			TCHAR Chat[200];
			ROGLCM_AddChat_Stub(*pPacket, PlayerName, Chat);
			AddChat(PlayerName, Chat);
			break;

		case ROGLCM_SetName:
			TCHAR PName[20];
			*pPacket + PName;
			m_PlayerName = PName;
			break;
		}
		break;

	case ROGLCO_PlayerView:
		return m_PlayerView.SendMessage(ROGCM_RPCCall, wParam, lParam);

	case ROGLCO_RoomView:
		return m_RoomView.SendMessage(ROGCM_RPCCall, wParam, lParam);
	
	case ROGLCO_MoneyView:
		return m_MoneyView.SendMessage(ROGCM_RPCCall, wParam, lParam);
	default:
		ASSERT(FALSE);
		break;
	}

	return TRUE;

}

