#ifndef CROGClientLobbyView_H
#define CROGClientLobbyView_H

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ROGLobbyProtocol.h"
#include "cPicture.h"
#include "ROGClientPlayerView.h"
#include "ROGClientRoomView.h"
#include "ROGClientMoneyView.h"

/////////////////////////////////////////////////////////////////////////////
// CROGClientLobbyView window
class cRPC;

class CLobbyEdit : public CEdit
{
public:
	virtual LRESULT WindowProc( UINT message, WPARAM wParam, LPARAM lParam );

};

class CROGClientLobbyView : public CWnd
{
protected:
	enum eChildWindowID{
		CWID_UserBtn = 1,
		CWID_RoomBtn,
		CWID_MacroBtn,
		CWID_ExitBtn,
		CWID_SendBtn,
		CWID_ChatListEdit,
		CWID_ChatEdit,
		CWID_UserView,
		CWID_RoomView,
		CWID_MoneyView,
	};

	CButton			m_UserBtn;
	CButton			m_RoomBtn;
	CButton			m_MacroBtn;
	CButton			m_ExitBtn;
	CButton			m_SendBtn;
	CEdit			m_ChatListEdit;
	CLobbyEdit		m_ChatEdit;
	CString			m_PlayerName;
//	WNDPROC			m_OldEditWndProc;

	cRPC *GetRPC();

	CROGClientPlayerView	m_PlayerView;
	CROGClientRoomView		m_RoomView;
	CROGClientMoneyView		m_MoneyView;	

	CWnd*			m_pChildView;

	void ChangeChildView(CWnd *pNewChildView);

	void AddChat(LPCTSTR Name, LPCTSTR Chat);

	//{{AFX_MSG(CROGClientLobbyView)
	afx_msg int OnCreate( LPCREATESTRUCT lpCreateStruct );
	afx_msg void OnDestroy( );
	afx_msg void OnPaint();
	afx_msg LRESULT OnRPCCall(WPARAM wParam, LPARAM lParam);
	afx_msg void OnSendBtn();
	afx_msg void OnUserBtn();
	afx_msg void OnRoomBtn();
	afx_msg void OnMacroBtn();
	afx_msg void OnExitBtn();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

public:
	CROGClientLobbyView();
	virtual ~CROGClientLobbyView();

	void WisperChat(LPCTSTR to);
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CROGClientLobbyView)
	protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL OnCommand( WPARAM wParam, LPARAM lParam );
	//}}AFX_VIRTUAL

};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft eMbedded Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ROGClientLobbyView_H__045A435F_9A98_49CC_A5CA_3CBCA46CDB1E__INCLUDED_)
