// ROGClientLoginView.cpp : implementation of the CROGClientLoginView class
//

#include "stdafx.h"
#include "ROGClientLoginView.h"
#include "ROGClientMainWnd.h"
#include "ROGClient.h"
#include "ROGLobbyProtocol.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

static RECT rcIDStatic = { 0, 0, 0 + 60, 0 + 24 };
static RECT rcPasswordStatic = { 0, 24, 0 + 60, 24 + 24 };
static RECT rcUserIDEdit = { 80, 0, 80 + 120, 0 + 24 };
static RECT rcPasswordEdit = { 80, 24, 80 + 120, 24 + 24 };
static RECT rcLoginBtn = { 0, 80, 0 + 60, 80 + 24 };
static RECT rcNewBtn = { 80, 80, 80 + 60, 80 + 24 };
static RECT rcExitBtn = { 160, 80, 160 + 60, 80 + 24 };




/*
WNDPROC PrevEditWndProc;
//WNDPROC PrevPasswordWndProc;

LRESULT CALLBACK EditWndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam){
	switch(uMsg){
	case WM_CHAR:
		if(wParam == '\n'){
			::PostMessage(::GetParent(hWnd), WM_COMMAND, ::GetDlgCtrlID(hWnd), (WPARAM)hWnd);
		}else if(wParam == '\t'){
			::PostMessage(::GetParent(hWnd), WM_COMMAND, ::GetDlgCtrlID(hWnd), (WPARAM)hWnd);
		}
		break;
	case WM_KEYDOWN:
		if(wParam == VK_RETURN){
			int i;
			i = 0;

		}
		break;

	}
	return CallWindowProc(PrevEditWndProc, hWnd, uMsg, wParam, lParam);
}
*/
/////////////////////////////////////////////////////////////////////////////
// CROGClientLoginView


CROGClientLoginView::CROGClientLoginView(){
}

CROGClientLoginView::~CROGClientLoginView()
{
}


BEGIN_MESSAGE_MAP(CROGClientLoginView,CWnd )
	//{{AFX_MSG_MAP(CROGClientLoginView)
	ON_WM_CREATE()
	ON_WM_PAINT()
	ON_COMMAND(CROGClientLoginView::CWID_UserIDEdit, OnUserIDEdit)
	ON_COMMAND(CROGClientLoginView::CWID_PasswordEdit, OnPasswordEdit)
	ON_COMMAND(CROGClientLoginView::CWID_LoginBtn, OnLoginBtn)
	ON_COMMAND(CROGClientLoginView::CWID_NewBtn, OnNewBtn)
	ON_COMMAND(CROGClientLoginView::CWID_ExitBtn, OnExitBtn)
	ON_MESSAGE(WM_NEXTDLGCTL, OnNextDlgCtl)
	ON_WM_KEYDOWN()
	ON_MESSAGE(ROGCM_RPCCall, OnRPCCall)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CROGClientLoginView message handlers
LRESULT CROGClientLoginView::OnRPCCall(WPARAM wParam, LPARAM lParam){
	cRPCPacket *pPacket;
	pPacket = (cRPCPacket *)lParam;

	switch(pPacket->GetObjectID()){
	case RPCO_Owner:
		switch(wParam){
		case ROGLCM_LoginResult:
			{
				char Success;
				ROGLCM_LoginResult_Stub(*pPacket, Success);
				LoginResult(Success == 1);
			}
			break;
		default:
			ASSERT(FALSE);
			break;


		}
		break;
	default:
		ASSERT(FALSE);

	}

	return TRUE;

}

void CROGClientLoginView::LoginResult(bool Success){
	if(Success){
		GetParent()->PostMessage(ROGCM_ChangeChild, ROGCCVC_Lobby, 0);

	}else{
		((CROGClientMainWnd*)GetParent())->CloseRPC();
		MessageBox(_T("failed to login."), _T("error"), MB_OK);
	}

}

BOOL CROGClientLoginView::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	cs.style &= ~WS_BORDER;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		NULL, HBRUSH(COLOR_WINDOW+1), NULL);

	return TRUE;
}

int CROGClientLoginView::OnCreate( LPCREATESTRUCT lpCreateStruct ){

	cDisplay &Display = ((CROGClientMainWnd*)GetParent())->m_Display;

	//Display.Create(m_hWnd);

	m_IDStatic.Create		(_T("ID"),		WS_CHILD | WS_VISIBLE, rcIDStatic, this, CWID_IDStatic);
	m_PasswordStatic.Create	(_T("Passwd"),	WS_CHILD | WS_VISIBLE, rcPasswordStatic, this, CWID_PasswordStatic);
	m_UserIDEdit.Create		(WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP, rcUserIDEdit, this, CWID_UserIDEdit);
//	m_UserIDEdit.SendMessage(DM_SETDEFID, (WPARAM) CWID_LoginBtn, (LPARAM) 0); 

//	PrevEditWndProc = (WNDPROC)GetClassLong(m_UserIDEdit.m_hWnd, GCL_WNDPROC);
//	SetClassLong(m_UserIDEdit.m_hWnd, GCL_WNDPROC, (LONG)EditWndProc);
	m_PasswordEdit.Create	(WS_CHILD | WS_VISIBLE | WS_BORDER | ES_PASSWORD | WS_TABSTOP, rcPasswordEdit, this, CWID_PasswordEdit);
//	PrevPasswordWndProc = (WNDPROC)GetClassLong(m_PasswordEdit.m_hWnd, GCL_WNDPROC);
//	SetClassLong(m_PasswordEdit.m_hWnd, GCL_WNDPROC, (LONG)PasswordWndProc);
	m_LoginBtn.Create		(_T("Login"), WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_DEFPUSHBUTTON, rcLoginBtn, this, CWID_LoginBtn);
	m_NewBtn.Create			(_T("New"), WS_CHILD | WS_VISIBLE | WS_TABSTOP, rcNewBtn, this, CWID_NewBtn);
	m_ExitBtn.Create		(_T("Exit"), WS_CHILD | WS_VISIBLE | WS_TABSTOP, rcExitBtn, this, CWID_ExitBtn);
	SendMessage(DM_SETDEFID, (WPARAM) CWID_LoginBtn, (LPARAM) 0); 

	m_UserIDEdit.SetFocus();

	((CROGClientMainWnd*)GetParent())->CloseRPC();

	m_IDStatic.SetFocus();

	return 0;
}

void CROGClientLoginView::OnDestroy( ){

//	cROGDisplay &Display = ((CROGClientMainWnd*)GetParent())->m_Display;

//	m_TitlePic.Destroy();
//	Display.Destroy();

}

void CROGClientLoginView::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	
	// Do not call CWnd::OnPaint() for painting messages
//	cROGDisplay &Display = ((CROGClientMainWnd*)GetParent())->m_Display;
//	Display.GetBackPic()->Blt(0, 0, &m_TitlePic);
//	Display.Flip();

//	m_StartBtn.Invalidate();
//	m_ExitBtn.Invalidate();

}


BOOL CROGClientLoginView::OnCommand( WPARAM wParam, LPARAM lParam ){
	return CWnd::OnCommand(wParam, lParam);
}



cRPC *CROGClientLoginView::GetRPC(){
	return &((CROGClientMainWnd *)GetParent())->m_RPC;
}

void CROGClientLoginView::OnUserIDEdit(){
	m_PasswordEdit.SetFocus();
}

void CROGClientLoginView::OnPasswordEdit(){
	m_UserIDEdit.SetFocus();
}


void CROGClientLoginView::OnLoginBtn(){
	cRPCPacket Packet;



	if(!((CROGClientMainWnd*)GetParent())->OpenRPC()){
//		DWORD dwErr  = GetLastError();
//		LPTSTR str;
//		_stsprintf(str, _T("$%d"), dwErr);

		//  ׽Ʈ    ٵ Ǿ ִ.
		//    Ȯ ó ־ ϰڴ.
		MessageBox(_T("Network connect fail."), _T("error"), MB_OK);
		//ASSERT(!"OnLoginBtn::OpenRPC() fail.");
		return;
	}


	Packet.SetHeader(RPCO_Owner, ROGLSM_Login);

	TCHAR PlayerName[20];
	TCHAR Password[20];

	m_UserIDEdit.GetWindowText(PlayerName, 20);
	m_PasswordEdit.GetWindowText(Password, 20);
	ROGLSM_Login_Stub(Packet, PlayerName, Password);
	GetRPC()->SendPacket(&Packet);
}

void CROGClientLoginView::OnNewBtn(){
	GetParent()->PostMessage(ROGCM_ChangeChild, ROGCCVC_NewUser, 0);
}

void CROGClientLoginView::OnExitBtn(){

#ifdef UNDER_CE
	PostQuitMessage(0);
#else
	GetParent()->PostMessage(ROGCM_ChangeChild, ROGCCVC_Title, 0);
#endif
	

}




void CROGClientLoginView::OnKeyDown( UINT nChar, UINT nRepCnt, UINT nFlags ){
	int i;
	i = 0;
}


LRESULT CROGClientLoginView::OnNextDlgCtl(WPARAM wParam, LPARAM lParam){
	int i;
	i = 0;

	return 0;
}

