// MainFrm.cpp : implementation of the CROGClientMainWnd class
//

#include "stdafx.h"

#include "ROGClientMainWnd.h"
#include "ROGClient.h"
#include "ROGClientTitleView.h"
#include "ROGClientLobbyView.h"
#include "ROGClientLoginView.h"
#include "ROGClientNewUserView.h"
#include "ROGClientUpgradeView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CWnd *ROGCreateChildView(int ChildID);
extern void ROGDestroyChildView(int ChildID, CWnd *pWnd);

/////////////////////////////////////////////////////////////////////////////
// CROGClientMainWnd

IMPLEMENT_DYNAMIC(CROGClientMainWnd, CWnd)

BEGIN_MESSAGE_MAP(CROGClientMainWnd, CWnd)
	//{{AFX_MSG_MAP(CROGClientMainWnd)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_SETFOCUS()
	ON_WM_TIMER()
	ON_MESSAGE(ROGCM_ChangeChild, OnChangeChild)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CROGClientMainWnd construction/destruction

CROGClientMainWnd::CROGClientMainWnd()
{
	m_pClientInfo = 0;
}

CROGClientMainWnd::~CROGClientMainWnd()
{
	if(m_pClientInfo)
		delete m_pClientInfo;
}

bool CROGClientMainWnd::Create(CWnd *pParentWnd, UINT nID, sROGClientInfo *ClientInfo){
	CRect rcClient;
	rcClient.SetRect(0, 0, 240, 320);

	m_pClientInfo = new sROGClientInfo;
	memcpy(m_pClientInfo, ClientInfo, sizeof(sROGClientInfo));

#ifdef UNDER_CE
	m_strInstallPath.Format(_T("program files\\renodigm\\%s"), m_pClientInfo->GameID);
#else
	TCHAR pszWindowsPath[MAX_PATH];
	GetWindowsDirectory(pszWindowsPath, MAX_PATH);
	m_strInstallPath.Format(_T("%c:\\program files\\renodigm\\%s"), pszWindowsPath[0], m_pClientInfo->GameID);

#endif


	if(!CWnd::Create(NULL, NULL, WS_CHILD | WS_VISIBLE, rcClient, pParentWnd, nID, NULL))
		return false;

	SetFocus();

	return true;	
}


int CROGClientMainWnd::OnCreate(LPCREATESTRUCT lpCreateStruct){
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	m_pChildView = CreateChildView(0);
	if(!m_pChildView){
		TRACE0("Failed to create view window\n");
		return -1;
	}

	//   ̺귯 ʱȭ
	WSADATA wsaData;
	if(WSAStartup(MAKEWORD(2, 2), &wsaData ) != 0){
		ASSERT(!"CROGClientMainWnd::OpenRPC()::WSAStartup() fail.");
		return false;
	}

	// ÷ ʱȭ
	if(!m_Display.Create(m_hWnd)){
		ASSERT(_T("Faile to init display."));
		return -1;
	}
#ifndef UNDER_CE
	PostMessage(ROGCM_ChangeChild, ROGCCVC_Upgrade, 0);
#else
	PostMessage(ROGCM_ChangeChild, ROGCCVC_Title, 0);
#endif

	return 0;
}

void CROGClientMainWnd::OnDestroy(){
	DestroyChildView();
	
	m_Display.Destroy();
	m_RPC.Destroy();
}



BOOL CROGClientMainWnd::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs


	cs.lpszClass = AfxRegisterWndClass(0);

	cs.style = cs.style & ~WS_CLIPCHILDREN;
	return TRUE;
}



LPTSTR CROGClientMainWnd::MakeString(UINT stringID)
{
	TCHAR buffer[255];
	TCHAR* theString;

	::LoadString(AfxGetInstanceHandle(), stringID, buffer, 255);
	theString = new TCHAR[lstrlen(buffer) + 1];
	lstrcpy(theString, buffer);
	return theString;
}   

 
bool CROGClientMainWnd::OpenRPC(const char *ServerIP, int ServerPort){
	if(ServerIP == 0){
		if(!m_RPC.CreateClient(m_pClientInfo->ServerAddr, m_pClientInfo->ServerPort))
			return false;
	}else if(ServerPort == 0){
		if(!m_RPC.CreateClient(ServerIP, m_pClientInfo->ServerPort))
			return false;
	}else{
		if(!m_RPC.CreateClient(ServerIP, ServerPort))
			return false;
	}
	SetTimer(100, 100, 0);
	return true;
}

void CROGClientMainWnd::CloseRPC(){
	m_RPC.Destroy();
	KillTimer(100);
}

/////////////////////////////////////////////////////////////////////////////
// CROGClientMainWnd diagnostics

#ifdef _DEBUG
void CROGClientMainWnd::AssertValid() const
{
	CWnd::AssertValid();
}

void CROGClientMainWnd::Dump(CDumpContext& dc) const
{
	CWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CROGClientMainWnd message handlers
void CROGClientMainWnd::OnSetFocus(CWnd* pOldWnd)
{
	// forward focus to the view window
	if(m_pChildView && m_pChildView->m_hWnd)
		m_pChildView->SetFocus();
}

BOOL CROGClientMainWnd::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo)
{
	// let the view have first crack at the command
	if (m_pChildView->OnCmdMsg(nID, nCode, pExtra, pHandlerInfo))
		return TRUE;

	// otherwise, do default handling
	return CWnd::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}

LRESULT CROGClientMainWnd::OnChangeChild(WPARAM wParam, LPARAM lParam){
	//
	DestroyChildView();
	m_pChildView = CreateChildView(wParam);
	m_pChildView->ShowWindow(SW_SHOW);


	
	if(wParam >= ROGCCVC_Count || wParam == ROGCCVC_Title)
		SetFullScreen();
	else
		RestoreFullScreen();

	return 0;
}

CWnd *CROGClientMainWnd::CreateChildView(int ChildViewID){
	CWnd *pNewChild;

	switch(ChildViewID){
	case ROGCCVC_Default:
		pNewChild = &m_wndView;
		break;

	case ROGCCVC_Upgrade:
		pNewChild = new CROGClientUpgradeView;
		break;

	case ROGCCVC_Title:
		pNewChild = new CROGClientTitleView;
		break;
	case ROGCCVC_Lobby:
		pNewChild = new CROGClientLobbyView;
		break;
	case ROGCCVC_Login:
		pNewChild = new CROGClientLoginView;
		break;
	case ROGCCVC_NewUser:
		pNewChild = new CROGClientNewUserView;
		break;
	default:
		pNewChild = ROGCreateChildView(ChildViewID);
		break;
	}

	if(pNewChild){
		CRect rcClient;
		GetClientRect(rcClient);
		if (!pNewChild->Create(NULL, NULL, WS_CHILD | WS_VISIBLE | WS_CLIPCHILDREN, rcClient, this, 0, NULL)){
			TRACE0("Failed to create view window\n");
			return 0;//pNewChild = &m_wndView;
		}
	}else{
		return 0;
	}
	m_ChildViewID = ChildViewID;

	return pNewChild;

}

void CROGClientMainWnd::DestroyChildView(){
	if(m_ChildViewID < ROGCCVC_Count){
		CWnd		*pChildView;
		pChildView		= m_pChildView;
		m_pChildView	= 0;
		pChildView->DestroyWindow();
		if(m_ChildViewID > 0){
			delete pChildView;
		}
	}else{
		m_pChildView->DestroyWindow();
		ROGDestroyChildView(m_ChildViewID, m_pChildView);
	}
	m_pChildView = &m_wndView;
	m_ChildViewID = 0;

}

void CROGClientMainWnd::OnTimer( UINT nIDEvent ){
	if(nIDEvent == 101){
		SetFullScreen();
		KillTimer(101);
		return;
	}
	if(nIDEvent == 100){
		// Ʈ ޽ ó
		cRPCPacket *pPacket;
		bool Continue = true;

		while(Continue){
			pPacket = m_RPC.PeekPacket();
			if(pPacket){
				pPacket = m_RPC.GetPacket();
				if(pPacket->GetObjectID() == RPCO_RPC){
					switch(pPacket->GetMethodID()){
					case RPCM_Close:
						// Ʈ  ݴ´.
						CloseRPC();
						MessageBox(_T("Connection closed"));
						PostMessage(ROGCM_ChangeChild, ROGCCVC_Login, 0);
						Continue = false;
						break;
					default:
						ASSERT(FALSE);
						break;
					}
					m_RPC.DestroyPacket(pPacket);
				}else{
					m_pChildView->SendMessage(ROGCM_RPCCall, pPacket->GetMethodID(), (LPARAM)pPacket);
					m_RPC.DestroyPacket(pPacket);
				}
			}else{
				Continue = false;
			}
		}
	}
}



void CROGClientMainWnd::SetFullScreen() // üȭ   
{
#ifdef UNDER_CE	
	//  츦 ֻ  Ѵ.
	SHINITDLGINFO shidi;
	shidi.dwMask  = SHIDIM_FLAGS;
	shidi.dwFlags = SHIDIF_FULLSCREENNOMENUBAR;
	shidi.hDlg    = AfxGetMainWnd()->m_hWnd;

	SHInitDialog(&shidi);
	AfxGetMainWnd()->BringWindowToTop();

	// ½ũ ٸ Ⱥ̰ Ѵ.
	SHSipPreference(AfxGetMainWnd()->m_hWnd, SIP_FORCEDOWN);
	SHFullScreen(AfxGetMainWnd()->m_hWnd,SHFS_HIDESIPBUTTON);	
	SHFullScreen(AfxGetMainWnd()->m_hWnd,SHFS_HIDETASKBAR);	

	// â ü ȭ  ̵Ų.
	AfxGetMainWnd()->ModifyStyle(WS_CAPTION | WS_SYSMENU, WS_POPUP);
	AfxGetMainWnd()->MoveWindow(0, 0, 240, 320, TRUE);
	MoveWindow(0, 0, 240, 320, TRUE);
#endif
}

void CROGClientMainWnd::RestoreFullScreen(){
	AfxGetMainWnd()->MoveWindow(0, 24, 240, 320 - 48, TRUE);
	SHFullScreen(AfxGetMainWnd()->m_hWnd,SHFS_SHOWTASKBAR);	
	SHFullScreen(AfxGetMainWnd()->m_hWnd,SHFS_SHOWSIPBUTTON);	

}


bool CROGClientMainWnd::GetInstallPath(LPTSTR Path, int BuffSize){
	if(BuffSize <= m_strInstallPath.GetLength()){
		TRACE(_T("You need BuffSize > %d\n"), m_strInstallPath.GetLength());
	}
	_tcscpy(Path, m_strInstallPath);
	return true;
}

CString CROGClientMainWnd::GetResourcePath(LPTSTR FileName){
	//TCHAR Buff[MAX_PATH];
	TCHAR Buff[MAX_PATH];

	GetInstallPath(Buff);

	_tcscat(Buff, _T("\\"));
	_tcscat(Buff, FileName);

	return Buff;
}










