#ifndef CROGClientMainWnd_H
#define CROGClientMainWnd_H

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "ROGClientView.h"
#include "cRPC.h"
#include "cDisplay.h"
#include "cSoundplayer.h"

enum eROGClientChildViewClassID{
	ROGCCVC_Default,
	ROGCCVC_Upgrade,
	ROGCCVC_Title,
	ROGCCVC_Lobby,
	ROGCCVC_Login,
	ROGCCVC_NewUser,
	ROGCCVC_Count
};

struct sROGClientInfo{
	TCHAR GameID[30];
	char ServerAddr[MAX_PATH];
	int ServerPort;

	TCHAR	UpgradeServerURL[MAX_PATH];		// ex) www.renodigm.com   ٿε ġ www.renodigm.com/Download/[GameID]/filelist.txt
	int		UpgradeServerPort;				//
	CWnd *(*CreateChildView)(int ChildID);
};


class CROGClientMainWnd : public CWnd{
public:
	cRPC				m_RPC;
	cDisplay			m_Display;

	CWnd				*m_pChildView;
	sROGClientInfo		*m_pClientInfo;

	CROGClientMainWnd();
	virtual ~CROGClientMainWnd();

	bool Create(CWnd *pParentWnd, UINT nID, sROGClientInfo *ClientInfo);

	void SetFullScreen();			// üȭ   
	void RestoreFullScreen();

	// Ʈ 
	bool OpenRPC(const char * ServerIP = 0, int ServerPort = 0);
	void CloseRPC();
	
	bool GetInstallPath(LPTSTR Path, int BuffSize = MAX_PATH);
	CString GetResourcePath(LPTSTR FileName);

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	//{{AFX_VIRTUAL(CROGClientMainWnd)
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);
	//}}AFX_VIRTUAL
protected: 
	DECLARE_DYNAMIC(CROGClientMainWnd)

	CROGClientView		m_wndView;
	int					m_ChildViewID;

	CWnd				*CreateChildView(int ChildViewID);
	void				DestroyChildView();

	CString				m_strInstallPath;

	//{{AFX_MSG(CROGClientMainWnd)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy( ); 
	afx_msg void OnSetFocus(CWnd *pOldWnd);
	afx_msg LRESULT OnChangeChild(WPARAM wParam, LPARAM lParam);
	afx_msg void OnTimer( UINT nIDEvent );

	LPTSTR MakeString(UINT stringID);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

//{{AFX_INSERT_LOCATION}}
// Microsoft eMbedded Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINFRM_H__ED4225EA_01D2_43C9_B5FF_EB7EF289E755__INCLUDED_)
