// ROGClientMoneyView.cpp : implementation file
//

#include "stdafx.h"
#include "ROGClientMainWnd.h"
#include "ROGClientMoneyView.h"
#include "ROGLobbyProtocol.h"
#include "ROGClient.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


#define RECT_INIT(x, y, w, h) { (x), (y), (x) + (w), (y) + (h) }

static int Left1 = 8;
static int Top1 = 8;
static int yDist1 = 24;
static int Width1 = 100;
static int Height1 = 20;

static int Left2 = 120;
static int Width2 = 100;

static RECT rcMoneyStatic		= RECT_INIT(Left1, Top1 + yDist1 * 0, Width1, Height1);
static RECT rcChipStatic		= RECT_INIT(Left1, Top1 + yDist1 * 1, Width1, Height1);
static RECT rcExplanationStatic	= RECT_INIT(Left1, Top1 + yDist1 * 2, Width1 + Width2, Height1);
static RECT rcChangeStatic		= RECT_INIT(Left1, Top1 + yDist1 * 3, Width1, Height1);

static RECT rcMoneyEdit		= RECT_INIT(Left2, Top1 + yDist1 * 0, Width2, Height1);
static RECT rcChipEdit		= RECT_INIT(Left2, Top1 + yDist1 * 1, Width2, Height1);
static RECT rcChangeEdit	= RECT_INIT(Left2, Top1 + yDist1 * 3, Width2, Height1);

static RECT rcToChipBtn = RECT_INIT(8, 104, 104, 24);
static RECT rcToMoneyBtn = RECT_INIT(120, 104, 104, 24);

/////////////////////////////////////////////////////////////////////////////
// CROGClientMoneyView

CROGClientMoneyView::CROGClientMoneyView()
{

	m_nMoney = 0;
	m_nChip = 0;
}

CROGClientMoneyView::~CROGClientMoneyView()
{
}


BEGIN_MESSAGE_MAP(CROGClientMoneyView, CWnd)
	//{{AFX_MSG_MAP(CROGClientMoneyView)
	ON_WM_CREATE()
	ON_COMMAND(CROGClientMoneyView::CWID_ToChipBtn, OnToChipBtn)
	ON_COMMAND(CROGClientMoneyView::CWID_ToMoneyBtn, OnToMoneyBtn)
	ON_MESSAGE(ROGCM_RPCCall, OnRPCCall)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CROGClientMoneyView message handlers

BOOL CROGClientMoneyView::PreCreateWindow(CREATESTRUCT& cs) 
{
	// TODO: Add your specialized code here and/or call the base class
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	cs.style &= ~WS_BORDER;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		NULL, HBRUSH(COLOR_WINDOW+1), NULL);

	return TRUE;
	

}



int CROGClientMoneyView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	// κ  Ӵϸ ˾ƿ´.
	GetRPC()->SendSimplePacket(RPCO_Owner, ROGLSM_GetMoney);
	
	// TODO: Add your specialized creation code here
	m_MoneyStatic.Create(_T("̹ Ӵ"),		WS_CHILD | WS_VISIBLE, rcMoneyStatic, this, CWID_MoneyStatic);
	m_ChipStatic.Create(_T(" Ĩ"),	WS_CHILD | WS_VISIBLE, rcChipStatic, this, CWID_ChipStatic);
	m_ExplanationStatic.Create(_T(" 1   Ĩ Ѱ Դϴ"),	WS_CHILD | WS_VISIBLE, rcExplanationStatic, this, CWID_ExplanationStatic);
	m_ChangeStatic.Create(_T("ȯ "),	WS_CHILD | WS_VISIBLE, rcChangeStatic, this, CWID_ChangeStatic);

	m_MoneyEdit.Create		(WS_CHILD | WS_VISIBLE | WS_BORDER, rcMoneyEdit, this, CWID_MoneyEdit);
	m_ChipEdit.Create		(WS_CHILD | WS_VISIBLE | WS_BORDER, rcChipEdit, this, CWID_ChipEdit);
	m_ChangeEdit.Create		(WS_CHILD | WS_VISIBLE | WS_BORDER, rcChangeEdit, this, CWID_ChangeEdit);

	m_MoneyEdit.SetReadOnly(TRUE);
	m_ChipEdit.SetReadOnly(TRUE);
	
	m_ToChipBtn.Create(_T("Ĩ ȯ"), WS_CHILD | WS_VISIBLE, rcToChipBtn, this, CWID_ToChipBtn);
	m_ToMoneyBtn.Create(_T(" ȯ"), WS_CHILD | WS_VISIBLE, rcToMoneyBtn, this, CWID_ToMoneyBtn);


	
	return 0;
}


cRPC *CROGClientMoneyView::GetRPC(){
	return &((CROGClientMainWnd *)GetParent()->GetParent())->m_RPC;
}

void CROGClientMoneyView::OnToChipBtn(){


	TCHAR ChipNumber[10];
	int nChipNumber;
	

	if(m_ChangeEdit.GetWindowText(ChipNumber, 10) == 0){
		MessageBox(_T("You should write number"));
		m_ChangeEdit.SetFocus();
		return;
	}

	for(int i = 0; i < 10; i++){
		if(ChipNumber[i] == NULL){
			break;
		}
		else{
			if(isdigit(ChipNumber[i]))
				continue;
			else{
				MessageBox(_T("You should write number"));
				return;
			}
		}	
	}

	
	nChipNumber = _ttoi(ChipNumber);


	if(nChipNumber > m_nMoney){
		MessageBox(_T("You should write less Money number"));
		SetMoneyEdit();
		return;
	}

	
	cRPCPacket Packet;
	Packet.SetHeader(RPCO_Owner, ROGLSM_SetChipNumber);
	ROGLSM_SetChipNumber_Stub(Packet, nChipNumber);
	GetRPC()->SendPacket(&Packet);


	//GetParent()->PostMessage(ROGCM_ChangeChild, ROGCCVC_Lobby, 0);
	

}

void CROGClientMoneyView::OnToMoneyBtn(){


	TCHAR ChipNumber[10];
	int nChipNumber;
	

	if(m_ChangeEdit.GetWindowText(ChipNumber, 10) == 0){
		MessageBox(_T("You should write number"));
		m_ChangeEdit.SetFocus();
		return;
	}

	for(int i = 0; i < 10; i++){
		if(ChipNumber[i] == NULL){
			break;
		}
		else{
			if(isdigit(ChipNumber[i]))
				continue;
			else{
				MessageBox(_T("You should write number"));
				return;
			}
		}	
	}

	
	nChipNumber = _ttoi(ChipNumber);


	if(nChipNumber > m_nChip){
		MessageBox(_T("You should write less chip number"));
		SetMoneyEdit();
		return;
	}

	
	cRPCPacket Packet;
	Packet.SetHeader(RPCO_Owner, ROGLSM_SetMoneyNumber);
	ROGLSM_SetMoneyNumber_Stub(Packet, nChipNumber);
	GetRPC()->SendPacket(&Packet);


//	GetParent()->PostMessage(ROGCM_ChangeChild, ROGCCVC_Lobby, 0);
	



}



LRESULT CROGClientMoneyView::OnRPCCall(WPARAM wParam, LPARAM lParam){
	cRPCPacket *pPacket;
	pPacket = (cRPCPacket *)lParam;


	
	switch(wParam){
	case ROGLCM_SetMoney:
		{
			
			ROGLCM_SetMoney_Stub(*pPacket, m_nMoney, m_nChip);
			SetMoneyEdit();
			
		}
		break;


	default:
		ASSERT(FALSE);
		break;


	}
	

	return TRUE;

}


void CROGClientMoneyView::SetMoneyEdit(){


	TCHAR strMoney[10];
	TCHAR strChip[10];
	

	_itot(m_nMoney, strMoney, 10);
	_itot(m_nChip, strChip, 10);

	m_MoneyEdit.SetWindowText(strMoney);
	m_ChipEdit.SetWindowText(strChip);

}