// ROGClientNewUserView.cpp : implementation of the CROGClientNewUserView class
//

#include "stdafx.h"
#include "ROGClientNewUserView.h"
#include "ROGClientMainWnd.h"
#include "ROGClient.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define RECT_INIT(x, y, w, h) { (x), (y), (x) + (w), (y) + (h) }

static int Left1 = 8;
static int Top1 = 8;
static int yDist1 = 24;
static int Width1 = 70;
static int Height1 = 20;

static RECT rcIDStatic			= RECT_INIT(Left1, Top1 + yDist1 * 0, Width1, Height1);
static RECT rcPasswordStatic	= RECT_INIT(Left1, Top1 + yDist1 * 1, Width1, Height1);
static RECT rcConfirmStatic		= RECT_INIT(Left1, Top1 + yDist1 * 2, Width1, Height1);
static RECT rcEmailStatic		= RECT_INIT(Left1, Top1 + yDist1 * 3, Width1, Height1);
static RECT rcGenderStatic		= RECT_INIT(Left1, Top1 + yDist1 * 4, Width1, Height1);
static RECT rcBirthYearStatic	= RECT_INIT(Left1, Top1 + yDist1 * 5, Width1, Height1);

static int Left2 = 80;
static int Width2 = 160;

static RECT rcUserIDEdit		= RECT_INIT(Left2, Top1 + yDist1 * 0, Width2, Height1);
static RECT rcPasswordEdit		= RECT_INIT(Left2, Top1 + yDist1 * 1, Width2, Height1);
static RECT rcPassword2Edit		= RECT_INIT(Left2, Top1 + yDist1 * 2, Width2, Height1);
static RECT rcEmailEdit			= RECT_INIT(Left2, Top1 + yDist1 * 3, Width2, Height1);
static RECT rcGenderCombo		= RECT_INIT(Left2, Top1 + yDist1 * 4, Width2, Height1 * 5);
static RECT rcBirthYearEdit		= RECT_INIT(Left2, Top1 + yDist1 * 5, Width2, Height1);
static RECT rcBirthYearSpin		= RECT_INIT(Left2, Top1 + yDist1 * 5, Width2, Height1);

static RECT rcOkBtn = RECT_INIT(8, 180, 64, 24);
static RECT rcCancelBtn = RECT_INIT(160, 180, 64, 24);

/////////////////////////////////////////////////////////////////////////////
// CROGClientNewUserView

CROGClientNewUserView::CROGClientNewUserView()
{
}

CROGClientNewUserView::~CROGClientNewUserView()
{
}


BEGIN_MESSAGE_MAP(CROGClientNewUserView,CWnd )
	//{{AFX_MSG_MAP(CROGClientNewUserView)
	ON_WM_CREATE()
	ON_WM_PAINT()
	ON_COMMAND(CROGClientNewUserView::CWID_OkBtn, OnOkBtn)
	ON_COMMAND(CROGClientNewUserView::CWID_CancelBtn, OnCancelBtn)
	ON_MESSAGE(ROGCM_RPCCall, OnRPCCall)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CROGClientNewUserView message handlers

BOOL CROGClientNewUserView::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	cs.style &= ~WS_BORDER;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		NULL, HBRUSH(COLOR_WINDOW+1), NULL);

	return TRUE;
}

int CROGClientNewUserView::OnCreate( LPCREATESTRUCT lpCreateStruct ){

	cDisplay &Display = ((CROGClientMainWnd*)GetParent())->m_Display;

	m_IDStatic.Create		(_T("ID"),		WS_CHILD | WS_VISIBLE, rcIDStatic, this, CWID_IDStatic);
	m_PasswordStatic.Create	(_T("Password"),	WS_CHILD | WS_VISIBLE, rcPasswordStatic, this, CWID_PasswordStatic);
	m_ConfirmStatic.Create	(_T("Confirm"), WS_CHILD | WS_VISIBLE, rcConfirmStatic, this, CWID_ConfirmStatic);
	m_EmailStatic.Create	(_T("E-Mail"),	WS_CHILD | WS_VISIBLE, rcEmailStatic, this, CWID_EmailStatic);
	m_GenderStatic.Create	(_T("Gender"),	WS_CHILD | WS_VISIBLE, rcGenderStatic, this, CWID_GenderStatic);
	m_BirthYearStatic.Create(_T("B-Year"),	WS_CHILD | WS_VISIBLE, rcBirthYearStatic, this, CWID_BirthYearStatic);

	m_UserIDEdit.Create		(WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP, rcUserIDEdit, this, CWID_UserIDEdit);
	m_UserIDEdit.SetFocus();
	m_PasswordEdit.Create	(WS_CHILD | WS_VISIBLE | WS_BORDER | ES_PASSWORD | WS_TABSTOP, rcPasswordEdit, this, CWID_PasswordEdit);
	m_Password2Edit.Create	(WS_CHILD | WS_VISIBLE | WS_BORDER | ES_PASSWORD | WS_TABSTOP, rcPassword2Edit, this, CWID_Password2Edit);
	m_EmailEdit.Create		(WS_CHILD | WS_VISIBLE | WS_BORDER| WS_TABSTOP, rcEmailEdit , this, CWID_EmailEdit);

	m_GenderCombo.Create	(WS_CHILD | WS_VISIBLE | CBS_DROPDOWNLIST | WS_TABSTOP, rcGenderCombo, this, CWID_GenderCombo);
	m_GenderCombo.AddString(_T("Male"));
	m_GenderCombo.AddString(_T("Female"));
	m_GenderCombo.SetCurSel(0);
	m_BirthYearEdit.Create	(WS_CHILD | WS_VISIBLE | WS_BORDER | ES_RIGHT | WS_TABSTOP, rcBirthYearEdit, this, CWID_BirthYearEdit);
	m_BirthYearSpin.Create	(WS_CHILD | WS_VISIBLE | UDS_AUTOBUDDY | UDS_ALIGNRIGHT | UDS_SETBUDDYINT , rcBirthYearSpin, this, CWID_BirthYearSpin);
	m_BirthYearSpin.SetRange(1900, 2100);
	m_BirthYearSpin.SetPos(1980);

	m_OkBtn.Create(_T("OK"), WS_CHILD | WS_VISIBLE| WS_TABSTOP, rcOkBtn, this, CWID_OkBtn);
	m_CancelBtn.Create(_T("Cancel"), WS_CHILD | WS_VISIBLE| WS_TABSTOP, rcCancelBtn, this, CWID_CancelBtn);

	return 0;
}

void CROGClientNewUserView::OnDestroy( ){

}

void CROGClientNewUserView::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
}

LRESULT CROGClientNewUserView::OnRPCCall(WPARAM wParam, LPARAM lParam){
	cRPCPacket *pPacket;
	pPacket = (cRPCPacket *)lParam;

	switch(pPacket->GetObjectID()){
	case RPCO_Owner:
		switch(wParam){
		case ROGLCM_CreateNewPlayerResult:
			{
				char Result;
				ROGLCM_CreateNewPlayerResult_Stub(*pPacket, Result);
				CreateNewPlayerResult(Result);
			}
			break;
		default:
			ASSERT(FALSE);
			break;

		}
		break;
	default:
		ASSERT(FALSE);

	}

	((CROGClientMainWnd*)GetParent())->CloseRPC();

	return TRUE;

}

BOOL CROGClientNewUserView::OnCommand( WPARAM wParam, LPARAM lParam ){
	return CWnd::OnCommand(wParam, lParam);
}



cRPC *CROGClientNewUserView::GetRPC(){
	return &((CROGClientMainWnd *)GetParent())->m_RPC;
}

void CROGClientNewUserView::OnOkBtn(){
//	GetParent()->PostMessage(ROGCM_ChangeChild, ROGCCVC_Lobby, 0);
	cRPCPacket Packet;

	if(!((CROGClientMainWnd*)GetParent())->OpenRPC()){

		//  ׽Ʈ    ٵ Ǿ ִ.
		//    Ȯ ó ־ ϰڴ.
		MessageBox(_T("Network connect fail."), _T("error"), MB_OK);
		//ASSERT(!"OnLoginBtn::OpenRPC() fail.");
		return;
	}


	TCHAR PlayerName[20];
	TCHAR Password[20];
	TCHAR Password2[20];
	TCHAR email[30];
	char Gender;
	int BirthYear;


	if(m_UserIDEdit.GetWindowText(PlayerName, 20) == 0){
		MessageBox(_T("You should fill UserID"));
		m_UserIDEdit.SetFocus();
		return;
	}

	if(m_PasswordEdit.GetWindowText(Password, 20) == 0){
		MessageBox(_T("You should fill Password"));
		m_PasswordEdit.SetFocus();
		return;
	}
	m_Password2Edit.GetWindowText(Password2, 20);
	if(_tcscmp(Password, Password2)){
		MessageBox(_T("Password is not correct."));
		m_PasswordEdit.SetFocus();
		return;
	}
	if(m_EmailEdit.GetWindowText(email, 30) == 0){
		MessageBox(_T("You should fill email"));
		m_EmailEdit.SetFocus();
		return;
	}
	Gender = m_GenderCombo.GetCurSel();
	BirthYear = m_BirthYearSpin.GetPos();

	Packet.SetHeader(RPCO_Owner, ROGLSM_CreateNewPlayer);
	ROGLSM_CreateNewPlayer_Stub(Packet, PlayerName, Password, email, Gender, BirthYear);
	GetRPC()->SendPacket(&Packet);


}

void CROGClientNewUserView::OnCancelBtn(){
	GetParent()->PostMessage(ROGCM_ChangeChild, ROGCCVC_Login, 0);


	((CROGClientMainWnd*)GetParent())->CloseRPC();

}

void CROGClientNewUserView::CreateNewPlayerResult(char Result){
	switch(Result){
	case 0:
		MessageBox(_T("create new player ok."), _T("GameZone"), MB_OK);
		GetParent()->PostMessage(ROGCM_ChangeChild, ROGCCVC_Login, 0);
		break;

	case 1:
		MessageBox(_T("failed to create new player."), _T("error"), MB_OK);
		m_UserIDEdit.SetFocus();
		break;
	case 2:
		MessageBox(_T("there exists same user id."), _T("error"), MB_OK);
		m_UserIDEdit.SetFocus();
		break;
	}

}


