#include "stdafx.h"
#include "ROGClientPlayerView.h"
#include "ROGClientMainWnd.h"
#include "ROGClient.h"
#include "ROGClientLobbyView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

static int xOrg = 0, yOrg = 0;

static RECT rcUserListCtrl = { 
	xOrg,
	yOrg, 
	xOrg + 240, 
	yOrg + 112 
};

static RECT rcDetailBtn = { 
	xOrg, 
	yOrg + 112, 
	xOrg + 50,
	yOrg + 112 + 24 
};

static RECT rcWisperBtn = { 
	xOrg + 60, 
	yOrg + 112, 
	xOrg + 60 + 50, 
	yOrg + 112 + 24
};

static RECT rcCallBtn = { 
	xOrg + 120, 
	yOrg + 112, 
	xOrg + 120 + 50, 
	yOrg + 112 + 24 
};

static RECT rcJoinBtn = { 
	xOrg + 180, 
	yOrg + 112, 
	xOrg + 180 + 50, 
	yOrg + 112 + 24 
};

/////////////////////////////////////////////////////////////////////////////
// CROGClientPlayerView

CROGClientPlayerView::CROGClientPlayerView()
{
}

CROGClientPlayerView::~CROGClientPlayerView()
{
}


BEGIN_MESSAGE_MAP(CROGClientPlayerView,CWnd )
	//{{AFX_MSG_MAP(CROGClientPlayerView)
	ON_WM_CREATE()
	ON_WM_PAINT()
	ON_MESSAGE(ROGCM_RPCCall, OnRPCCall)
	ON_COMMAND(CROGClientPlayerView::CWID_DetailBtn, OnDetailBtn)
	ON_COMMAND(CROGClientPlayerView::CWID_WisperBtn, OnWisperBtn)
	ON_COMMAND(CROGClientPlayerView::CWID_CallBtn, OnCallBtn)
	ON_COMMAND(CROGClientPlayerView::CWID_JoinBtn, OnJoinBtn)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CROGClientPlayerView message handlers

BOOL CROGClientPlayerView::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	cs.style &= ~WS_BORDER;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		NULL, HBRUSH(COLOR_WINDOW+1), NULL);

	return TRUE;
}

int CROGClientPlayerView::OnCreate( LPCREATESTRUCT lpCreateStruct ){

	cDisplay &Display = ((CROGClientMainWnd*)GetParent())->m_Display;

	m_WisperBtn.Create(_T("Wisper"), WS_CHILD | WS_VISIBLE, rcWisperBtn, this, CWID_WisperBtn);

	m_PlayerListCtrl.Create(WS_CHILD | WS_VISIBLE | LVS_REPORT | LVS_SINGLESEL | LVS_SORTASCENDING | LVS_SHOWSELALWAYS, rcUserListCtrl, this, CWID_PlayerListCtrl);
	m_PlayerListCtrl.InsertColumn(0, _T("ID"), LVCFMT_LEFT, 8 * 8);
	m_PlayerListCtrl.InsertColumn(1, _T("Location"), LVCFMT_LEFT, 14 * 8);
	m_PlayerListCtrl.InsertColumn(2, _T("Money"), LVCFMT_RIGHT, 8 * 8);
	m_PlayerListCtrl.SetExtendedStyle(LVS_EX_FULLROWSELECT);


	// κ   ´.
	GetRPC()->SendSimplePacket(RPCO_Owner, ROGLSM_GetPlayerList);

	return 0;
}

void CROGClientPlayerView::OnDestroy( ){

	cDisplay &Display = ((CROGClientMainWnd*)GetParent()->GetParent())->m_Display;

}

void CROGClientPlayerView::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	


}

LRESULT CROGClientPlayerView::OnRPCCall(WPARAM wParam, LPARAM lParam){
	cRPCPacket *pPacket;
	pPacket = (cRPCPacket *)lParam;

	switch(wParam){
	case ROGLCM_SetPlayerList:
		{
			sROGPlayerData *pPlayerData;
			unsigned short PlayerCount;

			ROGLCM_SetPlayerList_Stub(*pPacket, PlayerCount, pPlayerData);
			SetPlayerList(PlayerCount, pPlayerData);
			if(PlayerCount)
				delete [] pPlayerData;
		}
		break;

	case ROGLCM_AddPlayerList:		//	 Ʈ Ѹ ߰
		{
			sROGPlayerData PlayerData;
			ROGLCM_AddPlayerList_Stub(*pPacket, &PlayerData);
			AddPlayerList(&PlayerData);
		}
		break;
	case ROGLCM_RemovePlayerList:	//	 Ʈ Ѹ 
		{
			TCHAR UserName[100];
			ROGLCM_RemovePlayerList_Stub(*pPacket, UserName);
			RemovePlayerList(UserName);			
		}
		break;
	case ROGLCM_UpdatePlayerList:		//	 Ʈ Ѹ ߰
		{
			sROGPlayerData PlayerData;
			ROGLCM_UpdatePlayerList_Stub(*pPacket, &PlayerData);
			UpdatePlayerList(&PlayerData);
		}
		break;


	default:
		ASSERT(FALSE);
		break;


	}
	return TRUE;
}

void CROGClientPlayerView::SetPlayerList(int PlayerCount, sROGPlayerData *pPlayerData){
	int i;

	m_PlayerListCtrl.DeleteAllItems();
	for(i = 0; i < PlayerCount; i ++){
		AddPlayerList(pPlayerData + i);

	}
}

void CROGClientPlayerView::AddPlayerList(sROGPlayerData *pPlayerData){
	int nItem;
	TCHAR str[200];

	nItem = m_PlayerListCtrl.InsertItem(m_PlayerListCtrl.GetItemCount(), pPlayerData->Name);
	if(pPlayerData->RoomID == 0){
		_tcscpy(str, _T("Lobby"));
	}else{
		_stprintf(str, _T("Room %02d"), pPlayerData->RoomID);
	}
	m_PlayerListCtrl.SetItemText(nItem, 1, str);
	_stprintf(str, _T("%d"), pPlayerData->Money);
	m_PlayerListCtrl.SetItemText(nItem, 2, str);
	m_PlayerListCtrl.SetItemData(nItem, pPlayerData->RoomID);
}

void CROGClientPlayerView::RemovePlayerList(LPCTSTR pName){
	LVFINDINFO FindInfo;

	FindInfo.flags = LVFI_STRING;
	FindInfo.psz = pName;
	m_PlayerListCtrl.DeleteItem(m_PlayerListCtrl.FindItem(&FindInfo));
}

void CROGClientPlayerView::UpdatePlayerList(sROGPlayerData *pPlayerData){
	int nItem;
	TCHAR str[200];

	LVFINDINFO FindInfo;

	FindInfo.flags = LVFI_STRING;
	FindInfo.psz = pPlayerData->Name;
	
	nItem = m_PlayerListCtrl.FindItem(&FindInfo);

	if(nItem < 0)
		return;

	if(pPlayerData->RoomID == 0){
		_tcscpy(str, _T("Lobby"));
	}else{
		_stprintf(str, _T("Room %02d"), pPlayerData->RoomID);
	}
	m_PlayerListCtrl.SetItemText(nItem, 1, str);
	_stprintf(str, _T("%d"), pPlayerData->Money);
	m_PlayerListCtrl.SetItemText(nItem, 2, str);
	m_PlayerListCtrl.SetItemData(nItem, pPlayerData->RoomID);
}

BOOL CROGClientPlayerView::OnCommand( WPARAM wParam, LPARAM lParam ){
	return CWnd::OnCommand(wParam, lParam);
}

BOOL CROGClientPlayerView::OnChildNotify( UINT message, WPARAM wParam, LPARAM lParam, LRESULT* pLResult){
	LPNMHDR	pNMHeader;

	pNMHeader = (LPNMHDR) lParam;
	switch(wParam){
	case CWID_PlayerListCtrl:
		{
			LPNMLISTVIEW pNMListView;
			pNMListView = (LPNMLISTVIEW)lParam;

			switch(pNMHeader->code){
			case LVN_ITEMACTIVATE:
				if(pNMListView->uNewState & LVIS_SELECTED){
					short RoomID = (short)m_PlayerListCtrl.GetItemData(pNMListView->iItem);
					if(RoomID > 0){
//						m_CallBtn.EnableWindow(FALSE);
//						m_JoinBtn.EnableWindow(TRUE);
					}else{
//						m_CallBtn.EnableWindow(TRUE);
//						m_JoinBtn.EnableWindow(FALSE);
					}
				}
				break;
			};
		}
		
		break;
	}
	return TRUE;
}


cRPC *CROGClientPlayerView::GetRPC(){
	return &((CROGClientMainWnd *)GetParent()->GetParent())->m_RPC;
}

void CROGClientPlayerView::OnDetailBtn(){
//	GetParent()->PostMessage(ROGCM_ChangeChild, ROGCCVC_Lobby, 0);
}

void CROGClientPlayerView::OnWisperBtn(){
	TCHAR to[100];
	POSITION pos;
	int Index;

	pos = m_PlayerListCtrl.GetFirstSelectedItemPosition();
	if(pos){
		Index = m_PlayerListCtrl.GetNextSelectedItem(pos);
		m_PlayerListCtrl.GetItemText(Index, 0, to, 100);
		((CROGClientLobbyView*)GetParent())->WisperChat(to);
	}
}

void CROGClientPlayerView::OnCallBtn(){
}

void CROGClientPlayerView::OnJoinBtn(){
}
