// ROGClientRoomView.cpp : implementation of the CROGClientRoomView class
//

#include "stdafx.h"
#include "ROGClientRoomView.h"
#include "ROGClientMainWnd.h"
#include "ROGClient.h"
//#include "ROGSevenPokerRoomProtocol.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CROGClientRoomView
static int xOrg = 0, yOrg = 0;

static RECT rcRoomListCtrl = { 
	xOrg,
	yOrg, 
	xOrg + 240, 
	yOrg + 112 
};

static RECT rcDetailBtn = { 
	xOrg + 60, 
	yOrg + 112, 
	xOrg + 60 + 50, 
	yOrg + 112 + 24
};

static RECT rcCreateBtn = { 
	xOrg + 120, 
	yOrg + 112, 
	xOrg + 120 + 50, 
	yOrg + 112 + 24 
};

static RECT rcJoinBtn = { 
	xOrg + 180, 
	yOrg + 112, 
	xOrg + 180 + 50, 
	yOrg + 112 + 24 
};

CROGClientRoomView::CROGClientRoomView()
{
}

CROGClientRoomView::~CROGClientRoomView()
{
}


BEGIN_MESSAGE_MAP(CROGClientRoomView,CWnd )
	//{{AFX_MSG_MAP(CROGClientRoomView)
	ON_WM_CREATE()
	ON_WM_PAINT()
	ON_COMMAND(CWID_CreateBtn, OnCreateBtn)
	ON_COMMAND(CWID_JoinBtn, OnJoinBtn)
	ON_MESSAGE(ROGCM_RPCCall, OnRPCCall)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CROGClientRoomView message handlers

BOOL CROGClientRoomView::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	cs.style &= ~WS_BORDER;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		NULL, HBRUSH(COLOR_WINDOW+1), NULL);

	return TRUE;
}

int CROGClientRoomView::OnCreate( LPCREATESTRUCT lpCreateStruct ){
	m_RoomListCtrl.Create(WS_CHILD | WS_VISIBLE | LVS_REPORT | LVS_SHOWSELALWAYS, rcRoomListCtrl, this, CWID_RoomListCtrl);
	m_RoomListCtrl.SetExtendedStyle(LVS_EX_FULLROWSELECT);
	m_RoomListCtrl.InsertColumn(0, _T("ID"), LVCFMT_LEFT, 8 * 8);
	m_RoomListCtrl.InsertColumn(1, _T("State"), LVCFMT_LEFT, 14 * 8);
	m_RoomListCtrl.InsertColumn(2, _T("User"), LVCFMT_RIGHT, 8 * 8);

	m_DetailBtn.Create(_T("Detail"), WS_CHILD | WS_VISIBLE, rcDetailBtn, this, CWID_DetailBtn);
	m_CreateBtn.Create(_T("Create"), WS_CHILD | WS_VISIBLE, rcCreateBtn, this, CWID_CreateBtn);
	m_JoinBtn.Create(_T("Join"), WS_CHILD | WS_VISIBLE, rcJoinBtn, this, CWID_JoinBtn);
	// κ   ´.
	GetRPC()->SendSimplePacket(RPCO_Owner, ROGLSM_GetRoomList);

	return 0;
}

void CROGClientRoomView::OnDestroy( ){

}

void CROGClientRoomView::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	
	// Do not call CWnd::OnPaint() for painting messages
}

LRESULT CROGClientRoomView::OnRPCCall(WPARAM wParam, LPARAM lParam){
	cRPCPacket *pPacket;
	pPacket = (cRPCPacket *)lParam;

	switch(wParam){
	case ROGLCM_SetRoomList:
		{
			sROGRoomData *pRoomData;
			short RoomCount;

			ROGLCM_SetRoomList_Stub(*pPacket, RoomCount, pRoomData);
			SetRoomList(RoomCount, pRoomData);
			if(RoomCount)
				delete [] pRoomData;
		}
		break;

	
	case ROGLCM_CreateRoomResult:
		{
			short Result;
			ROGLCM_CreateRoomResult_Stub(*pPacket, Result);
			
			if(Result == -1){
				MessageBox(_T("You have not enough Chip"));
			}
			else{
				// 游⿡ 
				GetParent()->PostMessage(ROGCM_ChangeChild, ROGCCVC_Count, 0);
			}

		}
		break;

	case ROGLCM_JoinRoomResult:
		{
			short Result;
			ROGLCM_JoinRoomResult_Stub(*pPacket, Result);
			
			if(Result == -1){
				MessageBox(_T("You have not enough Chip"));
			}
			else{
				// ο 
				GetParent()->GetParent()->PostMessage(ROGCM_ChangeChild, ROGCCVC_Count, 0);
			}


		}
		break;

	case ROGLCM_AddRoomList:			//	 Ʈ ϳ  ߰
		{
			sROGRoomData RoomData;
			ROGLCM_AddRoomList_Stub(*pPacket, &RoomData);
			AddRoomList(&RoomData);
		}
		break;

	case ROGLCM_RemoveRoomList:		//	 Ʈ ϳ  
		{
			short RoomID;
			ROGLCM_RemoveRoomList_Stub(*pPacket, RoomID);
			RemoveRoomList(RoomID);

		}
		break;

	case ROGLCM_UpdateRoomList:
		{
			sROGRoomData RoomData;
			ROGLCM_UpdateRoomList_Stub(*pPacket, &RoomData);
			UpdateRoomList(&RoomData);
		}
		break;

	default:
		ASSERT(FALSE);
		break;


	}
	return TRUE;

}

BOOL CROGClientRoomView::OnCommand( WPARAM wParam, LPARAM lParam ){
	return CWnd::OnCommand(wParam, lParam);
}



cRPC *CROGClientRoomView::GetRPC(){
	return &((CROGClientMainWnd *)GetParent()->GetParent())->m_RPC;
}

void CROGClientRoomView::SetRoomList(int RoomCount, sROGRoomData *pRoomData){
	int i;

	m_RoomListCtrl.DeleteAllItems();
	for(i = 0; i < RoomCount; i ++){
		AddRoomList(pRoomData + i);
	}
}


void CROGClientRoomView::AddRoomList(sROGRoomData *pRoomData){
	int nItem;
	TCHAR str[200];

	_stprintf(str, _T("%3d"), pRoomData->RoomID);
	nItem = m_RoomListCtrl.InsertItem(m_RoomListCtrl.GetItemCount(), str);


	_stprintf(str, _T("playing"));
	m_RoomListCtrl.SetItemText(nItem, 1, str);

	_stprintf(str, _T("%d/%d"), pRoomData->PlayerCount, pRoomData->PlayerCountLimit);
	m_RoomListCtrl.SetItemText(nItem, 2, str);
	m_RoomListCtrl.SetItemData(nItem, pRoomData->RoomID);
}

void CROGClientRoomView::RemoveRoomList(short RoomID){
	LVFINDINFO FindInfo;
	TCHAR str[200];

	_stprintf(str, _T("%3d"), RoomID);
	FindInfo.flags = LVFI_STRING;
	FindInfo.psz = str;
	m_RoomListCtrl.DeleteItem(m_RoomListCtrl.FindItem(&FindInfo));

}

void CROGClientRoomView::UpdateRoomList(sROGRoomData *pRoomData){
	int Index;

	LVFINDINFO FindInfo;
	TCHAR str[200];

	_stprintf(str, _T("%3d"), pRoomData->RoomID);
	FindInfo.flags = LVFI_STRING;
	FindInfo.psz = str;
	Index = m_RoomListCtrl.FindItem(&FindInfo);

	if(Index >= 0){
		_stprintf(str, _T("playing"));
		m_RoomListCtrl.SetItemText(Index, 1, str);

		_stprintf(str, _T("%d/%d"), pRoomData->PlayerCount, pRoomData->PlayerCountLimit);
		m_RoomListCtrl.SetItemText(Index, 2, str);
		m_RoomListCtrl.SetItemData(Index, pRoomData->RoomID);

	}
}

void CROGClientRoomView::OnCreateBtn(){
	//    濡 
	cRPCPacket		Packet;
	short			PlayerCountLimit = 5;

	Packet.SetHeader(RPCO_Owner, ROGLSM_CreateRoom);
	ROGLSM_CreateRoom_Stub(Packet, PlayerCountLimit);
	GetRPC()->SendPacket(&Packet);


}

void CROGClientRoomView::OnJoinBtn(){
	//
	cRPCPacket		Packet;

	int uSelectedCount = m_RoomListCtrl.GetSelectedCount();
	int nItem = -1;

	if (uSelectedCount > 0){
		nItem = m_RoomListCtrl.GetNextItem(nItem, LVNI_SELECTED);
		ASSERT(nItem != -1);

		short RoomID = (short)m_RoomListCtrl.GetItemData(nItem);
		Packet.SetHeader(RPCO_Owner, ROGLSM_JoinRoom);
		ROGLSM_JoinRoom_Stub(Packet, RoomID);
		GetRPC()->SendPacket(&Packet);


	}

	
}


