// ROGClientUpgradeView.cpp : implementation of the CROGClientUpgradeView class
//

#include "stdafx.h"
#include "ROGClientUpgradeView.h"
#include "ROGClientMainWnd.h"
#include "ROGClient.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

static RECT rcStartBtn = { 20, 200, 20 + 48, 200 + 24 };
static RECT rcExitBtn = { 120, 200, 120 + 48, 200 + 24 };

/////////////////////////////////////////////////////////////////////////////
// CROGClientUpgradeView

void DecodeFileNameMacro(LPCTSTR strLocalFileName, LPTSTR strLocalFileName2){
	const TCHAR *pStr;
	TCHAR *pStr2;

	pStr = strLocalFileName;
	pStr2 = strLocalFileName2;

	while(*pStr){
		if(*pStr == '%'){
#ifndef UNDER_CE
			// macro mode;
			if(_tcsncmp(pStr, _T("%windir%"), 8) == 0){
				pStr += 8;
				PathLen = GetWindowsDirectory(Path, MAX_PATH);
				_tcscpy(pStr2, Path);
				pStr2 += PathLen;
			}else if(_tcsncmp(pStr, _T("%sysdir%"), 8) == 0){
				pStr += 8;
				PathLen = GetSystemDirectory(Path, MAX_PATH);
				_tcscpy(pStr2, Path);
				pStr2 += PathLen;
			}else if(_tcsncmp(pStr, _T("%appdir%"), 8) == 0){
				pStr += 8;
				GetWindowsDirectory(Path, MAX_PATH);
				_tcscpy(Path + 3, _T("Program files")); 
				PathLen = _tcslen(Path);
				_tcscpy(pStr2, Path);
				pStr2 += PathLen;
			}else{
				*pStr2 = *pStr;
				pStr ++;
				pStr2 ++;
			}
#else
			*pStr2 = *pStr;
			pStr ++;
			pStr2 ++;

#endif
	
		}else{
			*pStr2 = *pStr;
			pStr ++;
			pStr2 ++;
		}

	}

	*pStr2 = 0;

	
}


CROGClientUpgradeView::CROGClientUpgradeView()
{
}

CROGClientUpgradeView::~CROGClientUpgradeView()
{
}


BEGIN_MESSAGE_MAP(CROGClientUpgradeView,CWnd )
	//{{AFX_MSG_MAP(CROGClientUpgradeView)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_PAINT()
	ON_WM_TIMER()
	ON_COMMAND(CROGClientUpgradeView::CWID_StartBtn, OnStartBtn)
	ON_COMMAND(CROGClientUpgradeView::CWID_ExitBtn, OnExitBtn)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CROGClientUpgradeView message handlers

BOOL CROGClientUpgradeView::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	cs.style &= ~WS_BORDER;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		NULL, (HBRUSH)(COLOR_BTNFACE + 1), NULL);

	return TRUE;
}

int CROGClientUpgradeView::OnCreate( LPCREATESTRUCT lpCreateStruct ){

	cDisplay &Display = ((CROGClientMainWnd*)GetParent())->m_Display;


	CROGClientMainWnd *pMainWnd = ((CROGClientMainWnd*)GetParent());

//	m_StartBtn.Create(_T("Start"), WS_CHILD | WS_VISIBLE, rcStartBtn, this, CWID_StartBtn);
//	m_ExitBtn.Create(_T("Exit"), WS_CHILD | WS_VISIBLE, rcExitBtn, this, CWID_ExitBtn);
	m_CtrlMsg1.Create(_T(""), WS_CHILD | WS_VISIBLE, CRect(0, 0, 240, 0 + 24), this, 0);
	m_CtrlMsg2.Create(_T(""), WS_CHILD | WS_VISIBLE, CRect(0, 24, 240, 24 + 24), this, 0);
	m_CtrlMsg3.Create(_T(""), WS_CHILD | WS_VISIBLE, CRect(0, 48, 240, 48 + 24), this, 0);
	m_CtrlMsg4.Create(_T(""), WS_CHILD | WS_VISIBLE, CRect(0, 72, 240, 72 + 24), this, 0);
	m_CtrlTotalProgress.Create(WS_CHILD | WS_VISIBLE, CRect(10, 120, 220, 120 + 8), this, 0);

	m_hInternet = InternetOpen(_T("GameZone"), INTERNET_OPEN_TYPE_PRECONFIG, NULL, NULL, 0); 

	m_Downloader.Create(GetSafeHwnd(), m_hInternet);

	m_CtrlMsg1.SetWindowText(_T("AUTO UPGRADER"));
	m_CtrlMsg2.SetWindowText(_T("Retrieving version info..."));

	SetTimer(100, 100, 0);
	return 0;
}

void CROGClientUpgradeView::OnDestroy( ){
	cDisplay &Display = ((CROGClientMainWnd*)GetParent())->m_Display;
	m_Downloader.Stop(true);
	m_Downloader.Destroy();
	InternetCloseHandle(m_hInternet);


}

void CROGClientUpgradeView::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	
	// Do not call CWnd::OnPaint() for painting messages
//	dc.DrawText(_T("H l o"), 5, CRect(0, 0, 100, 100), DT_LEFT);
	cDisplay &Display = ((CROGClientMainWnd*)GetParent())->m_Display;
//	Display.GetBackPic()->Blt(0, 0, &m_TitlePic);
//	Display.Flip(dc.m_hDC);
	
/*	CDC *pDC = GetParent()->GetDC();
	dc.BitBlt(0, 0, 240, 280, pDC, 0, 0, SRCCOPY);
	GetParent()->ReleaseDC(pDC);*/
//	dc.DrawText(_T(" e l "), 5, CRect(0, 20, 100, 100), DT_LEFT);

//	m_StartBtn.Invalidate();
//	m_ExitBtn.Invalidate();

}

LRESULT CROGClientUpgradeView::OnRPCCall(WPARAM wParam, LPARAM lParam){
	cRPCPacket *pPacket;
	pPacket = (cRPCPacket *)lParam;

	ASSERT(FALSE);

	return TRUE;

}

BOOL CROGClientUpgradeView::OnCommand( WPARAM wParam, LPARAM lParam ){
	return CWnd::OnCommand(wParam, lParam);
}

void CROGClientUpgradeView::OnStartBtn(){
	GetParent()->PostMessage(ROGCM_ChangeChild, ROGCCVC_Login, 0);
}

void CROGClientUpgradeView::OnExitBtn(){
//	GetParent()->PostMessage(ROGCM_ChangeChild, ROGCCVC_Lobby, 0);
	PostQuitMessage(0);
}

void CROGClientUpgradeView::OnTimer(UINT nIDEvent) 
{
	KillTimer(100);

	CROGClientMainWnd *pMainWnd = (CROGClientMainWnd*)GetParent();


	HINTERNET			hHttpSession;
	HINTERNET			hHttpRequest;

	hHttpSession = InternetConnect(
		m_hInternet,
		pMainWnd->m_pClientInfo->UpgradeServerURL,
		pMainWnd->m_pClientInfo->UpgradeServerPort,
		_T(""), _T(""), INTERNET_SERVICE_HTTP, 0, 0);

	CString strRequest;
	CString dateTime;

/*#ifdef _ROGStood
	//strRequest.Format(_T("~mechlord/Download/%s/filelist.txt"), pMainWnd->m_pClientInfo->GameID);
	strRequest.Format(_T("~mechlord/Download/Stood/filelist.txt"));
#elif defined(_ROGSevenPoker)
	//strRequest.Format(_T("~mechlord/Download/%s/filelist.txt"), pMainWnd->m_pClientInfo->GameID);
	strRequest.Format(_T("~mechlord/Download/SevenPoker/filelist.txt"));
#else*/
	strRequest.Format(_T("Download/%s/filelist.txt"), pMainWnd->m_pClientInfo->GameID);
//#endif
	
	hHttpRequest = HttpOpenRequest(hHttpSession, _T("GET"), 
		strRequest, HTTP_VERSION, NULL, 0, INTERNET_FLAG_NO_CACHE_WRITE, 0);

	if(HttpSendRequest(hHttpRequest, NULL, 0, NULL, 0)){
		TCHAR str[MAX_PATH];
		

		while(InternetReadString(hHttpRequest, str, MAX_PATH)){
			if(_tcslen(str) < 1)
				continue;
			TCHAR strUrl[MAX_PATH];
			TCHAR strServerFileName[MAX_PATH];
			TCHAR strLocalFileName[MAX_PATH];
			TCHAR strLocalFileName2[MAX_PATH];
			int nPort;
			SYSTEMTIME ModifyTime;

			ZeroMemory(&ModifyTime, sizeof(SYSTEMTIME));

			nPort = 80;
			_stscanf(str, _T("%s %d %s %s %u-%u-%u %u:%u:%u"), 
				strUrl, 
				&nPort,
				strServerFileName, 
				strLocalFileName,
				&ModifyTime.wYear,
				&ModifyTime.wMonth,
				&ModifyTime.wDay,
				&ModifyTime.wHour,
				&ModifyTime.wMinute,
				&ModifyTime.wSecond);

			CDownloadFile *pDownload;
			DecodeFileNameMacro(strLocalFileName, strLocalFileName2);
			pDownload = new CDownloadFile(strUrl, nPort, strServerFileName, strLocalFileName2, 0, ModifyTime);
			m_Downloader.AddDownload(pDownload);
		}

		m_Downloader.Start();

		InternetCloseHandle(hHttpRequest);
		InternetCloseHandle(hHttpSession);

	}else{
		InternetCloseHandle(hHttpSession);
		m_CtrlMsg2.SetWindowText(_T("Upgrade Server is not available."));
		return;
	}

}


LRESULT CROGClientUpgradeView::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	switch(message){
	case WM_DOWNLOAD_START:
		m_CtrlTotalProgress.SetRange(0, short((DWORD)lParam >> 10));
		m_CtrlMsg2.SetWindowText(_T("Starting download..."));
		m_dwTotalFileSize = (DWORD)lParam;
		return 0;
	case WM_DOWNLOAD_FILE:
		{
			CString strInfo;
			m_CtrlTotalProgress.SetPos(short((DWORD)lParam >> 10));
			strInfo.Format(_T("%dK/%dK"), ((DWORD)lParam >> 10), ((DWORD)m_dwTotalFileSize >> 10));
			m_CtrlMsg2.SetWindowText(strInfo);
		}
		return 0;
	case WM_DOWNLOAD_END:
		{
			GetParent()->PostMessage(ROGCM_ChangeChild, ROGCCVC_Title, 0);
		}

		return 0;
	}
	
	return CWnd::WindowProc(message, wParam, lParam);
}



