#include "StdAfx.h"
#include "ROGLobbyProtocol.h"

// Lobby Server Protocol ////////////////////////////////////////////////////////////////////////////////
void ROGLSM_Login_Stub(cRPCPacket &Packet, LPTSTR PlayerName, LPTSTR Password){
	Packet + PlayerName + Password;
}

void ROGLSM_CreateNewPlayer_Stub(cRPCPacket &Packet, LPTSTR PlayerName, LPTSTR Password, LPTSTR email, char &Gender, int &BirthYear){
	Packet + PlayerName + Password + email + Gender + BirthYear;
}

void ROGLSM_CreateRoom_Stub(cRPCPacket &Packet, short &PlayerCountLimit){
	Packet + PlayerCountLimit;
}

void ROGLSM_JoinRoom_Stub(cRPCPacket &Packet, short &RoomID){
	Packet + RoomID;
}

void ROGLSM_AddChat_Stub(cRPCPacket &Packet, LPTSTR Chat){
	Packet + Chat;
}

void ROGLSM_WisperChat_Stub(cRPCPacket &Packet, LPTSTR to, LPTSTR Chat){
	Packet + to + Chat;
}

void ROGLSM_SetChipNumber_Stub(cRPCPacket &Packet, int &nChipNumber){
	Packet + nChipNumber;
}

void ROGLSM_SetMoneyNumber_Stub(cRPCPacket &Packet, int &nMoneyNumber){
	Packet + nMoneyNumber;
}





// Lobby Client Protocol ////////////////////////////////////////////////////////////////////////////////
void ROGLCM_LoginResult_Stub(cRPCPacket &Packet, char &Result){
	Packet + Result;

}

void ROGLCM_CreateNewPlayerResult_Stub(cRPCPacket &Packet, char &Result){
	Packet + Result;
}

void ROGLCM_SetPlayerList_Stub(cRPCPacket &Packet, unsigned short &Count, sROGPlayerData* &pData){
	int i;

	Packet + Count;

	if(Packet.IsReadMode() && Count > 0){
		pData = new sROGPlayerData[Count];
	}

	for(i = 0; i < Count; i ++){
		Packet + pData[i].Name;
		Packet + pData[i].RoomID;
		Packet + pData[i].Money;
	}
}

void ROGLCM_AddPlayerList_Stub(cRPCPacket &Packet, sROGPlayerData* pData){
	Packet + pData->Name;
	Packet + pData->RoomID;
	Packet + pData->Money;
}

void ROGLCM_RemovePlayerList_Stub(cRPCPacket &Packet, LPTSTR pUserID){
	Packet + pUserID;
}

void ROGLCM_UpdatePlayerList_Stub(cRPCPacket &Packet, sROGPlayerData* pData){
	Packet + pData->Name;
	Packet + pData->RoomID;
	Packet + pData->Money;
}


void ROGLCM_SetRoomList_Stub(cRPCPacket &Packet, short &RoomCount, sROGRoomData* &pRoom){
	int i;

	Packet + RoomCount;

	if(Packet.IsReadMode() && RoomCount > 0){
		pRoom = new sROGRoomData[RoomCount];
	}

	for(i = 0; i < RoomCount; i ++){
		Packet + pRoom[i];
	}

}

void ROGLCM_AddRoomList_Stub(cRPCPacket &Packet, sROGRoomData* pData){
	Packet + *pData;

}

void ROGLCM_RemoveRoomList_Stub(cRPCPacket &Packet, short &RoomID){
	Packet + RoomID;
}

void ROGLCM_UpdateRoomList_Stub(cRPCPacket &Packet, sROGRoomData* pData){
	Packet + *pData;
}


void ROGLCM_CreateRoomResult_Stub(cRPCPacket &Packet, short &Result){
	Packet + Result;

}

void ROGLCM_JoinRoomResult_Stub(cRPCPacket &Packet, short &Result){
	Packet + Result;
}

void ROGLCM_AddChat_Stub(cRPCPacket &Packet, LPTSTR PlayerName, LPTSTR Chat){
	Packet + PlayerName + Chat;
}

void ROGLCM_SetMoney_Stub(cRPCPacket &Packet, int &nMoney, int &nChip){
	Packet + nMoney + nChip;
}
















