#include "StdAfx.h"
#include "ROGRoom.h"
#include "ROGPlayer.h"
#include "ROGLobbyProtocol.h"
#include "ROGServer.h"


cROGRoom::cROGRoom(){

}

cROGRoom::~cROGRoom(){

}

void cROGRoom::Dump(){
	printf("Room(%X) Dump\n", (int)this);
	printf("\tID            = %d\n", (int)RoomID);
	printf("\tName          = %s\n", "Unknown");
	printf("\tUserCount     = %d/%d\n", PlayerList.GetCount(), PlayerCountLimit);
}

bool cROGRoom::Create(short NewRoomID, int NewPlayerCountLimit){
	RoomID				= NewRoomID;
	PlayerCountLimit	= NewPlayerCountLimit;

	//     Ŭ̾Ʈ Ѵ.
	cRPCPacket Packet;
	sROGRoomData RoomData;

	Packet.SetHeader(ROGLCO_RoomView, ROGLCM_AddRoomList);
	RoomData.RoomID = GetRoomID();
	RoomData.PlayerCount = GetPlayerCount();
	RoomData.PlayerCountLimit = GetPlayerCountLimit();
	ROGLCM_AddRoomList_Stub(Packet, &RoomData);
	pApp->Lobby.BroadcastPacket(&Packet, (cROGPlayer*)NULL);

	return true;
}

void cROGRoom::Destroy(){
	//  ŵ Ŭ̾Ʈ ˸.
	cRPCPacket Packet;

	Packet.SetHeader(ROGLCO_RoomView, ROGLCM_RemoveRoomList);
	ROGLCM_RemoveRoomList_Stub(Packet, RoomID);
	pApp->Lobby.BroadcastPacket(&Packet, (cROGPlayer*)NULL);

}

bool cROGRoom::Update(){
	// flase  ϸ ش  ŵȴ.
	
	if(PlayerList.GetCount() == 0) // 濡 ƹ   ŵȴ.
		return false;

	return true;

}

bool cROGRoom::AddPlayer(cROGPlayer *pNewPlayer){
	PlayerList.AddTail(pNewPlayer);
	pNewPlayer->SetRoom(this);
	BroadcastRoomUpdate(pNewPlayer);

	return true;
}

void cROGRoom::RemovePlayer(cROGPlayer *pPlayer){
	pPlayer->SetRoom(0);
	PlayerList.Remove(pPlayer);
	BroadcastRoomUpdate();
}

short cROGRoom::GetRoomID(){
	return RoomID;
}

bool cROGRoom::IsFull(){
	return PlayerList.GetCount() >= PlayerCountLimit;
}

bool cROGRoom::BroadcastPacket(cRPCPacket *pPacket, cROGGamePlayer *pPlayerExcept){
	cList<cROGPlayer *>::cCursor	csr;
	cROGPlayer						*pPlayer;

	for(csr = PlayerList.Head(); csr != 0; csr ++){
		pPlayer = *csr;

		if(pPlayer->GetGamePlayer() != pPlayerExcept)
			pPlayer->GetRPC()->SendPacket(pPacket);

	}

	return true;
}

bool cROGRoom::BroadcastPacket(cRPCPacket *pPacket, cROGPlayer *pPlayerExcept){
	cList<cROGPlayer *>::cCursor	csr;
	cROGPlayer						*pPlayer;

	for(csr = PlayerList.Head(); csr != 0; csr ++){
		pPlayer = *csr;

		if(pPlayer != pPlayerExcept)
			pPlayer->GetRPC()->SendPacket(pPacket);

	}

	return true;
}

void cROGRoom::BroadcastRoomUpdate(cROGPlayer *pPlayerExcept){
	//     Ŭ̾Ʈ鿡 Ѵ.
	cRPCPacket Packet;
	sROGRoomData RoomData;

	Packet.SetHeader(ROGLCO_RoomView, ROGLCM_UpdateRoomList);
	RoomData.RoomID = RoomID;
	RoomData.PlayerCount = GetPlayerCount();
	RoomData.PlayerCountLimit = PlayerCountLimit;
	ROGLCM_UpdateRoomList_Stub(Packet, &RoomData);
	pApp->Lobby.BroadcastPacket(&Packet, pPlayerExcept);
}













