/*
* cROGServerApp App ǥϴ Ŭ
* 
*
*
*
*
*
* 
* */
#ifndef cROGServerApp_H
#define cROGServerApp_H

#include "cList.h"
#include "cRPC.h"
#include "ROGLobby.h"
#include "cDBRecord.h" // to compile without database access

class cROGPlayer;
class cROGRoom;
struct sROGPlayerData;
struct sROGRoomData;

class cROGServerApp{
public:
	cROGLobby	Lobby;
	cDBRecord	DBRecord;

	cROGServerApp();
	virtual ~cROGServerApp();

	int	Main(int argc, char **argv);

	short	GetPlayerListData(sROGPlayerData * & pPlayerData);
	short	GetRoomListData(sROGRoomData * & pRoomData);

	short	CreateRoom(int PlayerCountLimit);
	bool	JoinRoom(short RoomID, cROGPlayer *pPlayer);
	void	LeaveRoom(cROGPlayer *pPlayer); // κ .

	cROGPlayer*	FindPlayer(const char *pName);


protected:
	virtual int	GetServerPort() = 0;

private:
	
	cRPC RPC;

	cList<cROGPlayer *>	PlayerList;
	cList<cROGRoom *>	RoomList;
	cList<short>		FreeRoomIDList;
	

	cDBConnection DBCon;

	bool OpenDB();
	void CloseDB();

	bool OpenRPC();
	void CloseRPC();

	void UpdateRooms();
	void UpdatePlayers();

	bool AcceptNewPlayer(SOCKET Socket);

	bool CreateNewAccount(const char *pUserID, const char *pPassword, const char Email, bool IsMale, int BirthYear); // ο  .
	bool Login(cROGPlayer *pPlayer, const char *pUserID, const char *pPassword);			// ROGS αѴ.

};

extern cROGServerApp *pApp;

#endif

