#include "StdAfx.h"
#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include "cDBRecord.h"

bool cDBConnection::Connect(const char *host, const char *user, const char *passwd, const char *db, unsigned int port){
	// mysql C API  ʱȭ Ѵ.
    mysql_init(&mysql);

    if(!mysql_real_connect(&mysql, host, user, passwd, db, port, NULL, 0)){
        printf("%s\n", mysql_error(&mysql));
        return false;
    }
	return true;

}

void cDBConnection::Close(){
	mysql_close(&mysql);
}


////////////////////////////////////////////////////////////////////////////////////////////////////
cDBRecord::cDBRecord(){
	pConnection = NULL;
}

cDBRecord::~cDBRecord(){
	Close();
}

bool cDBRecord::Open(cDBConnection *pNewConnection){
	pConnection = pNewConnection;

	pResult = NULL;

	return true;
}

void cDBRecord::Close(){
	if(pResult){
		mysql_free_result(pResult);
		pResult = NULL;
	}
}

bool cDBRecord::Query(const char *pFormat, ...){
	char QueryBuffer[8192];
	va_list argList;

	// Լ ڵ ̿Ͽ  ڿ  .
	va_start(argList, pFormat);
	QueryBuffer[0] = '\0';
	vsprintf((char*)QueryBuffer, pFormat, argList);
	va_end(argList);

	//  Ѵ.
	if(mysql_real_query(&pConnection->mysql, QueryBuffer, strlen(QueryBuffer))){
		printf("MySQL error no: %d\n%s\n",
			mysql_errno(&pConnection->mysql),
			mysql_error(&pConnection->mysql));
		return false;
	}

	pResult = mysql_store_result(&pConnection->mysql);
	if(pResult){ //  select  
		FieldCount = mysql_field_count(&pConnection->mysql);
	}
	//  select  ƴѰ  .

	return true;
}


bool cDBRecord::Fetch(){
	//    ´.
	Row = mysql_fetch_row(pResult);
	if(!Row)
		return false;
	CurFieldNo = 0;
	
	return true;

}

void cDBRecord::EndFetch(){
	if(pResult){
		mysql_free_result(pResult);
		pResult = NULL;
	}
}


cDBRecord& cDBRecord::operator>>(char& arg ){
	arg = atoi(Row[CurFieldNo]);
	CurFieldNo ++;
	return *this;
}

cDBRecord& cDBRecord::operator>>(BYTE& arg ){
	arg = atoi(Row[CurFieldNo]);
	CurFieldNo ++;
	return *this;
}


cDBRecord& cDBRecord::operator>>(short& arg ){
	arg = atoi(Row[CurFieldNo]);
	CurFieldNo ++;
	return *this;
}

cDBRecord& cDBRecord::operator>>(WORD& arg ){
	arg = atoi(Row[CurFieldNo]);
	CurFieldNo ++;
	return *this;
}

cDBRecord& cDBRecord::operator>>(int& arg ){
	arg = atoi(Row[CurFieldNo]);
	CurFieldNo ++;
	return *this;
}

cDBRecord& cDBRecord::operator>>(char* arg){
	strcpy(arg, Row[CurFieldNo]);
	CurFieldNo ++;
	return *this;
}


