/*
	RPC (Renodigm's Remote Procedure Call)

	ũ 
	WIN32 : Win32 ÷  ȴ.
	LINUX : Linux ÷  ȴ.

*/

#ifndef cRPC_H
#define cRPC_H

#include "cList.h"


#define MAX_PACKET_SIZE	1462	// Ŷ ⺻ / ũ

class cRPC;

class cRPCPacket{
	//	cRPCPacket Ʈũ ۵Ǵ Ŷ Ÿ.
public:
	cRPCPacket(int PacketSize = MAX_PACKET_SIZE);
	~cRPCPacket();

	bool		IsReadMode(){ return ReadMode; }

	// б  ޼
	BYTE		GetObjectID();
	BYTE		GetMethodID();
	WORD		GetSize();
	void		SetWriteMode();

	//   ޼
	void		SetHeader(BYTE ObjectID, BYTE MethodID);
	void		SetReadMode();

	// Ű¡ ޼
	bool		ExSizeParam(void *pParamData);	// ũⰡ  ִ Param ȯ
	bool		ExParam(void *pParamData, WORD ParamSize);
	bool		ExString(char *pParam);
	bool		ExString(const char *pParam);
	bool		ExString(unsigned short *pParam);
	bool		ExString(const unsigned short *pParam);

	template<class Type> bool ExAuto(Type &Param){
		return ExParam(&Param, sizeof(Type));
	}

	cRPCPacket &operator+(char *pParam){
		ExString(pParam);
		return *this;
	}
	cRPCPacket &operator+(const char *pParam){
		ExString(pParam);
		return *this;
	}
	cRPCPacket &operator+(unsigned short *pParam){
		ExString(pParam);
		return *this;
	}
	cRPCPacket &operator+(const unsigned short *pParam){
		ExString(pParam);
		return *this;
	}

	template<class Type> cRPCPacket &operator+(Type &Param){
		ExParam(&Param, sizeof(Type));
		return *this;
	}

protected:
	char		*pData;
	int			DataSize;
	int			Cursor;
	bool		ReadMode;

private:
	friend class cRPC;

};

enum eRPCObjectID{
	RPCO_RPC = 0,
	RPCO_System,	//  Ǵ ü
	RPCO_Owner,		// 
};

enum eRPCMethodID{
	RPCM_Accept = 0,		
		// ο Ŭ̾Ʈ   쿡 ߻
	RPCM_Close,
		// Ŭ̾Ʈ   쿡 ߻
};

class cRPC{
public:

	cRPC();
	virtual ~cRPC();

	// RPC  
	bool CreateServer(const char *IPAddr, int IPPort, int BackLogCount);
		// RPC  Ѵ.
	bool CreateFromSocket(SOCKET _Socket);
		//   Ѵ.
	bool CreateClient(const char *DestIPAddr, int DestIPPort);
		// RPC  Ѵ.
	void Destroy();

	// Ŷ ó
	cRPCPacket*	GetPacket();		
		//  ť Ŷ , DestroyPacket ȣ ־ 
	cRPCPacket*	PeekPacket();
		// ť Ŷ  , DestroyPacket ȣ ʿ 
	void DestroyPacket(cRPCPacket *pPacket);
		// ť  Ŷ 

	// Ŷ 
	bool SendPacket(cRPCPacket *pPacket);
		// Ŷ ۽(۽ť  )
	bool SendSimplePacket(BYTE ObjectID, BYTE MethodID);

	// Ŷ  
	static bool AcceptStub(cRPCPacket &Packet, SOCKET &s);
	static bool CloseStub(cRPCPacket &Packet);

protected:

	cRPCPacket		PacketBuff;
	int				RecvCount;
	bool			ServerMode;
	
	SOCKET			Socket;
	cList<void *>	ReceiveQueue;

	bool ReceiveAsync();
	bool Receive();

	bool Accept();
	bool Close();


};







#endif
