#include "StdAfx.h"
#include "ROGSevenPokerPlayer.h"
#include "ROGSevenPokerRoomProtocol.h"
#include "ROGSevenPokerRoom.h"


bool cROGSevenPokerPlayer::SendPacket(cRPCPacket *pPacket){

	
	if(pPacket && cROGGamePlayer::SendPacket(pPacket)){
		int nMethodID;
		nMethodID = pPacket->GetMethodID();
		printf("			Send PeerTOPeer MSG: ");
		switch(nMethodID){

		case ROGSCM_PlayerInfo:
			printf("ROGSCM_PlayerInfo\n");
			break;
		case ROGSCM_RemovePlayer: 
			printf("ROGSCM_RemovePlayer\n");
			break;
		case ROGSCM_WaiterInfo: 
			printf("ROGSCM_WaiterInfo\n");
			break;
		case ROGSCM_StartPoker: 
			printf("ROGSCM_StartPoker\n");
			break;
		case ROGSCM_SetCard: 
			printf("ROGSCM_SetCard\n");
			break;
		case ROGSCM_ChooseFlipCard: 
			printf("ROGSCM_ChooseFlipCard\n");
			break;
		case ROGSCM_SetChip: 
				printf("ROGSCM_SetChip\n");
				break;
		case ROGSCM_SetBetChip: 
				printf("ROGSCM_SetBetChip\n");
				break;
		case ROGSCM_SetRaiseChip: 
				printf("ROGSCM_SetRaiseChip\n");
				break;
		case ROGSCM_SetWinner: 
			printf("ROGSCM_SetWinner\n");
			break;
		case ROGSCM_SetPokerBook: 
			printf("ROGSCM_SetPokerBook\n");
			break;

		case ROGSCM_SetBossRole: 
			printf("ROGSCM_SetBossRole\n");
			break;
		case ROGSCM_SetAfterCheckRole: 
			printf("ROGSCM_SetAfterCheckRole\n");
			break;
		case ROGSCM_SetAfterBetRole: 
			printf("ROGSCM_SetAfterBetRole\n");
			break;
		case ROGSCM_SetAfterCallRole: 
			printf("ROGSCM_SetAfterCallRole\n");
			break;
		case ROGSCM_SetOrder: 
			printf("ROGSCM_SetOrder\n");
			break;

		case ROGSCM_SayCheck: 
			printf("ROGSCM_SayCheck\n");
			break;
		case ROGSCM_SayCall: 
			printf("ROGSCM_SayCall\n");
			break;
		case ROGSCM_SayGood: 
			printf("ROGSCM_SayGood\n");
			break;
		case ROGSCM_SayDie: 
			printf("ROGSCM_SayDie\n");
			break;
		case ROGSCM_SayBet: 
			printf("ROGSCM_SayBet\n");
			break;

		case ROGSCM_CardIDInfo: 
			printf("ROGSCM_CardIDInfo\n");
			break;

		}

		return true;
	}

	else
		return false;

	
}

bool cROGSevenPokerPlayer::OnClientMessage(unsigned char ObjectID, unsigned char MethodID, cRPCPacket *pPacket){

	switch(MethodID){
	case ROGSSM_JoinPokerGame:
		{	
			printf("ROGSSM_JoinPokerGame\n");
	//		((cROGSevenPokerRoom*)pPlayer->GetRoom())->EngagePlayerIntoGame(this);
		}
		break;

	case ROGSSM_FlipOneCard:
		{	
			printf("ROGSSM_FlipOneCard\n");
			// ڰ ϳ ī带  ٰ 
			char cPos;
			if(!CardFlipped){
				CardFlipped = true;

				ROGSSM_FlipOneCard_Stub(*pPacket, cPos);	
				
				// ϴ  ī带  ڷ ű.
				int CardID;

				CardID = CardStack[cPos].cID;

				if(cPos < 2){
					CardStack[cPos].cID = CardStack[2].cID;
					CardStack[2].cID = CardID;
				}

				// ٸ ̵鿡 ī带  ˸
				((cROGSevenPokerRoom*)pPlayer->GetRoom())->NotifyPlayerCardFlip();
			}			
		}
		break;

	case ROGSSM_Check:
		{
			printf("ROGSSM_Check\n");
			// ڰ ý 
			((cROGSevenPokerRoom*)pPlayer->GetRoom())->DeclareCheck(RoomSeqID);
		}
		break;

	case ROGSSM_Call:
		{
			printf("ROGSSM_Call\n");
			((cROGSevenPokerRoom*)pPlayer->GetRoom())->DeclareCall(RoomSeqID);		
		}
		break;	

	case ROGSSM_BetDBL:
		{
			printf("ROGSSM_BetDBL\n");
			((cROGSevenPokerRoom*)pPlayer->GetRoom())->DeclareBetDBL(RoomSeqID);		
		}
		break;
	


	case ROGSSM_BetHalf:
		{
			printf("ROGSSM_BetHalf\n");
			((cROGSevenPokerRoom*)pPlayer->GetRoom())->DeclareBetHalf(RoomSeqID);		
		}
		break;

	case ROGSSM_Bet:
		{
			printf("ROGSSM_Bet\n");
			int nChip;
			ROGSSM_Bet_Stub(*pPacket, nChip);
			((cROGSevenPokerRoom*)pPlayer->GetRoom())->DeclareBet(RoomSeqID, nChip);
		}
		break;

	case ROGSSM_Die:
		{
			printf("ROGSSM_Die\n");
			((cROGSevenPokerRoom*)pPlayer->GetRoom())->DeclareDie(RoomSeqID);	
		}
		break;

	case ROGSSM_LeavePokerRoom:
		{
			printf("ROGSSM_LeavePokerRoom\n");
			((cROGSevenPokerRoom*)pPlayer->GetRoom())->RemovePlayer(pPlayer);
		}
		break;

	}

	return true;
}

cROGSevenPokerPlayer::cROGSevenPokerPlayer(){

	//ʱȭ 
	RoomSeqID = -1;
	LocationSeqID = -1;

	nPlayerState = EPS_Watching;	// ڸ  · 

}


void cROGSevenPokerPlayer::ResetRoom(){
	// 濡  
	pPlayer->SetRoom(0);
}

void cROGSevenPokerPlayer::InitStage(){
	// ӿ  ڰ غϴ 
	CardFlipped = false; // ī  ʾ

	int i;
	for(i = 0; i < 7; i++){ // ƹ ī嵵  ʾ
		CardStack[i].cID = -1;
		CardStack[i].Visible = false;
	}

}

void cROGSevenPokerPlayer::TakeCard(int Pos, char CardID){
	CardStack[Pos].cID = CardID;
}

/*
bool cROGSevenPokerPlayer::SendPacket(cRPCPacket *pPacket){

	return pPlayer->GetRPC()->SendPacket(pPacket);
}

*/


void cROGSevenPokerPlayer::SetChip(int _Chip){
	
	pPlayer->SetChip(_Chip);

}

int cROGSevenPokerPlayer::GetChip(){

	return pPlayer->GetChip();

}


const char*	cROGSevenPokerPlayer::GetName(){

	return pPlayer->GetName();
}
