#include "StdAfx.h"
#include "ROGSevenPokerRoom.h"
#include "ROGSevenPokerPlayer.h"
#include "ROGSevenPokerRoomProtocol.h"
#include "ROGServer.h"
#include <stdlib.h>
#include <ctime>


const int MIN_BET_CHIP = 1;

cROGRoom *ROGCreateRoom(){
	return new cROGSevenPokerRoom;
}


// cROGSevenPokerRoom /////////////////////////////////////////////////////////////////////////////////////////////
cROGSevenPokerRoom::cROGSevenPokerRoom(){
	PlayerCount = 0;
	nGameState = GS_Wait;
	time(&lPrevTime);
	CurBetPlayerSeqID = 0;

	srand(time(0));

	int i;
	for(i = 0; i < MAX_ROOM_PLAYER_COUNT; i ++){
		SeqIDOrder[i] = 0;
	}

	for(i = 0; i < MAX_ROOM_PLAYER_COUNT; i ++){
		SeqIDLocation[i] = 0;
	}
}

cROGSevenPokerRoom::~cROGSevenPokerRoom(){

}


bool cROGSevenPokerRoom::Create(short NewRoomID, int NewPlayerCountLimit){
	if(!cROGRoom::Create(NewRoomID, NewPlayerCountLimit))
		return false;
	return true;
}

void cROGSevenPokerRoom::Destroy(){
	cROGRoom::Destroy();
}

bool cROGSevenPokerRoom::AddPlayer(cROGPlayer *pNewPlayer){
	if(!cROGRoom::AddPlayer(pNewPlayer))
		return false;

	
	cROGSevenPokerPlayer			*pSevenPokerPlayer;
	pSevenPokerPlayer				= new cROGSevenPokerPlayer;
	pNewPlayer->SetGamePlayer(pSevenPokerPlayer);

	int i;
	for(i = 0; i < MAX_ROOM_PLAYER_COUNT; i++){
		if(SeqIDLocation[i] == 0){
			SeqIDLocation[i] = 1;
			break;
		}
	}

	pSevenPokerPlayer->SetLocationSeqID(i);

	return true;

}

void cROGSevenPokerRoom::RemovePlayer(cROGPlayer *pPlayer){
	cROGSevenPokerPlayer * pSevenPokerPlayer = (cROGSevenPokerPlayer*)(pPlayer->GetGamePlayer());
	cROGGamePlayer * pGamePlayer = pPlayer->GetGamePlayer();

	nGameState = GS_Wait;		// ÷̾ removeϸ  ٽ ϰ Ǿ
	time(&lPrevTime);

	int ID = pSevenPokerPlayer->GetLocationSeqID();

	for(int i = 0; i < MAX_ROOM_PLAYER_COUNT; i++){
		if(i == ID){
			if(SeqIDLocation[i] == 1)
				SeqIDLocation[i] = 0;
			else{
				ASSERT(FALSE);
			}
		}
	}

	cRPCPacket	Packet;
	char cRoomSeqID = pSevenPokerPlayer->GetRoomSeqID();
	Packet.SetHeader(RPCO_Owner, ROGSCM_LeaveSevenPokerRoom);
	ROGSCM_LeaveSevenPokerRoom_Stub(Packet, cRoomSeqID);

	BroadcastPacket(&Packet, pGamePlayer);

	pPlayer->SetGamePlayer(0);

	cROGRoom::RemovePlayer(pPlayer);

}


///////////////////////////////////////////////////////////////

bool cROGSevenPokerRoom::Update(){
	//  Ʈ Ѵ.

	if(!cROGRoom::Update())
		return false;

	switch(nGameState){
	case GS_Wait:
		time(&lTime);

		if(lTime - lPrevTime >= 3){ // 3ʰ , ڰ ִٸ,  Ѵ.
			if(PlayerList.GetCount() >= 1){ //  ׽Ʈ  1 ־ Ŀ Ѵ.
				StartPoker();
			}else{
				lPrevTime = time(&lTime);
			}
		}
		break;
	}

	return true;
}


void cROGSevenPokerRoom::MixCards(){
	int i;
	int a, b;
	int cID;

	// ī带   · غ д.
	for(i = 0; i < 52; i ++){
		CardStack[i].cID = i;
	}

	// ī带 ´.
	for(i = 0; i < 52 * 4; i ++){
		b = a = rand() % 52;
		while(b == a){
			b = rand() % 52;
		}
		cID = CardStack[a].cID;
		CardStack[a].cID = CardStack[b].cID;
		CardStack[b].cID = cID;
	}

	CardStackTopIndex = 51; //    

}

void cROGSevenPokerRoom::EngagePlayerIntoGame(cROGSevenPokerPlayer * pPlayer){
	// ڸ ۿ  ڷ ٲ
	cROGSevenPokerPlayer * pOtherPlayer;
	cRPCPacket Packet;

	// ش ڿ ڼ  Ѵ.
	char RoomSeqID = pPlayer->GetRoomSeqID();
	char LocationSeqID = pPlayer->GetLocationSeqID();
	const char *Name = pPlayer->GetName();
	char * tmpName = (char*)Name;
	int nChip = pPlayer->GetChip();


	Packet.SetHeader(RPCO_Owner, ROGSCM_PlayerInfo);
	ROGSCM_PlayerInfo_Stub(Packet, RoomSeqID, LocationSeqID, tmpName, nChip); 
	pPlayer->SendPacket(&Packet);
		
	if(pPlayer->IsWatching()){
		//   ڸ ٸ ڵ ˰ ֵ Ѵ.
		Packet.SetHeader(RPCO_Owner, ROGSCM_WaiterInfo);
		ROGSCM_WaiterInfo_Stub(Packet, RoomSeqID, LocationSeqID, tmpName, nChip); 
		BroadcastPacket(&Packet, (cROGGamePlayer*)pPlayer);

		// ڵ  ڽſ Ѵ.
		for(char i = 0; i < MAX_ROOM_PLAYER_COUNT; i ++){
			pOtherPlayer = GetPlayingPlayer(i);
			if(pOtherPlayer && pOtherPlayer != pPlayer){
				RoomSeqID = pOtherPlayer->GetRoomSeqID();
				LocationSeqID = pOtherPlayer->GetLocationSeqID();
				Name = pOtherPlayer->GetName();
				tmpName = (char*)Name;
				nChip = pOtherPlayer->GetChip();
		

				Packet.SetHeader(RPCO_Owner, ROGSCM_WaiterInfo);
				ROGSCM_WaiterInfo_Stub(Packet, RoomSeqID, LocationSeqID, tmpName, nChip); 
				pPlayer->SendPacket(&Packet);
					
			}
		}
	}

	pPlayer->SetPlaying();
}

void cROGSevenPokerRoom::FirstDeal(){ //  ī 3 
	// ī带 .
	//  ڵ鿡 3  ī带 .
	char i, CardCount;
	char HiddenCardID = 52;
	cROGSevenPokerPlayer *pPlayer;
	cRPCPacket Packet;
	
	for(CardCount = 0; CardCount < 3; CardCount ++){
	
		for(i = 0; i < MAX_ROOM_PLAYER_COUNT; i ++){
			pPlayer = GetPlayingPlayer(i);

			if(!pPlayer)
				continue;

			//  Դ ī   ˷ְ 
			//  Դ  ī带 ޾Ҵٴ Ǹ Ѵ.

			Packet.SetHeader(RPCO_Owner, ROGSCM_SetCard);
			ROGSCM_SetCard_Stub(Packet, i, CardCount, HiddenCardID); 

			BroadcastPacket(&Packet, (cROGGamePlayer*)pPlayer);
			
			// ¥ ī带 
			char CardID;

			CardID = CardStack[CardStackTopIndex].cID; // 52 ī带 ̸  ִ.
			CardStackTopIndex --;


			pPlayer->TakeCard(CardCount, CardID);

			Packet.SetHeader(RPCO_Owner, ROGSCM_SetCard);
			ROGSCM_SetCard_Stub(Packet, i, CardCount, CardID); 

			pPlayer->SendPacket(&Packet);

		}
	}
}

void cROGSevenPokerRoom::SetSeqIDOrder(int nCardNumber){
	int i;
	cROGSevenPokerPlayer *pPlayer;
	int TopScore;
	int Score;
	char TopScoreSeqID;

	
	TopScore = 0; //  ī  

	//   Ѵ.
	
	for(i = 0; i < MAX_ROOM_PLAYER_COUNT; i ++){
		pPlayer = GetPlayingPlayer(i);
		if(!pPlayer)
			continue;

		switch(nCardNumber){
		case 1:
			Score = GetCardsScore1(((cROGSevenPokerPlayer*)pPlayer)->CardStack + 2);
			break;
		case 2:
			Score = GetCardsScore2(((cROGSevenPokerPlayer*)pPlayer)->CardStack + 2);
			break;
		case 3:
			Score = GetCardsScore3(((cROGSevenPokerPlayer*)pPlayer)->CardStack + 2);
			break;
		case 4:
			Score = GetCardsScore4(((cROGSevenPokerPlayer*)pPlayer)->CardStack + 2);
			break;
		default:
			ASSERT(FALSE);
			break;
		}

		if(TopScore < Score){
			TopScore = Score;
			TopScoreSeqID = i;
		}
	}

	//  ο
	for(i = 1; i < MAX_ROOM_PLAYER_COUNT; i ++){
		SeqIDOrder[i] = -1;
	}

	SeqIDOrder[0] =  TopScoreSeqID;

	int nCount = GetPlayingPlayerCount();
	for(i = nCount - 1 ; i > 0; i--)
		SeqIDOrder[i] = (TopScoreSeqID + i) % nCount;

	CurBetPlayerSeqID = SeqIDOrder[0];

}	

void cROGSevenPokerRoom::Deal(char cDealCount){ //  ߾ 1 
	//  ī尡   .
	char i;
	cROGSevenPokerPlayer *pPlayer;
	cRPCPacket Packet;

	
	for(i = 0; i < MAX_ROOM_PLAYER_COUNT; i ++){
		if(SeqIDOrder[i] != -1){
			pPlayer = GetPlayingPlayer(SeqIDOrder[i]);
			if(pPlayer){
				char cCardID;

				cCardID = CardStack[CardStackTopIndex].cID; // 52 ī带 ̸  ִ.
				CardStackTopIndex --;

				pPlayer->TakeCard(cDealCount, cCardID);

				Packet.SetHeader(RPCO_Owner, ROGSCM_SetCard);
				ROGSCM_SetCard_Stub(Packet, SeqIDOrder[i], cDealCount, cCardID); 

				BroadcastPacket(&Packet);
			}
		}

	}

}

void cROGSevenPokerRoom::LastDeal(){ //  ߾  ī 
	//  ī尡   .
	int i;
	cRPCPacket Packet;
	cROGSevenPokerPlayer * pPlayer;

	for(i = 0; i < MAX_ROOM_PLAYER_COUNT; i ++){
		if(SeqIDOrder[i] != -1){
			pPlayer = GetPlayingPlayer(SeqIDOrder[i]);
			if(!pPlayer)
				continue;

			char CardID;
			char cDealCount = 6;
			char HiddenCardID = 52;


			CardID = CardStack[CardStackTopIndex].cID; // 52 ī带 ̸  ִ.
			CardStackTopIndex --;

			((cROGSevenPokerPlayer*)pPlayer)->TakeCard(6, CardID);

			Packet.SetHeader(RPCO_Owner, ROGSCM_SetCard);
			ROGSCM_SetCard_Stub(Packet, SeqIDOrder[i], cDealCount, HiddenCardID); 

			BroadcastPacket(&Packet, (cROGGamePlayer*)pPlayer);

			Packet.SetHeader(RPCO_Owner, ROGSCM_SetCard);
			ROGSCM_SetCard_Stub(Packet, SeqIDOrder[i], cDealCount, CardID); 

			pPlayer->SendPacket(&Packet);
		}

	}
}
// End of Deal

void cROGSevenPokerRoom::StartPoker(){
	// Ŀ  Ѵ.
	cROGSevenPokerPlayer *pPlayer;
	cRPCPacket Packet;
	char i;

	SetPlayerRoomSeqID();	//÷̾鿡 ȣ ҴѴ.
	MixCards();				// ī带  غ д.

	nBetChip = 0;			
	nRaiseChip = 0;
	nLastBetChip = 0;
	CurBetPlayerSeqID = 0;

 	for(i = 0; i < MAX_ROOM_PLAYER_COUNT; i ++){
		pPlayer = GetJoinRoomPlayer(i);
		if(pPlayer){
			EngagePlayerIntoGame(pPlayer);

			pPlayer->InitStage();

			if(pPlayer->GetChip() > MIN_BET_CHIP){ //    ִ 
				int nChip = pPlayer->GetChip();
				nChip -= MIN_BET_CHIP;
				pPlayer->SetChip(nChip);
				nBetChip += MIN_BET_CHIP;

				// Ŭ̾Ʈ   
				Packet.SetHeader(RPCO_Owner, ROGSCM_SetChip);
				ROGSCM_SetChip_Stub(Packet, i, nChip);
				BroadcastPacket(&Packet);
			
			}else{
				//   (Ļ)
				pPlayer->SetWatching();
			}
	
			Packet.SetHeader(RPCO_Owner, ROGSCM_StartPoker);
			pPlayer->SendPacket(&Packet);

		}
	}

	Packet.SetHeader(RPCO_Owner, ROGSCM_SetBetChip);
	ROGSCM_SetBetChip_Stub(Packet, nBetChip);
	BroadcastPacket(&Packet);

	FirstDeal();

	Packet.SetHeader(RPCO_Owner, ROGSCM_ChooseFlipCard);
	BroadcastPacket(&Packet);

	nGameState = GS_WaitCardFlip;
	CardFlipCount = 0;

	printf("Room[%2d].StartPokerGame()\n", RoomID);

}

void cROGSevenPokerRoom::NotifyPlayerCardFlip(){
	cRPCPacket Packet;

	CardFlipCount ++;

	if(GetPlayingPlayerCount() == CardFlipCount){
		//  ī带 
		cRPCPacket Packet;
		cROGSevenPokerPlayer *pPlayer;
		char i;
		char cDealCount = 2;

		//  ī带 Ŭ̾Ʈ ˸
		for(i = 0; i < MAX_ROOM_PLAYER_COUNT; i ++){
			pPlayer = GetPlayingPlayer(i);
			if(pPlayer){
				Packet.SetHeader(RPCO_Owner, ROGSCM_SetCard);
				char cCardID = ((cROGSevenPokerPlayer*)pPlayer)->CardStack[2].cID;
				ROGSCM_SetCard_Stub(Packet, i, cDealCount, cCardID);

				BroadcastPacket(&Packet, (cROGGamePlayer*)pPlayer);
			}
		}

		
		SetSeqIDOrder(1);
		Deal(3);
		nGameState = GS_WaitFirstBet;

		SetSeqIDOrder(2);
		StartBet();

	}
}

int cROGSevenPokerRoom::GetPlayingPlayerCount(){
	int PlayerCount;

	PlayerCount = 0;

	cList<cROGPlayer *>::cCursor	csr;
	cROGPlayer *pPlayer;
	cROGGamePlayer * pGamePlayer;

	for(csr = PlayerList.Head(); csr != 0; csr ++){
		pPlayer = *csr;
		pGamePlayer = pPlayer->GetGamePlayer();
		
		if(((cROGSevenPokerPlayer*)pGamePlayer)->IsPlayerPlaying())
			PlayerCount ++;
	}

	return PlayerCount;

}

int cROGSevenPokerRoom::GetPlayerCount(){
	return PlayerList.GetCount();
	
}


void cROGSevenPokerRoom::SetPlayerRoomSeqID(){

	
	cList<cROGPlayer *>::cCursor	csr;
	cROGPlayer *pPlayer;
	cROGGamePlayer * pGamePlayer;

	int i = 0;

	for(csr = PlayerList.Head(); csr != 0; csr ++){
		pPlayer = *csr;

		pGamePlayer = pPlayer->GetGamePlayer();
		((cROGSevenPokerPlayer*)pGamePlayer)->RoomSeqID = i;
		i++;

	}
	
}

char cROGSevenPokerRoom::GetNextOrderPlayerSeqID(){
	char OldCurBetPlayerSeqID;
	cROGSevenPokerPlayer *pPlayer;

	OldCurBetPlayerSeqID = CurBetPlayerSeqID;

	for(;;){
		//   ã´.
		pPlayer = 0;
		while(pPlayer == 0){
			CurBetPlayerSeqID ++;
			CurBetPlayerSeqID %= MAX_ROOM_PLAYER_COUNT;
	/*		while(SeqIDOrder[CurBetPlayerSeqID] == -1){
				CurBetPlayerSeqID ++;
				CurBetPlayerSeqID %= MAX_ROOM_PLAYER_COUNT;
			}
*/
			pPlayer = GetPlayingPlayer(CurBetPlayerSeqID);
		
		}

		if(CurBetPlayerSeqID == OldCurBetPlayerSeqID){
			//  ȥ ۿ .
			return -1;
			//CurBetPlayerSeqID  -1 ϴ 쿡 
			// StartBet() Լ ȣ   SetSeqIDOrder()Լ ȣؼ
			//CurBetPlayerSeqID -1 ƴ Ȯ  ʱȭ ؾ Ѵ.
		}


		if(((cROGSevenPokerPlayer*)pPlayer)->BetCountLimit > 0){
			break;
		}
		else if(((cROGSevenPokerPlayer*)pPlayer)->BetCountLimit == 0){
			return -1;
		}
	}

	return CurBetPlayerSeqID;

}

void cROGSevenPokerRoom::DeclareCheck(char SeqID){
	if(SeqID != CurBetPlayerSeqID)
		ASSERT(FALSE);

	// Check 

	// Check   ˸
	cRPCPacket Packet;

	Packet.SetHeader(RPCO_Owner, ROGSCM_SayCheck);
	ROGSCM_SayCheck_Stub(Packet, SeqID);
	BroadcastPacket(&Packet);

	cROGSevenPokerPlayer * pPlayer = GetPlayingPlayer(SeqID);
	if(!pPlayer)
		ASSERT(FALSE);

	if(pPlayer->BetCountLimit > 0){
		pPlayer->BetCountLimit --;
	}
	 
	pPlayer->PrevBetType = EBT_Check;

	if(pPlayer->BetCountLimit == 1){
		if(CheckEndGame())
			return;
	}


	CurBetPlayerSeqID = GetNextOrderPlayerSeqID();

	if(CurBetPlayerSeqID >= 0){
		Packet.SetHeader(RPCO_Owner, ROGSCM_SetOrder);
		ROGSCM_SetOrder_Stub(Packet, CurBetPlayerSeqID);
		BroadcastPacket(&Packet);
		
		cROGGamePlayer * pNextPlayer = (cROGGamePlayer*)(GetPlayingPlayer(CurBetPlayerSeqID));
		if(!pNextPlayer)
			ASSERT(FALSE);

		if(((cROGSevenPokerPlayer*)pNextPlayer)->PrevBetType == EBT_Bet){
			//    ο
			if(nRaiseChip == 0){
				Packet.SetHeader(RPCO_Owner, ROGSCM_SetAfterCheckRole);
				pNextPlayer->SendPacket(&Packet);
			}else{
				Packet.SetHeader(RPCO_Owner, ROGSCM_SetAfterBetRole);
				pNextPlayer->SendPacket(&Packet);
			}
		}
		else if(((cROGSevenPokerPlayer*)pNextPlayer)->PrevBetType == EBT_Call){
			//    ο
			if(nRaiseChip == 0){
				Packet.SetHeader(RPCO_Owner, ROGSCM_SetAfterCheckRole);
				pNextPlayer->SendPacket(&Packet);
			}else{
				Packet.SetHeader(RPCO_Owner, ROGSCM_SetAfterCallRole);
				pNextPlayer->SendPacket(&Packet);
			}

		}
		else if(((cROGSevenPokerPlayer*)pNextPlayer)->PrevBetType == EBT_Check){
			EndBet();
		}

		
	}else{
		//  
		EndBet();

	}
}


bool cROGSevenPokerRoom::CheckEndGame(){

	cROGGamePlayer * pPlayer;
	bool bEndGameFlag = true;


	int i;
	for(i = 0; i < MAX_ROOM_PLAYER_COUNT; i ++){
		pPlayer = GetPlayingPlayer(i);
		if(pPlayer){
			if(((cROGSevenPokerPlayer*)pPlayer)->PrevBetType == EBT_Bet){
				i = MAX_ROOM_PLAYER_COUNT;
				bEndGameFlag = false;
			}
		}
	}

	if(bEndGameFlag){
		nGameState = GS_WaitLastBet;
		EndBet();
		
	}

	return bEndGameFlag;
}

void cROGSevenPokerRoom::DeclareCall(char SeqID){
	//  Ͽ
	cRPCPacket Packet;
	cROGSevenPokerPlayer *pPlayer;

	if(SeqID != CurBetPlayerSeqID)
		ASSERT(FALSE);

	Packet.SetHeader(RPCO_Owner, ROGSCM_SayCall);
	ROGSCM_SayCall_Stub(Packet, SeqID);
	BroadcastPacket(&Packet);
	
	pPlayer = GetPlayingPlayer(SeqID);
	if(!pPlayer)
		ASSERT(FALSE);

	int nChip = pPlayer->GetChip();
	//  Die Ų.
	if(nChip <= 0)
		DeclareDie(SeqID);

	nChip -= nRaiseChip;
	
	if(nChip < 0){
		nChip = 0;
	}

	pPlayer->SetChip(nChip);
	nBetChip += nRaiseChip;

	
	Packet.SetHeader(RPCO_Owner, ROGSCM_SetBetChip);
	ROGSCM_SetBetChip_Stub(Packet, nBetChip);
	BroadcastPacket(&Packet);

	Packet.SetHeader(RPCO_Owner, ROGSCM_SetChip);
	ROGSCM_SetChip_Stub(Packet, SeqID, nChip);
	BroadcastPacket(&Packet);

	if(pPlayer->BetCountLimit > 0){
		pPlayer->BetCountLimit --;
	}
	
	pPlayer->PrevBetType = EBT_Call;

	//ù ̽  check    call  쿡 CheckEndGame() ȣǾѴ.
	//׷, BetCountLimit ʱⰪ 3 ɰ쿡,  3 ̽  쿡 CheckEndGame() 
	//ȣ  ʴ װ ߻  ִ.
	if(pPlayer->BetCountLimit == 1){
		if(CheckEndGame())
			return;
	}


	CurBetPlayerSeqID = GetNextOrderPlayerSeqID();

	if(CurBetPlayerSeqID >= 0){
		Packet.SetHeader(RPCO_Owner, ROGSCM_SetOrder);
		ROGSCM_SetOrder_Stub(Packet, CurBetPlayerSeqID);
		BroadcastPacket(&Packet);
		
		cROGGamePlayer * pNextPlayer = (cROGGamePlayer*)(GetPlayingPlayer(CurBetPlayerSeqID));
		if(!pNextPlayer)
			ASSERT(FALSE);

		if(((cROGSevenPokerPlayer*)pNextPlayer)->PrevBetType == EBT_Bet){
			//    ο
			if(nRaiseChip == 0){
				Packet.SetHeader(RPCO_Owner, ROGSCM_SetAfterCheckRole);
				pNextPlayer->SendPacket(&Packet);
			}else{
				Packet.SetHeader(RPCO_Owner, ROGSCM_SetAfterBetRole);
				pNextPlayer->SendPacket(&Packet);
			}
		}
		else if(((cROGSevenPokerPlayer*)pNextPlayer)->PrevBetType == EBT_Call){
			//    ο
			if(nRaiseChip == 0){
				Packet.SetHeader(RPCO_Owner, ROGSCM_SetAfterCheckRole);
				pNextPlayer->SendPacket(&Packet);
			}else{
				Packet.SetHeader(RPCO_Owner, ROGSCM_SetAfterCallRole);
				pNextPlayer->SendPacket(&Packet);
			}

		}
		else if(((cROGSevenPokerPlayer*)pNextPlayer)->PrevBetType == EBT_Check){
			EndBet();
		}


	}else{
		//  
		EndBet();

	}

}

void cROGSevenPokerRoom::BetChip(char SeqID, int _nChip){
	
	cRPCPacket Packet;

	cROGSevenPokerPlayer * pPlayer = GetPlayingPlayer(SeqID);
	if(!pPlayer)
		ASSERT(FALSE);
		
	//  Ǵ.
	if(pPlayer->BetCountLimit > 0){
		pPlayer->BetCountLimit --;
	}

	int nChip = pPlayer->GetChip();
	//  Die Ų.
	if(nChip <= 0)
		DeclareDie(SeqID);

	
	nBetChip += nRaiseChip + _nChip;
	nChip -= (nRaiseChip + _nChip);

	if(nChip < 0){
		nChip = 0;
	}

	pPlayer->SetChip(nChip);

	nRaiseChip += _nChip;
	nLastBetChip = _nChip;

	Packet.SetHeader(RPCO_Owner, ROGSCM_SetBetChip);
	ROGSCM_SetBetChip_Stub(Packet, nBetChip);
	BroadcastPacket(&Packet);
	Packet.SetHeader(RPCO_Owner, ROGSCM_SetRaiseChip);
	ROGSCM_SetRaiseChip_Stub(Packet, nRaiseChip);
	BroadcastPacket(&Packet);

	Packet.SetHeader(RPCO_Owner, ROGSCM_SayBet);
	ROGSCM_SayBet_Stub(Packet, SeqID);
	BroadcastPacket(&Packet);

	Packet.SetHeader(RPCO_Owner, ROGSCM_SetChip);
	ROGSCM_SetChip_Stub(Packet, SeqID, nChip);
	BroadcastPacket(&Packet);

	pPlayer->PrevBetType = EBT_Bet;

	CurBetPlayerSeqID = GetNextOrderPlayerSeqID();
	
	if(CurBetPlayerSeqID >= 0){
		Packet.SetHeader(RPCO_Owner, ROGSCM_SetOrder);
		ROGSCM_SetOrder_Stub(Packet, CurBetPlayerSeqID);
		BroadcastPacket(&Packet);
		
		cROGGamePlayer * pNextPlayer = (cROGGamePlayer*)(GetPlayingPlayer(CurBetPlayerSeqID));
		if(!pNextPlayer)
			ASSERT(FALSE);
		

		if(((cROGSevenPokerPlayer*)pNextPlayer)->PrevBetType == EBT_Bet){
			//    ο
			if(nRaiseChip == 0){
				Packet.SetHeader(RPCO_Owner, ROGSCM_SetAfterCheckRole);
				pNextPlayer->SendPacket(&Packet);
			}else{
				Packet.SetHeader(RPCO_Owner, ROGSCM_SetAfterBetRole);
				pNextPlayer->SendPacket(&Packet);
			}
		}
		else if(((cROGSevenPokerPlayer*)pNextPlayer)->PrevBetType == EBT_Call){
			//    ο
			if(nRaiseChip == 0){
				Packet.SetHeader(RPCO_Owner, ROGSCM_SetAfterCheckRole);
				pNextPlayer->SendPacket(&Packet);
			}else{
				Packet.SetHeader(RPCO_Owner, ROGSCM_SetAfterCallRole);
				pNextPlayer->SendPacket(&Packet);
			}

		}
		else if(((cROGSevenPokerPlayer*)pNextPlayer)->PrevBetType == EBT_Check){
			EndBet();
		}


	}else{
		//  
		EndBet();

	}
}


void cROGSevenPokerRoom::DeclareBet(char SeqID, int nChip){
	cRPCPacket Packet;

	if(SeqID != CurBetPlayerSeqID)
		ASSERT(FALSE);
		

	BetChip(SeqID, nChip);
}

void cROGSevenPokerRoom::DeclareBetHalf(char SeqID){


	// ǵ  ɰڴٰ 
	if(SeqID != CurBetPlayerSeqID)
		ASSERT(FALSE);
		


	BetChip(SeqID, (nBetChip + 1) / 2);
}

void cROGSevenPokerRoom::DeclareBetDBL(char SeqID){


	// ջ Ѹ ŭ ɰڴٰ 
	if(SeqID != CurBetPlayerSeqID)
		ASSERT(FALSE);
		


	BetChip(SeqID, nLastBetChip);
}

void cROGSevenPokerRoom::DeclareDie(char SeqID){
	if(SeqID != CurBetPlayerSeqID)
		ASSERT(FALSE);

	cRPCPacket Packet;

	Packet.SetHeader(RPCO_Owner, ROGSCM_SayDie);
	ROGSCM_SayDie_Stub(Packet, SeqID);
	BroadcastPacket(&Packet);
	
	cROGSevenPokerPlayer * pPlayer = GetPlayingPlayer(SeqID);
	if(!pPlayer)
		ASSERT(FALSE);
		
		
	pPlayer->BetCountLimit = -1;
	pPlayer->PrevBetType = EBT_Die;

	if(pPlayer->BetCountLimit == 1){
		if(CheckEndGame())
			return;
	}



	CurBetPlayerSeqID = GetNextOrderPlayerSeqID();

	pPlayer->SetWatching();

	if(GetPlayingPlayerCount() == 1){
		EstimateAllCards();

	}else if(GetPlayingPlayerCount() == 0){
		pPlayer->SetPlaying();
		EstimateAllCards();
		pPlayer->SetWatching();

	}else{
		if(CurBetPlayerSeqID >= 0){
			Packet.SetHeader(RPCO_Owner, ROGSCM_SetOrder);
			ROGSCM_SetOrder_Stub(Packet, CurBetPlayerSeqID);
			BroadcastPacket(&Packet);
			
			cROGGamePlayer * pNextPlayer = (cROGGamePlayer*)(GetPlayingPlayer(CurBetPlayerSeqID));
			if(!pNextPlayer)
				ASSERT(FALSE);

			if(((cROGSevenPokerPlayer*)pNextPlayer)->PrevBetType == EBT_Bet){
				//    ο
				if(nRaiseChip == 0){
					Packet.SetHeader(RPCO_Owner, ROGSCM_SetAfterCheckRole);
					pNextPlayer->SendPacket(&Packet);
				}else{
					Packet.SetHeader(RPCO_Owner, ROGSCM_SetAfterBetRole);
					pNextPlayer->SendPacket(&Packet);
				}
			}
			else if(((cROGSevenPokerPlayer*)pNextPlayer)->PrevBetType == EBT_Call){
				//    ο
				if(nRaiseChip == 0){
					Packet.SetHeader(RPCO_Owner, ROGSCM_SetAfterCheckRole);
					pNextPlayer->SendPacket(&Packet);
				}else{
					Packet.SetHeader(RPCO_Owner, ROGSCM_SetAfterCallRole);
					pNextPlayer->SendPacket(&Packet);
				}

			}
			else if(((cROGSevenPokerPlayer*)pNextPlayer)->PrevBetType == EBT_Check){
				EndBet();
			}


		}else{
			//  
			EndBet();

		}
	}
}

void cROGSevenPokerRoom::StartBet(){
	cRPCPacket Packet;

	
	
	Packet.SetHeader(RPCO_Owner, ROGSCM_SetOrder);
	ROGSCM_SetOrder_Stub(Packet, SeqIDOrder[0]);
	BroadcastPacket(&Packet);
	
	cROGSevenPokerPlayer * pPlayer = GetPlayingPlayer(SeqIDOrder[0]);
	if(!pPlayer)
		ASSERT(FALSE);
		
		
	//  ī带    ο
	Packet.SetHeader(RPCO_Owner, ROGSCM_SetBossRole);
	pPlayer->SendPacket(&Packet);

	//  ڵ鿡  Ƚ  οѴ.
	int i;
	for(i = 0; i < MAX_ROOM_PLAYER_COUNT; i ++){
		pPlayer = GetPlayingPlayer(i);

		if(pPlayer){
			pPlayer->BetCountLimit = 2; // ѹ Ѵ.
			pPlayer->PrevBetType = EBT_Bet;
		}
	}

	nRaiseChip = 0;
}
void cROGSevenPokerRoom::EndBet(){
	nRaiseChip = 0;
	nLastBetChip = 0;

	cRPCPacket Packet;
	Packet.SetHeader(RPCO_Owner, ROGSCM_SetBetChip);
	ROGSCM_SetBetChip_Stub(Packet,	nBetChip);
	BroadcastPacket(&Packet);

	Packet.SetHeader(RPCO_Owner, ROGSCM_SetRaiseChip);
	ROGSCM_SetRaiseChip_Stub(Packet, nRaiseChip);
	BroadcastPacket(&Packet);

	
	char cFlag = -1;
	
	Packet.SetHeader(RPCO_Owner, ROGSCM_SetOrder);
	ROGSCM_SetOrder_Stub(Packet, cFlag);
	BroadcastPacket(&Packet);

	switch(nGameState){
	case GS_WaitFirstBet:
		Deal(4);
		nGameState = GS_WaitSecondBet;
		SetSeqIDOrder(3);
		StartBet();
		break;

	case GS_WaitSecondBet:
		//ThirdDeal;
		Deal(5);
		nGameState = GS_WaitThirdBet;
		SetSeqIDOrder(4);
		StartBet();
		break;

	case GS_WaitThirdBet:
		LastDeal();
		nGameState = GS_WaitLastBet;
		SetSeqIDOrder(4);
		StartBet();
		break;

	case GS_WaitLastBet:
		time(&lPrevTime);
		EstimateAllCards();
		break;

	default:
		ASSERT(FALSE);
		
		break;

	}


}


cROGSevenPokerPlayer * cROGSevenPokerRoom::GetPlayingPlayer(char i){

	if(i < 0)
		ASSERT(FALSE);
		

	cList<cROGPlayer *>::cCursor	csr;
	cROGPlayer *pPlayer;
	cROGGamePlayer * pGamePlayer;

	
	for(csr = PlayerList.Head(); csr != 0; csr ++){
		pPlayer = *csr;
		
		pGamePlayer = pPlayer->GetGamePlayer();
		
		if(((cROGSevenPokerPlayer*)pGamePlayer)->RoomSeqID == i){
			if(((cROGSevenPokerPlayer*)pGamePlayer)->IsPlayerPlaying())
				return (cROGSevenPokerPlayer*)pGamePlayer;
		}

	}
	return 0;
}

cROGSevenPokerPlayer * cROGSevenPokerRoom::GetJoinRoomPlayer(char i){

	if(i < 0)
		ASSERT(FALSE);
		

	cList<cROGPlayer *>::cCursor	csr;
	cROGPlayer *pPlayer;
	cROGGamePlayer * pGamePlayer;

	for(csr = PlayerList.Head(); csr != 0; csr ++){
		pPlayer = *csr;

		pGamePlayer = pPlayer->GetGamePlayer();

		if(((cROGSevenPokerPlayer*)pGamePlayer)->RoomSeqID == i){
			return (cROGSevenPokerPlayer*)pGamePlayer;
		}

	}
	return 0;
}


void cROGSevenPokerRoom::EstimateAllCards(){
	char i;

	cROGSevenPokerPlayer *pPlayer;
	cRPCPacket Packet;
	

	char TopSeqID = -1;
	int TopPokerBook = -1;
	char TopPokerBookLevel = 0;
	
	if(nGameState == GS_WaitLastBet){
		for(i = 0; i < 4; i ++){

			pPlayer = GetPlayingPlayer(i);
		
			if(pPlayer){
				// ڵ鿡  Ѵ.
				EstimateCards(pPlayer->CardStack, &pPlayer->PokerBook, &pPlayer->PokerBookLevel);


				if(pPlayer->PrevBetType != EBT_Die){
					Packet.SetHeader(RPCO_Owner, ROGSCM_SetPokerBook);
					ROGSCM_SetPokerBook_Stub(Packet, i, pPlayer->PokerBook, pPlayer->PokerBookLevel, pPlayer->CardStack);
					BroadcastPacket(&Packet);
				}

			}

		}


		// 1 Ѵ.

		for(i = 0; i < 4; i ++){
			pPlayer = GetPlayingPlayer(i);
		
			if(pPlayer){
				if((int)pPlayer->PokerBook > TopPokerBook){

					TopPokerBook = pPlayer->PokerBook;
					TopPokerBookLevel = pPlayer->PokerBookLevel;
					TopSeqID = i;

				}else if((int)pPlayer->PokerBook == TopPokerBook && 
							pPlayer->PokerBookLevel > TopPokerBookLevel){

					TopPokerBook = pPlayer->PokerBook;
					TopPokerBookLevel = pPlayer->PokerBookLevel;
					TopSeqID = i;
				}

			}
		}
	}else{
		if(nGameState != GS_WaitLastBet){
			//   ƴѰ
			if(GetPlayingPlayerCount() == 1){
				// ̳ ̱ɷ ģ.
				for(i = 0; i < MAX_ROOM_PLAYER_COUNT; i ++){
					pPlayer = GetPlayingPlayer(i);
					if(pPlayer){ 
						TopSeqID = i;
						pPlayer->PokerBook = PB_NoPair;
						break;
					}

				}
			}else{
				nGameState = GS_Wait;
				time(&lPrevTime);
				printf("Room[%2d].EndPokerGame()\n", RoomID);
				return;
			}
		}

	}

	// ̱   

	pPlayer = GetPlayingPlayer(TopSeqID);
	if(!pPlayer)
		ASSERT(FALSE);
		
	int nChip = pPlayer->GetChip();
	nChip += nBetChip;
		pPlayer->SetChip(nChip);


	Packet.SetHeader(RPCO_Owner, ROGSCM_SetWinner);
	ROGSCM_SetWinner_Stub(Packet, TopSeqID, pPlayer->PokerBook);

	char CardID;
	for(i = 0; i < 7; i ++){
		CardID = pPlayer->CardStack[i].cID;
		ROGSCM_CardIDInfo_Stub(Packet, CardID);
	}
	
	

	BroadcastPacket(&Packet);

	Packet.SetHeader(RPCO_Owner, ROGSCM_SetChip);
	ROGSCM_SetChip_Stub(Packet, TopSeqID, nChip);
	BroadcastPacket(&Packet);

	nGameState = GS_Wait;
	time(&lPrevTime);

	printf("Room[%2d].EndPokerGame()\n", RoomID);

}



bool cROGSevenPokerRoom::BroadcastPacket(cRPCPacket *pPacket, cROGGamePlayer *pPlayerExcept){
	
	if(cROGRoom::BroadcastPacket(pPacket, pPlayerExcept)){
		int nMethodID;
		nMethodID = pPacket->GetMethodID();
		printf("			Send BroadCast MSG:	");
		switch(nMethodID){

		case ROGSCM_PlayerInfo:
			printf("ROGSCM_PlayerInfo\n");
			break;
		case ROGSCM_RemovePlayer: 
			printf("ROGSCM_RemovePlayer\n");
			break;
		case ROGSCM_WaiterInfo: 
			printf("ROGSCM_WaiterInfo\n");
			break;
		case ROGSCM_StartPoker: 
			printf("ROGSCM_StartPoker\n");
			break;
		case ROGSCM_SetCard: 
			printf("ROGSCM_SetCard\n");
			break;
		case ROGSCM_ChooseFlipCard: 
			printf("ROGSCM_ChooseFlipCard\n");
			break;
		case ROGSCM_SetChip: 
			printf("ROGSCM_SetChip\n");
			break;
		case ROGSCM_SetBetChip: 
			printf("ROGSCM_SetBetChip\n");
			break;
		case ROGSCM_SetRaiseChip: 
			printf("ROGSCM_SetRaiseChip\n");
			break;
		case ROGSCM_SetWinner: 
			printf("ROGSCM_SetWinner\n");
			break;
		case ROGSCM_SetPokerBook: 
			printf("ROGSCM_SetPokerBook\n");
			break;

		case ROGSCM_SetBossRole: 
			printf("ROGSCM_SetBossRole\n");
			break;
		case ROGSCM_SetAfterCheckRole: 
			printf("ROGSCM_SetAfterCheckRole\n");
			break;
		case ROGSCM_SetAfterBetRole: 
			printf("ROGSCM_SetAfterBetRole\n");
			break;
		case ROGSCM_SetOrder: 
			printf("ROGSCM_SetOrder\n");
			break;

		case ROGSCM_SayCheck: 
			printf("ROGSCM_SayCheck\n");
			break;
		case ROGSCM_SayCall: 
			printf("ROGSCM_SayCall\n");
			break;
		case ROGSCM_SayGood: 
			printf("ROGSCM_SayGood\n");
			break;
		case ROGSCM_SayDie: 
			printf("ROGSCM_SayDie\n");
			break;
		case ROGSCM_SayBet: 
			printf("ROGSCM_SayBet\n");
			break;

		case ROGSCM_CardIDInfo: 
			printf("ROGSCM_CardIDInfo\n");
			break;

		}

		return true;
	}
	else
		return false;
}



