#ifndef cROGSevenPokerRoom_H
#define cROGSevenPokerRoom_H

#include "ROGRoom.h"
#include "cCard.h"
#include "ROGSevenPokerPlayer.h"
#include <ctime>


#define MAX_ROOM_PLAYER_COUNT	4


enum EGameState{
	GS_Wait,
	GS_WaitCardFlip,// ī 徿 
	GS_WaitFirstBet,
	GS_WaitSecondBet,
	GS_WaitThirdBet,
	GS_WaitLastBet,
};

class cROGSevenPokerRoom : public cROGRoom{

protected:
	EGameState nGameState;

	int nBetChip; // ǵ
	int nRaiseChip; // ø
	int nLastBetChip; //  ǵ
	bool bWaitingOthers;

	time_t lTime;
	time_t lPrevTime;
	int PlayerCount;

	char SeqIDOrder[MAX_ROOM_PLAYER_COUNT];
	char SeqIDLocation[MAX_ROOM_PLAYER_COUNT];
	char CurBetPlayerSeqID;

	cCard CardStack[52]; // 52 ī带 ̸  ִ.
	int CardStackTopIndex;

	void MixCards();

	void FirstDeal(); // 3 
	void Deal(char cDealCount);
	void SecondDeal(); //  ߾ 2 
	void ThirdDeal(); //  ߾ 1 
	void LastDeal(); //  ߾  ī 

	int CardFlipCount; // ڰ ī  

	void EstimateAllCards();

	char GetNextOrderPlayerSeqID();
	void StartBet();
	void BetChip(char SeqID, int nChip);

	void EndBet();

	void SetPlayerRoomSeqID();

	void StartPoker();

	bool CheckEndGame();


public:
	cROGSevenPokerRoom();
	virtual ~cROGSevenPokerRoom();

	virtual bool			BroadcastPacket(cRPCPacket *pPacket, cROGGamePlayer *pPlayerExcept = 0);

	virtual bool	Create(short NewRoomID, int NewPlayerCountLimit);
	virtual void	Destroy();

	virtual bool	AddPlayer(cROGPlayer *pNewPlayer);
	virtual void	RemovePlayer(cROGPlayer *pPlayer);



public:

	void EngagePlayerIntoGame(cROGSevenPokerPlayer * pPlayer);	// ڸ ӿ Ŵ

	virtual bool Update();

	void InitCards();
	void DealThreeCard();
	void DealCard(int _nCount);

	void InitGamePlayerList();
	void EmptyNowGamePlayerList();

	int GetGameState(){ return (int)nGameState;} 
	int GetBetChip(){ return nBetChip;}

	void NotifyPlayerCardFlip();

	int GetPlayingPlayerCount();
	int GetPlayerCount();

	void DeclareCheck(char SeqID);
	void DeclareCall(char SeqID);
	void DeclareGood(char SeqID);
	void DeclareBetDBL(char SeqID);
	void DeclareBetHalf(char SeqID);
	void DeclareBet(char SeqID, int nChip);
	void DeclareDie(char SeqID);

	void SetSeqIDOrder(int nCardNumber);

	cROGSevenPokerPlayer * GetPlayingPlayer(char i);
	cROGSevenPokerPlayer * GetJoinRoomPlayer(char i);


};

#endif