#ifndef ROGSevenPokerRoomProtocol_H
#define ROGSevenPokerRoomProtocol_H

#include "cRPC.h"
#include "cCard.h"

// Lobby Server Protocol ////////////////////////////////////////////////////////////////////////////////

enum eROGSevenPokerServerMethodID{

	ROGSSM_JoinPokerGame,
	ROGSSM_LeavePokerRoom,
	ROGSSM_FlipOneCard,
	ROGSSM_Check,
	ROGSSM_Call,
	ROGSSM_Good,
	ROGSSM_Die,
	ROGSSM_BetDBL,
	ROGSSM_BetHalf,
	ROGSSM_Bet,
	
};

// Lobby Client Protocol ////////////////////////////////////////////////////////////////////////////////
enum eROGSevenPokerClientMethodID{
	
	ROGSCM_PlayerInfo,
	ROGSCM_RemovePlayer,
	ROGSCM_WaiterInfo,
	ROGSCM_StartPoker,
	ROGSCM_SetCard,
	ROGSCM_ChooseFlipCard,
	ROGSCM_SetChip,
	ROGSCM_SetBetChip,
	ROGSCM_SetRaiseChip,
	ROGSCM_SetWinner,
	ROGSCM_SetPokerBook,

	ROGSCM_SetBossRole,
	ROGSCM_SetAfterCheckRole,
	ROGSCM_SetAfterBetRole,
	ROGSCM_SetAfterCallRole,
	ROGSCM_SetOrder,

	ROGSCM_SayCheck,
	ROGSCM_SayCall,
	ROGSCM_SayGood,
	ROGSCM_SayDie,
	ROGSCM_SayBet,

	ROGSCM_CardIDInfo,

	ROGSCM_LeaveSevenPokerRoom,


};


void ROGSSM_JoinPokerGame_Stub(cRPCPacket &Packet);
void ROGSSM_LeavePokerRoom_Stub(cRPCPacket &Packet);
void ROGSSM_FlipOneCard_Stub(cRPCPacket &Packet, char &cPos);
void ROGSSM_Check_Stub(cRPCPacket &Packet);
void ROGSSM_Call_Stub(cRPCPacket &Packet);
void ROGSSM_Good_Stub(cRPCPacket &Packet);
void ROGSSM_Die_Stub(cRPCPacket &Packet);
void ROGSSM_Bet_Stub(cRPCPacket &Packet, int &nChip);


// Client ////////////////////////////////////////////////////////////////////////////////

void ROGSCM_PlayerInfo_Stub(cRPCPacket &Packet, char &RoomSeqID, char &LocationSeqID, char *Name, int &nChip);
void ROGSCM_PlayerID_Stub(cRPCPacket &Packet, char &i);
void ROGSCM_CardIDInfo_Stub(cRPCPacket &Packet, char &CardID);

void ROGSCM_RemovePlayer_Stub(cRPCPacket &Packet);
void ROGSCM_WaiterInfo_Stub(cRPCPacket &Packet, char &RoomSeqID, char &LocationSeqID, char *Name, int &nChip);
void ROGSCM_StartPoker_Stub(cRPCPacket &Packet);
void ROGSCM_SetCard_Stub(cRPCPacket &Packet, char &i, char &CardCount, char &HiddenCardID);
void ROGSCM_ChooseFlipCard_Stub(cRPCPacket &Packet);
void ROGSCM_SetChip_Stub(cRPCPacket &Packet, char &i, int &nChip);
void ROGSCM_SetBetChip_Stub(cRPCPacket &Packet, int &nBetChip);
void ROGSCM_SetRaiseChip_Stub(cRPCPacket &Packet, int &nRaistChip);
void ROGSCM_SetWinner_Stub(cRPCPacket &Packet, char &TopSeqID, ePokerBook &PokerBook);
void ROGSCM_SetPokerBook_Stub(cRPCPacket &Packet, char &i, ePokerBook &PokerBook, char &BookLevel, cCard *pCard);
void ROGSCM_LeaveSevenPokerRoom_Stub(cRPCPacket &Packet, char &RoomSeqID);


void ROGSCM_SetBossRole_Stub(cRPCPacket &Packet);
void ROGSCM_SetAfterCheckRole_Stub(cRPCPacket &Packet);
void ROGSCM_SetAfterBetRole_Stub(cRPCPacket &Packet);
void ROGSCM_SetAfterCallRole_Stub(cRPCPacket &Packet);
void ROGSCM_SetOrder_Stub(cRPCPacket &Packet, char & IDOrder);

void ROGSCM_SayCheck_Stub(cRPCPacket &Packet, char &i);
void ROGSCM_SayCall_Stub(cRPCPacket &Packet, char &i);
void ROGSCM_SayGood_Stub(cRPCPacket &Packet, char &i);
void ROGSCM_SayDie_Stub(cRPCPacket &Packet, char &i);
void ROGSCM_SayBet_Stub(cRPCPacket &Packet, char &i);


#endif




////////////////////////////////////////////////////////

