#include "StdAfx.h"
#include "cCard.h"

char MakeCard(eCardShape Shape, int No){
	return (char)((int)Shape * 13 + No);
}


cCard::cCard(){
	cID = 0;
	Visible = false;
}

cCard::cCard(char _cID, bool _Visible){
	cID = _cID;
	Visible = _Visible;
}

cCard::cCard(const cCard& _Card){
	cID = _Card.cID;
	Visible = _Card.Visible;
}

cCard& cCard::operator=(const cCard& _Card){
	cID = _Card.cID;
	Visible = _Card.Visible;
	return *this;
}


int cCard::GetNumber(){
	return cID % 13;
}

eCardShape cCard::GetShape(){
	return eCardShape(cID / 13);

}

int GetSameNumberCardCount(cCard *pCard, int Number, int CardCount = 7){
	// ش ī V Number شϴ ī  
	int Count;
	int i;

	Count = 0;
	for(i = 0; i < CardCount; i ++){
		if(pCard[i].GetNumber() == Number)
			Count ++;
	}

	return Count;
}

int GetSameNumberCardCount(cCard *pCard, int Number, int *pShape, int CardCount = 7){
	// ش ī п Number شϴ ī   
	int Count;
	int i;

	Count = 0;
	for(i = 0; i < CardCount; i ++){
		if(pCard[i].GetNumber() == Number){
			Count ++;
			*pShape = pCard[i].GetShape();
		}
	}

	return Count;
}

int GetSameShapeCardCount(cCard *pCard, int Shape, int CardCount = 7){
	// ش ī п Number شϴ ī  
	int Count;
	int i;

	Count = 0;
	for(i = 0; i < CardCount; i ++){
		if(pCard[i].GetShape() == Shape)
			Count ++;
	}

	return Count;
}

void EstimateCards(cCard *pCard, ePokerBook *pPokerBook, char *pLevel){
	int CardNums[13] = { 0, 12, 11, 10, 9, 8, 7, 6, 5, 4, 3, 2, 1 };
	int i, j, k;
	int ExpectedCard;
	int Level;

	// Straight Flush ˻
	for(Level = 9; Level >= 0; Level --){
		for(i = 0; i < 7; i ++){
			if(pCard[i].GetNumber() == Level){ // 9
				for(j = 1; j < 5; j ++){ // J(10) Q(11) K(12) A(0)
					ExpectedCard = (pCard[i].GetNumber() + j) % 13;
					for(k = 0; k < 7; k ++){
						if(pCard[k].GetNumber() == ExpectedCard && 
							pCard[i].GetShape() == pCard[k].GetShape())
							break;
					}
					if(k == 7)
						break;
				}
				if(j == 5){
					if(Level == 9){
						*pPokerBook = PB_RoyalStraightFlush;
						*pLevel = pCard[i].GetShape();
					}else{
						*pPokerBook = PB_StraightFlush;
						*pLevel = Level;
					}
					return;
				}
			}
		}
	}
	// Royal Straight ˻
	for(i = 0; i < 7; i ++){
		if(pCard[i].GetNumber() == 9){ // 9
			for(j = 1; j < 5; j ++){ // J(10) Q(11) K(12) A(0)
				ExpectedCard = (pCard[i].GetNumber() + j) % 13;
				for(k = 0; k < 7; k ++){
					if(pCard[k].GetNumber() == ExpectedCard)
						break;
				}
				if(k == 7)
					break;
			}
			if(j == 5){
				*pPokerBook = PB_RoyalStraight;
				*pLevel = pCard[i].GetShape();
				return;
			}
		}
	}

	// FourCard
	for(i = 0; i < 7; i ++){
		ExpectedCard = pCard[i].GetNumber();
		if(GetSameNumberCardCount(pCard, ExpectedCard) == 4){
			*pPokerBook = PB_FourCard;
			*pLevel = pCard[i].GetShape();
			return;
		}
	}

	// PB_FullHouse,  ī尡   ; Ѵ.
	int ThreeCardNo;
	int Level2;

	for(Level = 0; Level < 13; Level ++){
		for(i = 0; i < 7; i ++){
			if(CardNums[Level] != pCard[i].GetNumber())
				continue;

			ExpectedCard = CardNums[Level];
			if(GetSameNumberCardCount(pCard, ExpectedCard) == 3){
				//  ī 
				ThreeCardNo = ExpectedCard;
				//  ˻
				for(Level2 = 0; Level2 < 13; Level2 ++){
					if(ThreeCardNo == CardNums[Level2])
						continue;
					ExpectedCard = CardNums[Level2];
					if(GetSameNumberCardCount(pCard, ExpectedCard) == 2){
						// 
						*pPokerBook = PB_FullHouse;
						*pLevel = (20 - Level) * 4 + pCard[i].GetShape();
						return;
					}
				}
			}
		}
	}

	// Flush
	for(Level = 3; Level >= 0; Level --){
		if(GetSameShapeCardCount(pCard, Level) == 5){
			*pPokerBook = PB_Flush;
			*pLevel = Level;
		}
	}

	// Straight
	for(Level = 9; Level >= 0; Level --){
		for(i = 0; i < 7; i ++){
			if(pCard[i].GetNumber() == Level){ // 9
				for(j = 1; j < 5; j ++){ // J(10) Q(11) K(12) A(0)
					ExpectedCard = (pCard[i].GetNumber() + j) % 13;
					for(k = 0; k < 7; k ++){
						if(pCard[k].GetNumber() == ExpectedCard)
							break;
					}
					if(k == 7)
						break;
				}
				if(j == 5){
					*pPokerBook = PB_Straight;
					*pLevel = Level;
					return;
				}
			}
		}
	}

	// Three Card

	for(Level = 0; Level < 13; Level ++){
		for(i = 0; i < 7; i ++){
			if(CardNums[Level] != pCard[i].GetNumber())
				continue;

			ExpectedCard = CardNums[Level];
			if(GetSameNumberCardCount(pCard, ExpectedCard) == 3){
				//  ī 
				*pPokerBook = PB_ThreeCard;
				*pLevel = (20 - Level) * 4 + pCard[i].GetShape();
				return;
			}
		}
	}

	// Two Pair
	for(Level = 0; Level < 13; Level ++){
		for(i = 0; i < 7; i ++){
			if(CardNums[Level] != pCard[i].GetNumber())
				continue;

			ExpectedCard = CardNums[Level];
			if(GetSameNumberCardCount(pCard, ExpectedCard) == 2){
				//  ˻
				for(Level2 = 0; Level2 < 13; Level2 ++){
					if(ExpectedCard == CardNums[Level2])
						continue;
					if(GetSameNumberCardCount(pCard, CardNums[Level2]) == 2){
						// 
						*pPokerBook = PB_TwoPair;
						*pLevel = (20 - Level) * 4 + pCard[i].GetShape();
						return;
					}
				}
			}
		}
	}

	int Shape;
	// One Pair
	for(Level = 0; Level < 13; Level ++){
		if(GetSameNumberCardCount(pCard, CardNums[Level], &Shape) == 2){
			*pPokerBook = PB_OnePair;
			*pLevel = (20 - Level) * 4 + Shape;
			return;
		}
	}

	*pPokerBook = PB_NoPair;
	for(Level = 0; Level < 13; Level ++){
		if(GetSameNumberCardCount(pCard, CardNums[Level], &Shape) == 1){
			*pPokerBook = PB_NoPair;
			*pLevel = (20 - Level) * 4 + Shape;
			return;
		}
	}

}

int GetCardsScore1(cCard *pCard){
	// ̵ A  .
	int NoScoreTbl[13] = {
		13, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12
	};

	return NoScoreTbl[pCard[0].GetNumber()] * 10 + pCard[0].GetShape();
}

int GetCardsScore2(cCard *pCard){
	int CardNums[13] = { 0, 12, 11, 10, 9, 8, 7, 6, 5, 4, 3, 2, 1 };
	int Level;
	int Shape;
	// ̵ A   
	for(Level = 0; Level < 13; Level ++){
		if(GetSameNumberCardCount(pCard, CardNums[Level], &Shape) == 2){
			return (20 - Level) * 4 + Shape + 100;
		}
	}
	for(Level = 0; Level < 13; Level ++){
		if(GetSameNumberCardCount(pCard, CardNums[Level], &Shape) == 1){
			return (20 - Level) * 4 + Shape;
		}
	}

//	_ASSERT(FALSE);
	return 0;

}

int GetCardsScore3(cCard *pCard){
	int CardNums[13] = { 0, 12, 11, 10, 9, 8, 7, 6, 5, 4, 3, 2, 1 };
	int Level;
	int Shape;
	int i;
	// ̵ A ī尡  


	for(Level = 0; Level < 13; Level ++){
		for(i = 0; i < 7; i ++){
			if(CardNums[Level] != pCard[i].GetNumber())
				continue;

			if(GetSameNumberCardCount(pCard, CardNums[Level]) == 3){
				//  ī 
				return (20 - Level) * 4 + pCard[i].GetShape() + 200;
			}
		}
	}

	for(Level = 0; Level < 13; Level ++){
		if(GetSameNumberCardCount(pCard, CardNums[Level], &Shape) == 2){
			return (20 - Level) * 4 + Shape + 100;
		}
	}
	for(Level = 0; Level < 13; Level ++){
		if(GetSameNumberCardCount(pCard, CardNums[Level], &Shape) == 1){
			return (20 - Level) * 4 + Shape;
		}
	}

//	_ASSERT(FALSE);
	return 0;
}


int GetCardsScore4(cCard *pCard){
	int CardNums[13] = { 0, 12, 11, 10, 9, 8, 7, 6, 5, 4, 3, 2, 1 };
	int Level, Level2;
	int Shape;
	int i;

	// A ī尡  

	// FourCard
	if(GetSameNumberCardCount(pCard, pCard[0].GetNumber()) == 4){
		return (20 - CardNums[pCard[0].GetNumber()]) * 4 + 400;
	}
	

	for(Level = 0; Level < 13; Level ++){
		for(i = 0; i < 7; i ++){
			if(CardNums[Level] != pCard[i].GetNumber())
				continue;

			if(GetSameNumberCardCount(pCard, CardNums[Level]) == 3){
				//  ī 
				return (20 - Level) * 4 + pCard[i].GetShape() + 300;
			}
		}
	}


	// Two Pair
	for(Level = 0; Level < 13; Level ++){
		for(i = 0; i < 7; i ++){
			if(CardNums[Level] != pCard[i].GetNumber())
				continue;

			if(GetSameNumberCardCount(pCard, CardNums[Level]) == 2){
				//  ˻
				for(Level2 = 0; Level2 < 13; Level2 ++){
					if(CardNums[Level] == CardNums[Level2])
						continue;
					if(GetSameNumberCardCount(pCard, CardNums[Level2]) == 2){
						// 						
						return (20 - Level) * 4 + pCard[i].GetShape() + 200;
						
					}
				}
			}
		}
	}

	for(Level = 0; Level < 13; Level ++){
		if(GetSameNumberCardCount(pCard, CardNums[Level], &Shape) == 2){
			return (20 - Level) * 4 + Shape + 100;
		}
	}

	

	for(Level = 0; Level < 13; Level ++){
		if(GetSameNumberCardCount(pCard, CardNums[Level], &Shape) == 1){
			return (20 - Level) * 4 + Shape;
		}
	}


	return 0;
}


