// ROGSevenPokerRoomView.cpp : implementation file
//

#include "StdAfx.h"
#include "ROGSevenPokerRoomView.h"
#include "ROGSevenPokerRoomProtocol.h"
#include "cDisplay.h"
#include "cRPC.h"
#include "ROGClientMainWnd.h"
#include "ROGClient.h"
#include "ROGLobbyProtocol.h"
#include "resource.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CROGSevenPokerRoomView * g_pRoomWnd;

//ġ 
const int PLAYER_STARTX		= 8;     
const int PLAYER_STARTY		= 74;    
 
const int CARD_STARTX		= 8;     
const int CARD_STARTY		= 77;    



const int MESSAGE_STARTX = 4;
const int MESSAGE_STARTY = 300;


//ġ
const int PLAYER_INFOX		= 160;
const int PLAYER_INFOY      = 2;

const int CARD_WIDTH		= 32;  
const int CARD_HEIGHT		= 40;

const int CARD_VISIBLE_WIDTH = 16;

const int PLAYER_HEIGHT		= 56;

const int FONT_HEIGHT	=	16;

const int RESULTY		= -6;


#define MAX_GAME_PLAYER_COUNT 4


BEGIN_MESSAGE_MAP(CROGSevenPokerRoomView, CWnd)
	//{{AFX_MSG_MAP(CROGSevenPokerRoomView)
	ON_MESSAGE(ROGCM_RPCCall, OnRPCCall)
	ON_WM_LBUTTONUP()
	ON_WM_LBUTTONDOWN()
	ON_WM_DESTROY()
	ON_WM_KILLFOCUS()
	ON_WM_KEYDOWN()
	ON_WM_MOUSEMOVE()
	ON_WM_SETFOCUS()
	ON_WM_CREATE()
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()





CWnd *ROGCreateChildView(int ChildID){
	return new CROGSevenPokerRoomView;
}
 
void ROGDestroyChildView(int ChildID, CWnd *pWnd){
	delete pWnd;
}



///////////////////////////////////////////////////////
CROGSevenPokerRoomView::CROGSevenPokerRoomView(){
	g_pRoomWnd = this;
	m_nMyBetChip = 0;
	
	 m_nSecond = 20;
	m_dwBetTime = 0;
	m_dwPrevBetTime = 0;
	
}

CROGSevenPokerRoomView::~CROGSevenPokerRoomView()
{

}




void CROGSevenPokerRoomView::RenderGame(){
	TCHAR szYouLost[10] = _T("YOU LOST"); 
	TCHAR szYouWin[10] = _T("YOU WIN"); 
	int AddPosY[7] = {
		2, 2, -3, -3, -3, -3, 0
	};
	int PosY[4] = { 
		3, 0, 1, 2
	};
	int CardPosY[4];
	cSevenPokerPlayer *pPlayer;
	int			i, j;
	cCard		*pCard;
	RECT		rcCard;
	TCHAR		str[256];

	cDisplay &Display = ((CROGClientMainWnd*)GetParent())->m_Display;
	//  ׸.
	Display.GetBackPic()->Blt(0, 0, &m_BGPic);

	// ڵ ī ׸.
	if(Room.LocalPlayerSeqID >= 0){
		pPlayer = Room.GetPlayer(Room.LocalPlayerSeqID);
		for(i = 0; i < 4; i++){
			CardPosY[i] = PosY[(i + (4 - pPlayer->GetLocationSeqID())) % 4];
		}
	}

	for(i = 0; i < MAX_GAME_PLAYER_COUNT; i ++){
		pPlayer = Room.GetPlayer(i);
		char LocationID = pPlayer->GetLocationSeqID();

		if(pPlayer->IsPlayerPlaying()){
			// ڰ  ִ 7 ī ׷.
			for(j = 0; j < 7; j ++){
				// ī  .
				pCard = pPlayer->GetCard(j);

				if(!pCard->Visible || pCard->cID < 0)
					continue; 

				if(pCard->cID == 52){ // Hidden Card
					SetRect(&rcCard, 0, 0, CARD_WIDTH, CARD_HEIGHT);
					Display.GetBackPic()->Blt(
						CARD_STARTX + CARD_VISIBLE_WIDTH * j + 4,
						CARD_STARTY  + PLAYER_HEIGHT * CardPosY[LocationID] + 4 + AddPosY[j],
						&m_HiddenCardPic, &rcCard);
				}else if(pCard->cID >= 0 && pCard->cID < 52){
					rcCard.left		= CARD_WIDTH * pCard->GetNumber();
					rcCard.top		= CARD_HEIGHT * pCard->GetShape();
					rcCard.right	= rcCard.left + CARD_WIDTH;
					rcCard.bottom	= rcCard.top + CARD_HEIGHT;

					Display.GetBackPic()->Blt(
						CARD_STARTX + CARD_VISIBLE_WIDTH * j + 4,
						CARD_STARTY + PLAYER_HEIGHT * CardPosY[LocationID] + 4 + AddPosY[j],
						&m_CardPic, &rcCard);
				}
			}
			
			//   ڸ ϴ ǥ(Spot light) ׸.
			if(i == Room.nCurPlayerID){
				if(i ==Room.LocalPlayerSeqID)
					Display.GetBackPic()->Blt(PLAYER_STARTX,
					PLAYER_STARTY + PLAYER_HEIGHT * CardPosY[LocationID],
					&m_SpotLight1Pic, m_SpotLight1Pic.GetRect(), RGB(255, 0, 255));
				else
					Display.GetBackPic()->Blt(PLAYER_STARTX,
					PLAYER_STARTY + PLAYER_HEIGHT * CardPosY[LocationID],
					&m_SpotLight2Pic, m_SpotLight2Pic.GetRect(), RGB(255, 0, 255));

			}
		}

		if(!pPlayer->IsEmpty()){
			// ڵ   Ѵ.
			wsprintf(str, _T("%4dĨ"), pPlayer->nChip);
			Display.GetBackPic()->BltText(str, CARD_STARTX + PLAYER_INFOX,  PLAYER_STARTY + PLAYER_INFOY + PLAYER_HEIGHT * CardPosY[LocationID], 0, RGB(255, 255, 255));
			wsprintf(str, _T("%4s"), pPlayer->strName);
			Display.GetBackPic()->BltText(str, CARD_STARTX + PLAYER_INFOX, PLAYER_STARTY + PLAYER_INFOY + PLAYER_HEIGHT * CardPosY[LocationID] + FONT_HEIGHT, 0, RGB(255, 255, 255));


			int PokerBook;

			PokerBook = pPlayer->PokerBook;

			const static TCHAR *PokerBookStrings[] = {
				_T("One Pair"),
				_T("Two Pair"),
				_T(" Tripple"),
				_T("Straight"),
				_T("   Flush"),
				_T("   House"),
				_T("FourCard"),
				_T("Royal St"),
				_T("St Flush"),
				_T("Royal SF")
			};

			if((int)PokerBook > (int)PB_NoPair){
				Display.GetBackPic()->BltText(PokerBookStrings[(int)PokerBook - 1], 
					CARD_STARTX + PLAYER_INFOX, PLAYER_STARTY + PLAYER_INFOY + PLAYER_HEIGHT * CardPosY[LocationID] + FONT_HEIGHT * 2, 0, RGB(255, 255, 255));
			}
			else{
				lstrcpy(str, _T(""));

				switch(pPlayer->PrevBetType){
				case EBT_Bet:
					lstrcpy(str, _T("  Bet"));
					break;
				case EBT_Call:
					lstrcpy(str, _T(" Call"));
					break;
				case EBT_Check:
					lstrcpy(str, _T("Check"));
					break;
				case EBT_Die:
					lstrcpy(str, _T("  Die"));
					break;
				case EBT_Good:
					lstrcpy(str, _T(" Good"));
					break;
				case EBT_Prepare:
					break;
				default:
					ASSERT(0);
					break;
				}

				if(lstrlen(str))
					Display.GetBackPic()->BltText(str, CARD_STARTX + PLAYER_INFOX, PLAYER_STARTY + PLAYER_INFOY + PLAYER_HEIGHT * CardPosY[LocationID] + FONT_HEIGHT * 2, 0, RGB(255, 255, 255));
			}
		}
		//Die Ʈ ޽ 
		if(pPlayer->PrevBetType == EBT_Die){
			Display.GetBackPic()->BltText(_T("DIE"), PLAYER_STARTX, PLAYER_STARTY + PLAYER_HEIGHT * CardPosY[LocationID] + RESULTY, 0, RGB(255, 0, 255));
		}
		
		//winner Ʈ ޽ 
		else if(Room.nWinnerID >= 0 && i == Room.nWinnerID){
			Display.GetBackPic()->BltText(_T("WINNER"),	PLAYER_STARTX, PLAYER_STARTY + PLAYER_HEIGHT * CardPosY[LocationID] + RESULTY, 0, RGB(255, 0, 255));
		}
	}

	//   ׷.
	// ư  ׷.
	for(i = 0; i < BTN_Count; i ++){
		if(m_GameButtons[i].Visible){
			RECT rcBtn;

			rcBtn = m_GameButtons[i].rcPic;
			rcBtn.left += m_GameButtons[i].State * m_GameButtons[i].rcPic.right;
			rcBtn.right += m_GameButtons[i].State * m_GameButtons[i].rcPic.right;
			Display.GetBackPic()->Blt(m_GameButtons[i].rcBtn.left,
				m_GameButtons[i].rcBtn.top,
				&m_ButtonsPic, &rcBtn);
		}
	}

	// ǵ ׸.
	wsprintf(str, _T(" %d"), Room.nBetChip);
	Display.GetBackPic()->BltText(str, 8, 4, 0, RGB(255, 255, 255));

	wsprintf(str, _T(" %d"), Room.nRaiseChip);
	Display.GetBackPic()->BltText(str, 8, 4 + 14, 0, RGB(255, 255, 255));

	wsprintf(str, _T(" %d"), m_nMyBetChip);
	Display.GetBackPic()->BltText(str, 8, 4 + 14 + 14, 0, RGB(255, 255, 255));

	//    ڿ Ѵ.
	if(Room.LocalPlayerState == LPS_Wait){
		lstrcpy(strMessage, strSevenPokerMSG[SMSG_Play]);
	}
	
	if(Room.nCurPlayerID == Room.LocalPlayerSeqID){
		if( (m_nSecond == 20) && (m_dwBetTime == 0) ){
			m_dwPrevBetTime = GetTickCount();
		}

		m_dwBetTime = GetTickCount();
		
		if(m_dwBetTime - m_dwPrevBetTime > 1000){
			m_dwPrevBetTime = GetTickCount();
			wsprintf(strMessage, _T("ýð %d %s"), m_nSecond, strSevenPokerMSG[SMSG_SecWait]);
			m_nSecond--;
			
		}

		if(m_nSecond < 0){
			cRPCPacket Packet;
			//20ʰ   1 ϴ° Ѵ.
			Packet.SetHeader(RPCO_Owner, ROGSSM_Bet);
			int nTmp = 1;
			ROGSSM_Bet_Stub(Packet, nTmp);
			GetRPC()->SendPacket(&Packet);

			m_nSecond = 20;
			m_dwBetTime = 0;

			lstrcpy(strMessage, strSevenPokerMSG[SMSG_BetSecEnd]);
		}
	}
	if(lstrlen(strMessage)){
		Display.GetBackPic()->BltText(strMessage, MESSAGE_STARTX, MESSAGE_STARTY, 0, RGB(255, 255, 255), RGB(0, 0, 0));
	}
}

cRPC *CROGSevenPokerRoomView::GetRPC(){
	return &((CROGClientMainWnd *)GetParent())->m_RPC;
}












void CROGSevenPokerRoomView::EnableBtn(eButtonIDs ID){
	m_GameButtons[ID].State = 0;

	m_GameButtons[ID].Visible = true;

	if(ID == BTN_Call){
		m_GameButtons[BTN_Good].Visible = false;
	}else if(ID == BTN_Good){
		m_GameButtons[BTN_Call].Visible = false;
	}
}

void CROGSevenPokerRoomView::DisableAllBtns(){
	int i;

	for(i = 0; i < BTN_Count; i ++){
		m_GameButtons[i].State = 2;
		m_GameButtons[i].Visible = true;
	}
}



void CROGSevenPokerRoomView::ChangeState(){
	
	GetParent()->PostMessage(ROGCM_ChangeChild, ROGCCVC_Lobby, 0);

}



LRESULT CROGSevenPokerRoomView::OnRPCCall(WPARAM wParam, LPARAM lParam)
{
	cRPCPacket *pPacket;
	pPacket = (cRPCPacket *)lParam;

	return Room.OnServerMessage(wParam, pPacket);

}


void CROGSevenPokerRoomView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	char i, j;

	POINT ptMouse;

	ptMouse.x = point.x;
	ptMouse.y = point.y;

	for(i = 0; i < BTN_Count; i ++){
		
		if(m_GameButtons[i].Visible && m_GameButtons[i].State != 2){
			if(PtInRect(&m_GameButtons[i].rcBtn, ptMouse)){
//				m_GameButtons[i].State = 1;
				switch(i){

				case BTN_Call: // Call
					{
						cRPCPacket Packet;
						Packet.SetHeader(RPCO_Owner, ROGSSM_Call);
						GetRPC()->SendPacket(&Packet);

					}
					break;
				case BTN_Check: // Check
					{
						cRPCPacket Packet;
						Packet.SetHeader(RPCO_Owner, ROGSSM_Check);
						GetRPC()->SendPacket(&Packet);
						
					}
					break;

				case BTN_Die: // die
					{
						cRPCPacket Packet;
						Packet.SetHeader(RPCO_Owner, ROGSSM_Die);
						GetRPC()->SendPacket(&Packet);
						
					}
					break;

				case BTN_BetDBL: // double bet
					{
						cRPCPacket Packet;
						Packet.SetHeader(RPCO_Owner, ROGSSM_BetDBL);
						GetRPC()->SendPacket(&Packet);

					//	m_nMyBetChip = Room.nRaiseChip;
					}
					break;



				case BTN_BetHalf: // half bet
					{
						cRPCPacket Packet;
						Packet.SetHeader(RPCO_Owner, ROGSSM_BetHalf);
						GetRPC()->SendPacket(&Packet);

					//	m_nMyBetChip = (Room.nBetChip + 1) / 2;
						
					}
					break;

				case BTN_Exit: // exit
					{
						cRPCPacket Packet;
						//Packet.SetHeader(RRPCO_Owner, ROGSSM_LeaveStoodRoom);
						//GetRPC()->SendPacket(&Packet);
						GetRPC()->SendSimplePacket(RPCO_System, ROGLSM_SetLobbyMode);
						
						ChangeState();

					}
					break;

				case BTN_0: // 0
						m_nMyBetChip = 0;
						m_GameButtons[i].State = 0;
					break;

				case BTN_1:
						m_nMyBetChip += 1;
						m_GameButtons[i].State = 0;
					break;

				case BTN_5: // 5
						m_nMyBetChip += 5;
						m_GameButtons[i].State = 0;
					break;

				case BTN_10:
						m_nMyBetChip += 10;
						m_GameButtons[i].State = 0;
					break;

			
				case BTN_Bet: // Bet
					{
						cRPCPacket Packet;
						
						if(m_nMyBetChip == 0)
							Packet.SetHeader(RPCO_Owner, ROGSSM_Call);
						else{
							Packet.SetHeader(RPCO_Owner, ROGSSM_Bet);
							ROGSSM_Bet_Stub(Packet, m_nMyBetChip);

						}

						GetRPC()->SendPacket(&Packet);

						m_nMyBetChip = 0;

					}
					break;


				}	

				if(i <= BTN_Bet){
					for(j = 0; j <= BTN_Bet; j ++){
						m_GameButtons[j].State = 2;
					}

					m_nSecond = 20;
					m_dwBetTime = 0;
				}

				InvalidateRect(0, FALSE);
				break;
			}
		}
	}

	// ī  ư
	if(Room.GetGameState() == GS_FlipOneCard){
		// ī    ֵ Ѵ.
		RECT CardFlipRects[3] = {
			{
				0, 
				0, 
				CARD_VISIBLE_WIDTH,
				CARD_HEIGHT
			}, {
				CARD_VISIBLE_WIDTH,
				0,
				CARD_VISIBLE_WIDTH * 2,
				CARD_HEIGHT
			}, {
				CARD_VISIBLE_WIDTH * 2, 
				0,
				CARD_VISIBLE_WIDTH * 2 + CARD_WIDTH,
				CARD_HEIGHT
			}
		};
		
	

		CRect rc;
		

		for(i = 0; i < 3; i ++){
			rc = CardFlipRects[i];

			rc.left += PLAYER_STARTX;
			rc.top += PLAYER_STARTY + PLAYER_HEIGHT * 3;
			rc.right += PLAYER_STARTX;
			rc.bottom += PLAYER_STARTY + PLAYER_HEIGHT * 3;

			
			if(PtInRect(&rc, ptMouse)){
				// ϴ  ī带  ڷ ű.
				int CardID;

				CardID = Room.Players[Room.LocalPlayerSeqID].Cards[i].cID;
				if(i < 2){
					Room.Players[Room.LocalPlayerSeqID].Cards[i].cID = Room.Players[Room.LocalPlayerSeqID].Cards[2].cID;
					Room.Players[Room.LocalPlayerSeqID].Cards[2].cID = CardID;
				}

				//  ī  ڴٰ ˸
				cRPCPacket Packet;
				Packet.SetHeader(RPCO_Owner, ROGSSM_FlipOneCard);
				ROGSSM_FlipOneCard_Stub(Packet, i);
				GetRPC()->SendPacket(&Packet);

								
				Room.SetGameState(GS_Wait);
				g_pRoomWnd->strMessage[0] = 0;
				InvalidateRect(0, FALSE);
				break;
			}

		}
	}
	
	CWnd::OnLButtonUp(nFlags, point);
}

void CROGSevenPokerRoomView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default


	int i;

	POINT ptMouse;

	ptMouse.x = point.x;
	ptMouse.y = point.y;

	for(i = 0; i < BTN_Count; i ++){
		
		if(m_GameButtons[i].Visible && m_GameButtons[i].State != 2){
			if(PtInRect(&m_GameButtons[i].rcBtn, ptMouse)){
				m_GameButtons[i].State = 1;
				
////				DialogWnd.Create(_T("DialogWnd"), WS_CHILD | WS_VISIBLE, 30, 30, 140, 100, this, 0, g_pApp->m_hInstance, 0);
				
			}else{
				m_GameButtons[i].State = 0;
			}
		}
	}

	RECT rcExit = { 0, 0, 10, 10 };
	if(PtInRect(&rcExit, ptMouse)){
		PostQuitMessage(0);
	}
	InvalidateRect(0, FALSE);


}




void CROGSevenPokerRoomView::OnDestroy() 
{
	CWnd::OnDestroy();
	
	// TODO: Add your message handler code here
	m_TitlePic.Destroy();
//	m_FontPic.Destroy();
	m_BGPic.Destroy();
	m_SpotLight1Pic.Destroy();
	m_SpotLight2Pic.Destroy();
	m_CardPic.Destroy();
	m_ButtonsPic.Destroy();


//	cROGDisplay &Display = ((CROGClientMainWnd*)GetParent())->m_Display;
//	Display.Destroy();

//	Display.GetBackPic()->Destroy();
	
}

void CROGSevenPokerRoomView::OnKillFocus(CWnd* pNewWnd) 
{
	CWnd::OnKillFocus(pNewWnd);
	
	// TODO: Add your message handler code here
	
}



void CROGSevenPokerRoomView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: Add your message handler code here and/or call default
	
	CWnd::OnKeyDown(nChar, nRepCnt, nFlags);
}




void CROGSevenPokerRoomView::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	int i;

	POINT ptMouse;

	ptMouse.x = point.x;
	ptMouse.y = point.y;

	for(i = 0; i < BTN_Count; i ++){
		
		if(m_GameButtons[i].Visible && m_GameButtons[i].State != 2){
			if(PtInRect(&m_GameButtons[i].rcBtn, ptMouse)){
	//			m_GameButtons[i].State = 1;
			}else{
				m_GameButtons[i].State = 0;
			}
		}
	}

	InvalidateRect(0, FALSE);
	
	CWnd::OnMouseMove(nFlags, point);
}

void CROGSevenPokerRoomView::OnSetFocus(CWnd* pOldWnd) 
{
	CWnd::OnSetFocus(pOldWnd);
	
	// TODO: Add your message handler code here
	
}

int CROGSevenPokerRoomView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
		// ÷ ʱȭ
	cDisplay &Display = ((CROGClientMainWnd*)GetParent())->m_Display;
	
//	Display.Create(m_hWnd); 
	
	
	if(!Display.GetBackPic()->Create(&Display, 240, 320)){
//		Display.Destroy();
		MessageBox(_T("Display.GetBackPic()->Create Fail"), _T("RenoPokerClient"), MB_OK);
		return -1;
	}

// 	Display.SetBackPic(&m_BackBuff);

	bool bSuccess = false;

	CROGClientMainWnd *pMainWnd = ((CROGClientMainWnd*)GetParent());
	
	for(;;){
//		if(!m_FontPic.Create(&Display, pMainWnd->GetResourcePath( _T("Font0.bmp"))))
//			break;
		if(!m_BGPic.Create(&Display, AfxGetApp()->m_hInstance, IDB_BG))
			break;
		if(!m_SpotLight1Pic.Create(&Display, AfxGetApp()->m_hInstance, IDB_SPOTLIGHT01))
			break;
		if(!m_SpotLight2Pic.Create(&Display, AfxGetApp()->m_hInstance, IDB_SPOTLIGHT02))
			break;
		if(!m_CardPic.Create(&Display, AfxGetApp()->m_hInstance, IDB_CARDS))
			break;
		if(!m_HiddenCardPic.Create(&Display, AfxGetApp()->m_hInstance, IDB_HIDDEN))
			break;
		if(!m_ButtonsPic.Create(&Display, AfxGetApp()->m_hInstance, IDB_BUTTONS))
			break;

		bSuccess = true;
		break;
	}


	if(!bSuccess){
		m_TitlePic.Destroy();
//		m_FontPic.Destroy();
		m_BGPic.Destroy();
		m_SpotLight1Pic.Destroy();
		m_SpotLight2Pic.Destroy();
		m_ButtonsPic.Destroy();

//		Display.Destroy();
		return -1;
	}

	// Network initialize

	if(SetTimer(1, 50, 0) == 0){
		ASSERT(0);
	}

	const RECT rcBtn[BTN_Count] = {
		{ 96,   6,  96 + 34,  6 + 18 },//check
		{ 201,  6, 200 + 34,  6 + 18 },//die
		{ 131,  6, 130 + 34,  6 + 18 },//good
		{ 166,  6, 165 + 34,  6 + 18 },//call
		{ 206, 28, 205 + 28, 28 + 18 },//DBL
		{ 176, 28, 175 + 28, 28 + 18 },//Half
		{ 61,   6,  60 + 34,  6 + 18 },//exit
		{ 60,  28,  60 + 34, 28 + 18 },//bet

		{ 96, 28, 95 + 18, 28 + 18 },//0 
		{ 115, 28, 115 + 18, 28 + 18 },//1
		{ 135,  28, 135 + 18, 28 + 18 },//5
		{ 155, 28, 155 + 18, 28 + 18 },//10
	
	};

	const RECT rcBtnPic[BTN_Count] = {
		{  0,   0, 32,  18 }, //check
		{  0,  18, 32,  36 }, //die 
		{  0,  36, 32,  54 }, //good
		{  0,  54, 32,  72 }, //call
		{  0, 198, 26, 216 }, //DBL
		{  0, 180, 26, 198 }, //half

		{  0,  72, 32,  90 },  //exit
		{  0,  90, 32,  108 },  //bet
		{  0, 108, 16, 126 },   //0
		{  0, 126, 16, 144 },   //1
		{  0, 144, 16, 162 },   //5
		{  0, 162, 16, 180 },   //10 


	};

	int i;

	for(i = 0; i < BTN_Count; i ++){
		m_GameButtons[i].rcBtn = rcBtn[i];
		m_GameButtons[i].rcPic = rcBtnPic[i];
		m_GameButtons[i].State = 0;
		m_GameButtons[i].Visible = false;
	}
		
	// Game Initialize
	m_nGameMode = GM_Play;

	Room.Init();

	//   ˸
	cRPCPacket Packet;

	strMessage[0] = 0;
	
	return 0;
}



void CROGSevenPokerRoomView::OnPaint(){
	CPaintDC dc(this);
	
	//   Ѵ.
	RenderGame();

	cDisplay &Display = ((CROGClientMainWnd*)GetParent())->m_Display;

	Display.Flip(dc);

}
