#ifndef cSevenPokerPlayer_H
#define cSevenPokerPlayer_H

#include "cCard.h"

enum EPokerLevel{
	PL_ONEPAIR = 1,  
	PL_TWOPAIR,
	PL_TRIPPLE,
	PL_STRAIGHT,
	PL_FLUSH,	
	PL_FULLHOUSE,
	PL_POKER,	
	PL_NSF,	
	PL_OSF,	
	PL_RSF,	
};

enum eBetType{
	EBT_Prepare,
	EBT_Bet,
	EBT_Check,
	EBT_Call,
	EBT_Die,
	EBT_Good,

};

class cSevenPokerPlayer{ 
private:
	enum EPlayerState{ 
		EPS_Empty,
		EPS_Prepare, 
		EPS_GamePlay,
		
	};

	EPlayerState nPlayerState;

	bool bDieFlag;
	bool bCallFlag;

	int nCurCardNum;

public:
	ePokerBook PokerBook;
	int PokerBookLevel;
	TCHAR strName[20];

	eBetType PrevBetType;

	char cLocationSeqID;
	int nChip;
	int nOrder;

	cCard Cards[7];
	int CardStackPos;

	int nGrade;

	cSevenPokerPlayer();
	virtual void Destroy();

	void Init();
	void ResetCards();

	void StartPoker();
	void LeavePokerRoom();
	void OpenOneCard(int CardNumber);

	
	void SendACKBet(int _cBetType, int _nRaiseMoney);

	void SetOrder(int Order){ nOrder = Order;}

	void SetCallFlag(){ bCallFlag = true;} 
	void SetDieFlag(){ bDieFlag = true;}

	void SetPrevBetType(eBetType _BetType){ PrevBetType = _BetType;} 
	
	eBetType GetPrevBetType(){ return PrevBetType;} 
	

	bool IsEmpty(){ return nPlayerState == EPS_Empty; }
	bool IsPlayerPlaying(){ return nPlayerState == EPS_GamePlay; }
	void SetPrepareState(){ nPlayerState = EPS_Prepare; }
	void SetEmptyState(){ nPlayerState = EPS_Empty; }
	void SetPlaying(){ nPlayerState = EPS_GamePlay;}

	cCard *GetCard(int idx){ return Cards + idx ; }

	char GetLocationSeqID(){ return cLocationSeqID; }


};


#endif