#include "StdAfx.h"
#include "cSevenPokerRoom.h"
#include "ROGSevenPokerRoomView.h"
#include "ROGSevenPokerRoomProtocol.h"

// cSevenPokerRoom /////////////////////////////////////////////////////////////////////////////////////////////
cSevenPokerRoom::cSevenPokerRoom(){
	Init();

	LocalPlayerSeqID = -1;
	LocalLocationSeqID = -1;
	LocalPlayerState = LPS_Wait;
}

cSevenPokerRoom::~cSevenPokerRoom()
{

}

void cSevenPokerRoom::Init(){
	InitGamePlayerList();

	nBetChip = 0;
	nRaiseChip = 0;
	nPrevRaiseChip = 0;
	nWinnerID = -1;//playerID 0 ϹǷ ʱȭ -1 Ѵ.

	nGameState = GS_Wait;

}

void cSevenPokerRoom::InitGamePlayerList(){
	for(int i = 0; i < MAX_ROOM_PLAYER_COUNT; i ++){
		Players[i].ResetCards();
		Players[i].PrevBetType = EBT_Prepare;
	}
}

bool cSevenPokerRoom::OnServerMessage(WPARAM wParam, cRPCPacket *pPacket){
	switch(wParam){
	
	case ROGSCM_WaiterInfo			: OnROGSCMWaiterInfo(wParam, pPacket); break;
	case ROGSCM_PlayerInfo			: OnROGSCMPlayerInfo(wParam, pPacket); break;
	case ROGSCM_RemovePlayer		: OnROGSCMRemovePlayer(wParam, pPacket); break;

	case ROGSCM_StartPoker			: OnROGSCMStartPoker(wParam, pPacket); break;
	case ROGSCM_SetCard				: OnROGSCMSetCard(wParam, pPacket); break;	
	case ROGSCM_ChooseFlipCard		: OnROGSCMChooseFlipCard(wParam, pPacket); break;	
	case ROGSCM_SetChip				: OnROGSCMSetChip(wParam, pPacket); break;
	case ROGSCM_SetBetChip			: OnROGSCMSetBetChip(wParam, pPacket); break;
	case ROGSCM_SetRaiseChip		: OnROGSCMSetRaiseChip(wParam, pPacket); break;
	case ROGSCM_SetWinner			: OnROGSCMSetWinner(wParam, pPacket); break;
	case ROGSCM_SetPokerBook		: OnROGSCMSetPokerBook(wParam, pPacket); break;

	case ROGSCM_SetBossRole			: OnROGSCMSetBossRole(wParam, pPacket); break;
	case ROGSCM_SetAfterCheckRole	: OnROGSCMSetAfterCheckRole(wParam, pPacket); break;
	case ROGSCM_SetAfterBetRole		: OnROGSCMSetAfterBetRole(wParam, pPacket); break;
	case ROGSCM_SetAfterCallRole	: OnROGSCMSetAfterCallRole(wParam, pPacket); break;
	case ROGSCM_SetOrder			: OnROGSCMSetOrder(wParam, pPacket); break;

	case ROGSCM_CardIDInfo			: OnROGSCMCardIDInfo(wParam, pPacket); break;


	case ROGSCM_SayCheck			: OnROGSCMSayCheck(wParam, pPacket); break;
	case ROGSCM_SayCall				: OnROGSCMSayCall(wParam, pPacket); break;
	case ROGSCM_SayGood				: OnROGSCMSayGood(wParam, pPacket); break;
	case ROGSCM_SayDie				: OnROGSCMSayDie(wParam, pPacket); break;
	case ROGSCM_SayBet				: OnROGSCMSayBet(wParam, pPacket); break;

	case ROGSCM_LeaveSevenPokerRoom	: OnROGSCMLeaveSevenPokerRoom(wParam, pPacket); break;
	}
	return true;
}

void cSevenPokerRoom::OnROGSCMSetAfterCallRole(WPARAM wParam, cRPCPacket *pPacket){
	g_pRoomWnd->DisableAllBtns();
	g_pRoomWnd->EnableBtn(BTN_Call);
	g_pRoomWnd->EnableBtn(BTN_Die);

	InvalidateRect(g_pRoomWnd->m_hWnd, 0, FALSE);
}

void cSevenPokerRoom::OnROGSCMSetBossRole(WPARAM wParam, cRPCPacket *pPacket){
	g_pRoomWnd->DisableAllBtns();
	g_pRoomWnd->EnableBtn(BTN_Check);
	g_pRoomWnd->EnableBtn(BTN_Die);
	g_pRoomWnd->EnableBtn(BTN_BetDBL);
	g_pRoomWnd->EnableBtn(BTN_BetHalf);
	g_pRoomWnd->EnableBtn(BTN_Bet);
	g_pRoomWnd->EnableBtn(BTN_0);
	g_pRoomWnd->EnableBtn(BTN_1);
	g_pRoomWnd->EnableBtn(BTN_5);
	g_pRoomWnd->EnableBtn(BTN_10);

	InvalidateRect(g_pRoomWnd->m_hWnd, 0, FALSE);

}

void cSevenPokerRoom::OnROGSCMSetAfterCheckRole(WPARAM wParam, cRPCPacket *pPacket){
	g_pRoomWnd->DisableAllBtns();
	g_pRoomWnd->EnableBtn(BTN_Call);
	g_pRoomWnd->EnableBtn(BTN_Die);


	InvalidateRect(g_pRoomWnd->m_hWnd, 0, FALSE);

}

void cSevenPokerRoom::OnROGSCMSetAfterBetRole(WPARAM wParam, cRPCPacket *pPacket){
	g_pRoomWnd->DisableAllBtns();
	g_pRoomWnd->EnableBtn(BTN_Check);
	g_pRoomWnd->EnableBtn(BTN_Call);
	g_pRoomWnd->EnableBtn(BTN_Die);
	g_pRoomWnd->EnableBtn(BTN_Die);
	g_pRoomWnd->EnableBtn(BTN_BetDBL);
	g_pRoomWnd->EnableBtn(BTN_BetHalf);
	g_pRoomWnd->EnableBtn(BTN_Bet);
	g_pRoomWnd->EnableBtn(BTN_0);
	g_pRoomWnd->EnableBtn(BTN_1);
	g_pRoomWnd->EnableBtn(BTN_5);
	g_pRoomWnd->EnableBtn(BTN_10);


	InvalidateRect(g_pRoomWnd->m_hWnd, 0, FALSE);

}


void cSevenPokerRoom::OnROGSCMStartPoker(WPARAM wParam, cRPCPacket *pPacket){
	// Ŀ Ѵ.
	int i;

	Init();

	for(i = 0; i < MAX_ROOM_PLAYER_COUNT;  i++){
		Players[i].Init();
	}

	nCurPlayerID = -1;

	LocalPlayerState = LPS_Play;

	g_pRoomWnd->DisableAllBtns();

}

void cSevenPokerRoom::OnROGSCMPlayerInfo(WPARAM wParam, cRPCPacket *pPacket){
	char SeqID;
	char LocationSeqID;
	int nChip;
	char strName[20];

	ROGSCM_PlayerInfo_Stub(*pPacket, SeqID, LocationSeqID, strName, nChip); 


	
	Players[SeqID].cLocationSeqID = LocationSeqID;
	Players[SeqID].nChip = nChip;
	Players[SeqID].SetPrepareState();
		
	LocalPlayerSeqID = SeqID;
	LocalLocationSeqID = LocationSeqID;

#ifdef UNDER_CE
	mbstowcs(Players[SeqID].strName, strName, strlen(strName) + 1); //PDA
#else
	wsprintf(Players[SeqID].strName, _T("%s"), strName);			//ActiveX
#endif

	
	Players[SeqID].cLocationSeqID = LocationSeqID;
	Players[SeqID].nChip = nChip;
	Players[SeqID].SetPrepareState();


	InvalidateRect(g_pRoomWnd->m_hWnd, 0, FALSE);
	
}


void cSevenPokerRoom::OnROGSCMWaiterInfo(WPARAM wParam, cRPCPacket *pPacket){
	char SeqID;
	char LocationSeqID;
	int nChip;
	char strName[20];

	ROGSCM_WaiterInfo_Stub(*pPacket, SeqID, LocationSeqID, strName, nChip); 
	
#ifdef UNDER_CE
	mbstowcs(Players[SeqID].strName, strName, strlen(strName) + 1); //PDA
#else
	wsprintf(Players[SeqID].strName, _T("%s"), strName);			//ActiveX
#endif

	Players[SeqID].cLocationSeqID = LocationSeqID;
	Players[SeqID].nChip = nChip;
	Players[SeqID].SetPrepareState();

	InvalidateRect(g_pRoomWnd->m_hWnd, 0, FALSE);

}

void cSevenPokerRoom::OnROGSCMLeaveSevenPokerRoom(WPARAM wParam, cRPCPacket *pPacket){
	
	char cSeqID;
	
	ROGSCM_LeaveSevenPokerRoom_Stub(*pPacket, cSeqID); 
		
	Players[cSeqID].SetEmptyState(); 

	InvalidateRect(g_pRoomWnd->m_hWnd, 0, FALSE);
	
}

void cSevenPokerRoom::OnROGSCMCardIDInfo(WPARAM wParam, cRPCPacket *pPacket){
	
	int i, j;
	char cUserSeqID;
	char cCardID;

	for(i = 0; i < MAX_ROOM_PLAYER_COUNT; i ++){
		ROGSCM_CardIDInfo_Stub(*pPacket, cUserSeqID); 
	
		if(cUserSeqID >= 0){
			Players[i].SetPlaying();
			for(j = 0; j < 7; j ++){
				ROGSCM_CardIDInfo_Stub(*pPacket, cCardID); 
				Players[i].Cards[j].cID = cCardID;
				Players[i].Cards[j].Visible = true;
			}
		}
	}

	InvalidateRect(g_pRoomWnd->m_hWnd, 0, FALSE);
	
}


void cSevenPokerRoom::OnROGSCMSetOrder(WPARAM wParam, cRPCPacket *pPacket){
	char cSeqID;

	ROGSCM_SetOrder_Stub(*pPacket, cSeqID);
	
	nCurPlayerID = cSeqID;

	if(nCurPlayerID >= 0)
		wsprintf(g_pRoomWnd->strMessage, _T("%s %s"), Players[nCurPlayerID].strName, strSevenPokerMSG[SMSG_BetOrder]);
	
	InvalidateRect(g_pRoomWnd->m_hWnd, 0, FALSE);
	
}


void cSevenPokerRoom::OnROGSCMRemovePlayer(WPARAM wParam, cRPCPacket *pPacket){
/*	char SeqID;
	*pMsg >> SeqID;

	int i;
	for(i = 0; i < MAX_ROOM_PLAYER_COUNT; i ++){
		Players[i].SetEmptyState();
	}

*/
}

void cSevenPokerRoom::OnROGSCMSetCard(WPARAM wParam, cRPCPacket *pPacket){
	char SeqID;
	char cPos;
	char cCardID;

	ROGSCM_SetCard_Stub(*pPacket, SeqID, cPos, cCardID); 


	Players[SeqID].Cards[cPos].cID = cCardID;
	Players[SeqID].Cards[cPos].Visible = true;

	Players[SeqID].SetPlaying();


///	Sound.CreateFromWaveFile("\\Program Files\\RenoPokerClient\\dealcard.wav", 0, SND_ASYNC | SND_FILENAME);

	Sleep(300);

	
	InvalidateRect(g_pRoomWnd->m_hWnd, 0, FALSE);
	UpdateWindow(g_pRoomWnd->m_hWnd);

}

void cSevenPokerRoom::OnROGSCMChooseFlipCard(WPARAM wParam, cRPCPacket *pPacket){
	nGameState = GS_FlipOneCard;

	lstrcpy(g_pRoomWnd->strMessage, strSevenPokerMSG[SMSG_Flip]);
	InvalidateRect(g_pRoomWnd->m_hWnd, 0, FALSE);

}

void cSevenPokerRoom::OnROGSCMSetChip(WPARAM wParam, cRPCPacket *pPacket){
	char cSeqID;
	int nChip;

	ROGSCM_SetChip_Stub(*pPacket, cSeqID, nChip);
	
	Players[cSeqID].nChip = nChip;

	InvalidateRect(g_pRoomWnd->m_hWnd, 0, FALSE);
	
}

void cSevenPokerRoom::OnROGSCMSetBetChip(WPARAM wParam, cRPCPacket *pPacket){
	int nChip;

	ROGSCM_SetBetChip_Stub(*pPacket, nChip);
	
	nBetChip = nChip;

	InvalidateRect(g_pRoomWnd->m_hWnd, 0, FALSE);
	
}

void cSevenPokerRoom::OnROGSCMSetRaiseChip(WPARAM wParam, cRPCPacket *pPacket){
	int nChip;

	ROGSCM_SetBetChip_Stub(*pPacket, nChip);

	nRaiseChip = nChip;

	InvalidateRect(g_pRoomWnd->m_hWnd, 0, FALSE);
	
}

void cSevenPokerRoom::OnROGSCMSetWinner(WPARAM wParam, cRPCPacket *pPacket){
	char cWinnerSeqID;
	char cID;
	ePokerBook PokerBook;

	g_pRoomWnd->DisableAllBtns();
	g_pRoomWnd->EnableBtn(BTN_Exit);///

	ROGSCM_SetWinner_Stub(*pPacket, cWinnerSeqID, PokerBook);

	int i;
	for(i = 0; i < 7; i ++){
		ROGSCM_CardIDInfo_Stub(*pPacket, cID);
		Players[cWinnerSeqID].Cards[i].cID = cID;
	}

	nWinnerID = cWinnerSeqID;

	wsprintf(g_pRoomWnd->strMessage, _T("%s"), strSevenPokerMSG[SMSG_CheckLevel]);


	InvalidateRect(g_pRoomWnd->m_hWnd, 0, FALSE);


}

void cSevenPokerRoom::OnROGSCMSetPokerBook(WPARAM wParam, cRPCPacket *pPacket){
	char cSeqID;
	ePokerBook Book;
	char cLev;
	cCard Card[7];//  Լ ROGSCM_SetPokerBook_Stub() Card[6] ϱ  
					//⿡ Card[3] ƴ Card[7]  Ѵ.

	ROGSCM_SetPokerBook_Stub(*pPacket, cSeqID, Book, cLev, Card);

	
	Players[cSeqID].PokerBook = Book;
	Players[cSeqID].PokerBookLevel = cLev;

	Players[cSeqID].Cards[0] = Card[0];
	Players[cSeqID].Cards[1] = Card[1];
	Players[cSeqID].Cards[6] = Card[6];
	Players[cSeqID].Cards[0].Visible = true;
	Players[cSeqID].Cards[1].Visible = true;
	Players[cSeqID].Cards[6].Visible = true;

	InvalidateRect(g_pRoomWnd->m_hWnd, 0, FALSE);
	
}


void cSevenPokerRoom::OnROGSCMSayCheck(WPARAM wParam, cRPCPacket *pPacket){
	char cSeqID;

	ROGSCM_SayCheck_Stub(*pPacket, cSeqID); 

	Players[cSeqID].PrevBetType = EBT_Check;

	wsprintf(g_pRoomWnd->strMessage, _T("%s %s"), Players[cSeqID].strName, strSevenPokerMSG[SMSG_Check]);
	
	InvalidateRect(g_pRoomWnd->m_hWnd, 0, FALSE);
}

void cSevenPokerRoom::OnROGSCMSayCall(WPARAM wParam, cRPCPacket *pPacket){
	char cSeqID;

	ROGSCM_SayCall_Stub(*pPacket, cSeqID); 

	Players[cSeqID].PrevBetType = EBT_Call;

	wsprintf(g_pRoomWnd->strMessage, _T("%s %s"), Players[cSeqID].strName, strSevenPokerMSG[SMSG_Call]);
	
	InvalidateRect(g_pRoomWnd->m_hWnd, 0, FALSE);
}

void cSevenPokerRoom::OnROGSCMSayGood(WPARAM wParam, cRPCPacket *pPacket){
	char cSeqID;

	ROGSCM_SayGood_Stub(*pPacket, cSeqID); 

	Players[cSeqID].PrevBetType = EBT_Good;

	wsprintf(g_pRoomWnd->strMessage, _T("%s %s"), Players[cSeqID].strName, strSevenPokerMSG[SMSG_Good]);
	
	InvalidateRect(g_pRoomWnd->m_hWnd, 0, FALSE);
}

void cSevenPokerRoom::OnROGSCMSayDie(WPARAM wParam, cRPCPacket *pPacket) {
	char cSeqID;

	ROGSCM_SayDie_Stub(*pPacket, cSeqID); 

	Players[cSeqID].PrevBetType = EBT_Die;

	wsprintf(g_pRoomWnd->strMessage, _T("%s %s"), Players[cSeqID].strName, strSevenPokerMSG[SMSG_Die]);
	
	InvalidateRect(g_pRoomWnd->m_hWnd, 0, FALSE);
}

void cSevenPokerRoom::OnROGSCMSayBet(WPARAM wParam, cRPCPacket *pPacket) {
	char cSeqID;

	ROGSCM_SayBet_Stub(*pPacket, cSeqID); 

	Players[cSeqID].PrevBetType = EBT_Bet;

	int nTmpMoney = nRaiseChip - nPrevRaiseChip;
	if(nTmpMoney < 0)
		nTmpMoney = 0;

	wsprintf(g_pRoomWnd->strMessage, _T("%s %d%s"), Players[cSeqID].strName, nTmpMoney, strSevenPokerMSG[SMSG_Bet]);
	
	InvalidateRect(g_pRoomWnd->m_hWnd, 0, FALSE);
}
